
/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"
#include <signal.h>

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "spells.h"
#include "house.h"
#include "olc.h"
#include "chatlink.h"
#include "dg_scripts.h"
#include "map.h"

/*   external vars  */
extern char *coin_stringv(int amount);
extern int total_bytes_written;
extern FILE *player_fl;
extern struct str_app_type str_app[];
extern struct room_data *world;
extern struct char_data *character_list;
extern struct char_data *mob_proto;
extern struct obj_data *object_list;
extern struct descriptor_data *descriptor_list;
extern struct index_data *mob_index;
extern struct index_data *obj_index;
extern struct int_app_type int_app[];
extern struct wis_app_type wis_app[];
extern struct zone_data *zone_table;
extern struct time_info_data time_info;
extern int top_of_zone_table;
extern int top_of_loaded_mobs_table;
extern int restricted;
extern int top_of_world;
extern int top_of_mobt;
extern int top_of_objt;
extern int top_of_p_table;
extern long top_of_grid_count;
extern long boot_time;
extern struct char_data *mob_proto;
extern char *NOT_OK;

/* for objects */
extern char *item_types[];
extern char *wear_bits[];
extern char *extra_bits[];
extern char *extra2_bits[];
extern char *anti_bits[];
extern char *container_bits[];
extern char *drinks[];
extern char *weapons_types[];
extern char *coin_abbrev[];
extern char *kingdom_list[];
extern struct obj_data *obj_proto;

/* for rooms */
extern char *dirs[];
extern char *room_bits[];
extern char *door_flags[];
extern char *sector_types[];
extern int rev_dir[];

/* for chars */
extern char *spells[];
extern char *equipment_types[];
extern char *affected_bits[];
extern char *affected2_bits[];
extern char *affected3_bits[];
extern char *affected4_bits[];
extern char *apply_types[];
extern char *class_types[];
extern char *class_abbrevs[];
extern char *race_types[];
extern char *action_bits[];
extern char *player_bits[];
extern char *preference_bits[];
extern char *position_types[];
extern char *status_types[];
extern char *connected_types[];
extern char *alignment_types[];
extern int thaco[NUM_CLASSES][LVL_IMPL + 1];
extern char *size_types[];
extern char *specialist_list[];
extern char *school_list[];
extern char *sphere_list[];
extern struct deity_data deity_list[];

/* extern functions */
extern int level_exp(int class, int level);
extern void deleteChar(struct char_data *ch);
extern void show_mreport(struct char_data *ch);
extern struct time_info_data real_time_passed(time_t t2, time_t t1);
extern void copy_mobile(struct char_data *tmob, struct char_data *fmob);
extern void Crash_rentsave(struct char_data *ch, int cost);
extern int mother_desc, port;
extern FILE *player_fl;
extern void aedit_save_to_disk(int zone);
extern void hedit_save_to_disk(int zone);
extern void redit_save_to_disk(int zone);
extern void medit_save_to_disk(int zone);
extern void oedit_save_to_disk(int zone);
extern void zedit_save_to_disk(int zone);
extern void assign_random_treasure(struct char_data *mob);
extern void list_all_shops(struct char_data *ch);
extern int _parse_name(char *arg, char *name);
extern int reserved_word(char *argument);
extern int Valid_Name(char *newname);
extern void display_mob_spells(struct char_data *target, struct char_data *ch);

ACMD(do_pshow);
void print_zone_to_buf(char *bufptr, int zone, int exit_info);


#define EXE_FILE "bin/greyhawk"	/* maybe use argv[0] but it's not reliable */

ACMD(do_god)
{
  int i;
  extern void check_autowiz(struct char_data *ch);
  skip_spaces(&argument);

  if (isname("Tasfalen", (GET_NAME(ch))) ||
      isname("Fafhrd", (GET_NAME(ch))) ||
      isname("Melkivar", (GET_NAME(ch))) ||
      isname("Corellon", (GET_NAME(ch))) ||
      isname("Boccob", (GET_NAME(ch)))) {

    gain_exp_regardless(ch, level_exp(GET_CLASS(ch), LVL_IMPL) - GET_EXP(ch));
    GET_LEVEL(ch) = LVL_IMPL;

    ch->real_abils.str_add = 0;
    ch->real_abils.str = 25;
    ch->real_abils.dex = 25;
    ch->real_abils.con = 25;
    ch->real_abils.wis = 25;
    ch->real_abils.intel = 25;
    ch->real_abils.cha = 25;
    ch->aff_abils = ch->real_abils;

    for (i = 0; i < LAST_TALK; i++)
      GET_TALK(ch, i) = 100;

    send_to_char("Ok you're a God now!\r\n", ch);
    check_autowiz(ch);
    save_char(ch, NOWHERE);
  } else if (isname("Iuz", (GET_NAME(ch))) ||
	     isname("Pyremius", (GET_NAME(ch))) ||
	     isname("Rand", (GET_NAME(ch))) ||
	     isname("Hanali", (GET_NAME(ch)))) {

    gain_exp_regardless(ch, level_exp(GET_CLASS(ch), LVL_GRGOD) - GET_EXP(ch));
    GET_LEVEL(ch) = LVL_GRGOD;

    send_to_char("Ok you're a God now!\r\n", ch);
    check_autowiz(ch);
    save_char(ch, NOWHERE);
  } else if (isname("Istus", (GET_NAME(ch))) ||
	     isname("Tastone", (GET_NAME(ch)))) {

    gain_exp_regardless(ch, level_exp(GET_CLASS(ch), LVL_GOD7) - GET_EXP(ch));
    GET_LEVEL(ch) = LVL_GOD7;

    send_to_char("Ok, you're a god now!\r\n", ch);
    check_autowiz(ch);
    save_char(ch, NOWHERE);
  } else if (isname("Kanthas", (GET_NAME(ch)))) {

    gain_exp_regardless(ch, level_exp(GET_CLASS(ch), LVL_GOD5) - GET_EXP(ch));
    GET_LEVEL(ch) = LVL_GOD5;

    send_to_char("Ok, you're a god now!\r\n", ch);
    check_autowiz(ch);
    save_char(ch, NOWHERE);
  } else
    send_to_char(NOT_OK, ch);
}


ACMD(do_echo)
{
  skip_spaces(&argument);

  if (!*argument)
    send_to_char("Yes.. but what?\r\n", ch);
  else {
    if (subcmd == SCMD_EMOTE)
      if (IS_PC(ch) && GET_LEVEL(ch) < LVL_IMMORT) {
	send_to_char(NOT_OK, ch);
	return;
      } else
	sprintf(buf, "$n %s", argument);
    else {
      strcpy(buf, argument);
    }

    act(buf, FALSE, ch, 0, 0, TO_PROXIMITY);
    if (PRF_FLAGGED(ch, PRF_NOREPEAT))
      send_to_char(OK, ch);
    else {
      act(buf, FALSE, ch, 0, 0, TO_CHAR);
    }

#ifdef ELIZA
    if (subcmd == SCMD_EMOTE)
/* do chatperformtoroom after all text of the person 
 * is printed... else the mobs will reply before
 * the thing is said */
      chatperformtoroom(ch, argument);
#endif
  }
}


ACMD(do_send)
{
  struct char_data *vict;

  half_chop(argument, arg, buf);

  if (!*arg) {
    send_to_char("Send what to who?\r\n", ch);
    return;
  }
  if (!(vict = get_char_vis(ch, arg))) {
    send_to_char(NOPERSON, ch);
    return;
  }
  send_to_char(buf, vict);
  send_to_char("\r\n", vict);
  if (PRF_FLAGGED(ch, PRF_NOREPEAT))
    send_to_char("Sent.\r\n", ch);
  else {
    sprintf(buf2, "You send '%s' to %s.\r\n", buf, GET_NAME(vict));
    send_to_char(buf2, ch);
  }
}



/* take a string, and return an rnum.. used for goto, at, etc. */
room_rnum
find_target_room(struct char_data *ch, char *rawroomstr, byte change_cord)
{
  int tmp, x, y, z, j, k;
  int location;
  struct char_data *target_mob = NULL;
  struct obj_data *target_obj = NULL;
  char roomstr[MAX_INPUT_LENGTH];

  one_argument(rawroomstr, roomstr);
  x = GET_X_CORD(ch);
  y = GET_Y_CORD(ch);
  z = GET_Z_CORD(ch);

  if (!*roomstr) {
    send_to_char("You must supply a room number or name.\r\n", ch);
    return NOWHERE;
  }
  if (isdigit(*roomstr) && !strchr(roomstr, '.')) {
    tmp = atoi(roomstr);
    if ((location = real_room(tmp)) < 0) {
      send_to_char("No room exists with that number.\r\n", ch);
      return NOWHERE;
    }
  } else if ((target_mob = get_char_vis(ch, roomstr))) {
    location = target_mob->in_room;
    x = GET_X_CORD(target_mob);
    y = GET_Y_CORD(target_mob);
    z = GET_Z_CORD(target_mob);
  } else if ((target_obj = get_obj_vis(ch, roomstr))) {
    if (target_obj->in_room != NOWHERE)
      location = target_obj->in_room;
    else {
      send_to_char("That object is not available.\r\n", ch);
      return NOWHERE;
    }
  } else {
    send_to_char("No such creature or object around.\r\n", ch);
    return NOWHERE;
  }

  /* a location has been found -- if you're < GRGOD, check restrictedions. */
  if (GET_LEVEL(ch) < LVL_IMPL) {
    if (ROOM_FLAGGED(location, ROOM_GODROOM)) {
      send_to_char("You are not ranked high enough to use that room!\r\n", ch);
      return NOWHERE;
    }
    if (ROOM_FLAGGED(location, ROOM_PRIVATE) &&
	world[location].people && world[location].people->next_in_room) {
      send_to_char("There's a private conversation going on in that room.\r\n", ch);
      return NOWHERE;
    }
    if (ROOM_FLAGGED(location, ROOM_HOUSE) &&
	!House_can_enter(ch, world[location].number)) {
      send_to_char("That's private property -- no trespassing!\r\n", ch);
      return NOWHERE;
    }
  }
  if (change_cord) {
    if (world[location].map && !(target_mob || target_obj))
      for (j = 0; j < world[location].x_size; j++)
	for (k = 0; k < world[location].y_size; k++)
	  if (world[location].map->map_grid[j][k] != MAP_NOTBLANK &&
	      world[location].map->map_grid[j][k] != MAP_WALL &&
	      world[location].map->map_grid[j][k] != MAP_BLANK) {
	    x = j;
	    y = k;
	  }
    GET_X_CORD(ch) = x;
    GET_Y_CORD(ch) = y;
    GET_Z_CORD(ch) = z;
  }
  return location;
}



ACMD(do_at)
{
  char command[MAX_INPUT_LENGTH];
  int location, original_loc;

  half_chop(argument, buf, command);
  if (!*buf) {
    send_to_char("You must supply a room number or a name.\r\n", ch);
    return;
  }
  if (!*command) {
    send_to_char("What do you want to do there?\r\n", ch);
    return;
  }
  if ((location = find_target_room(ch, buf, FALSE)) < 0)
    return;

  /* a location has been found. */
  original_loc = ch->in_room;
  char_from_room(ch);
  char_to_room(ch, location, -2);	/* -2 wont alter xyz */
  command_interpreter(ch, command);

  /* check if the char is still there */
  if (ch->in_room == location) {
    char_from_room(ch);
    char_to_room(ch, original_loc, -2);		/* -2 wont alter xyz */
  }
}


ACMD(do_goto)
{
  int location, x, y, z;

  /* save current */
  x = GET_X_CORD(ch);
  y = GET_Y_CORD(ch);
  z = GET_Z_CORD(ch);

  /* This might change x, y */
  if ((location = find_target_room(ch, argument, TRUE)) < 0)
    return;

  if (POOFOUT(ch))
    sprintf(buf, "$n %s", POOFOUT(ch));
  else
    strcpy(buf, "$n disappears in a puff of smoke.");

  act(buf, TRUE, ch, 0, 0, TO_PROXIMITY3);
  char_from_room(ch);
  /* If we changed, place in new spot */
  if (x != GET_X_CORD(ch) || y != GET_Y_CORD(ch) || z != GET_Z_CORD(ch)) {
    send_to_char("poof\r\n", ch);
    put_char_to_room(ch, location, -1, GET_X_CORD(ch), GET_Y_CORD(ch), GET_Z_CORD(ch));
  }
  /* otherwise, normal randomize */
  else
    char_to_room(ch, location, -1);

  if (POOFIN(ch))
    sprintf(buf, "$n %s", POOFIN(ch));
  else
    strcpy(buf, "$n appears with an ear-splitting bang.");

  act(buf, TRUE, ch, 0, 0, TO_PROXIMITY3);
  look_at_room(ch, 0);
}



ACMD(do_trans)
{
  struct descriptor_data *i;
  struct char_data *victim;

  one_argument(argument, buf);
  if (!*buf)
    send_to_char("Whom do you wish to transfer?\r\n", ch);
  else if (str_cmp("all", buf)) {
    if (!(victim = get_char_vis(ch, buf)))
      send_to_char(NOPERSON, ch);
    else if (victim == ch)
      send_to_char("That doesn't make much sense, does it?\r\n", ch);
    else {
      if ((GET_LEVEL(ch) < GET_LEVEL(victim)) && !IS_NPC(victim)) {
	send_to_char("Go transfer someone your own size.\r\n", ch);
	return;
      }
      act("$n disappears in a mushroom cloud.", FALSE, victim, 0, 0, TO_PROXIMITY2);
      char_from_room(victim);
      put_char_to_room(victim, ch->in_room, -1, GET_X_CORD(ch), GET_Y_CORD(ch), GET_Z_CORD(ch));
      act("$n arrives from a puff of smoke.", FALSE, victim, 0, 0, TO_PROXIMITY);
      act("$n has transferred you!", FALSE, ch, 0, victim, TO_VICT);
      look_at_room(victim, 0);
    }
  } else {			/* Trans All */
    if (GET_LEVEL(ch) < LVL_GRGOD) {
      send_to_char("I think not.\r\n", ch);
      return;
    }
    for (i = descriptor_list; i; i = i->next)
      if (!i->connected && i->character && i->character != ch) {
	victim = i->character;
	if (GET_LEVEL(victim) >= GET_LEVEL(ch))
	  continue;
	act("$n disappears in a mushroom cloud.", FALSE, victim, 0, 0, TO_PROXIMITY3);
	char_from_room(victim);
	char_to_room(victim, ch->in_room, -1);
	act("$n arrives from a puff of smoke.", FALSE, victim, 0, 0, TO_PROXIMITY2);
	act("$n has transferred you!", FALSE, ch, 0, victim, TO_VICT);
	look_at_room(victim, 0);
      }
    send_to_char(OK, ch);
  }
}



ACMD(do_teleport)
{
  struct char_data *victim;
  int target;

  two_arguments(argument, buf, buf2);

  if (!*buf)
    send_to_char("Whom do you wish to teleport?\r\n", ch);
  else if (!(victim = get_char_vis(ch, buf)))
    send_to_char(NOPERSON, ch);
  else if (victim == ch)
    send_to_char("Use 'goto' to teleport yourself.\r\n", ch);
  else if (GET_LEVEL(victim) >= GET_LEVEL(ch))
    send_to_char("Maybe you shouldn't do that.\r\n", ch);
  else if (!*buf2)
    send_to_char("Where do you wish to send this person?\r\n", ch);
  else if ((target = find_target_room(ch, buf2, FALSE)) >= 0) {
    send_to_char(OK, ch);
    act("$n disappears in a puff of smoke.", FALSE, victim, 0, 0, TO_PROXIMITY3);
    char_from_room(victim);
    char_to_room(victim, target, -1);
    act("$n arrives from a puff of smoke.", FALSE, victim, 0, 0, TO_PROXIMITY2);
    act("$n has teleported you!", FALSE, ch, 0, (char *) victim, TO_VICT);
    look_at_room(victim, 0);
  }
}



ACMD(do_lookup)
{

  any_two_arg(argument, buf, buf2);

  if (!*buf) {
    send_to_char("Usage: lookup [obj&+L|&nmob&+L|&nwld] <pattern>\r\n", ch);
    return;
  }
  if (is_abbrev(buf, "mob")) {
    if (!vnum_mobile(buf2, ch))
      send_to_char("No mobiles by that name.\r\n", ch);
    return;
  }
  if (is_abbrev(buf, "obj")) {
    if (!vnum_object(buf2, ch))
      send_to_char("No objects by that name.\r\n", ch);
    return;
  }
  if (is_abbrev(buf, "wld")) {
    if (!vnum_room(buf2, ch)) {
      send_to_char("No rooms with that name.\r\n", ch);
    }
    return;
  }
  if (is_abbrev(buf, "room")) {
    if (!vnum_room(buf2, ch)) {
      send_to_char("No rooms with that name.\r\n", ch);
    }
    return;
  }
  /* default */
  if (!*buf2) {
    vnum_mobile(argument, ch);
    vnum_object(argument, ch);
    vnum_room(argument, ch);
    return;
  }
}



void do_stat_room(struct char_data *ch)
{
  struct extra_descr_data *desc;
  struct room_data *rm = &world[ch->in_room];
  int i, found = 0;
  struct obj_data *j = 0;
  struct char_data *k = 0;

  sprintf(buf, "&+Y-=-=-=-=-= ROOM STAT =-=-=-=-=-\r\n");
  send_to_char(buf, ch);

  sprintf(buf, "&+YRoom name:&n %s\r\n", rm->name);
  send_to_char(buf, ch);

  sprinttype(rm->sector_type, sector_types, buf2);
  sprintf(buf, "&+YZone:&n [%3d], &+YVNum:&n [%5d], &+YRNum:&n [%5d], &+YType:&n %s\r\n",
	  zone_table[rm->zone].number, rm->number, ch->in_room, buf2);
  send_to_char(buf, ch);

  if (!WILDERNESS(ch->in_room)) {
    sprintf(buf, "&+YHeigth:&n %d'(%d) &+YWidth:&n %d(%d)' &+YLength:&n %d(%d)'\r\n",
	    GET_Z_SIZE(ch->in_room) * 3, GET_Z_SIZE(ch->in_room),
	    GET_Y_SIZE(ch->in_room) * 3, GET_Y_SIZE(ch->in_room),
	    GET_X_SIZE(ch->in_room) * 3, GET_X_SIZE(ch->in_room));
    send_to_char(buf, ch);
  }
  sprintf(buf, "&+YShape:&n%d  &+YTotal Light:&n%d &+Y(torches:&n%d&+Y/ambient:&n%d&+Y)&n\r\n", rm->shape,
	  rm->light + zone_table[rm->zone].conditions.ambient_light, rm->light, zone_table[rm->zone].conditions.ambient_light);
  send_to_char(buf, ch);

  sprintbit((ulong) rm->room_flags, room_bits, buf2);
  sprintf(buf, "&+YSpecProc:&n %s, &+YFlags:&n %s\r\n",
	  (rm->func == NULL) ? "&+rNone&n" : "&+gExists&n", buf2);
  send_to_char(buf, ch);

  if (IS_WATER_ROOM(ch->in_room)) {
    sprintf(buf, "&+YCurrent Direction:&n %s &+YCurrent Speed:&n %d\r\n",
	    dirs[rm->current_direction], rm->current_speed);
    send_to_char(buf, ch);
  }
  send_to_char("&+YDescription:&n\r\n", ch);
  if (rm->description)
    send_to_char(rm->description, ch);
  else
    send_to_char("  None.\r\n", ch);

  if (rm->ex_description) {
    sprintf(buf, "&+YExtra descs:&n");
    for (desc = rm->ex_description; desc; desc = desc->next) {
      strcat(buf, " ");
      strcat(buf, desc->keyword);
    }
    send_to_char(strcat(buf, "\r\n"), ch);
  }
  *buf = '\0';
  sprintf(buf, "&+YChars present:&n");
  for (found = 0, k = rm->people; k; k = k->next_in_room) {
    if (!CAN_SEE(ch, k))
      continue;
    sprintf(buf2, "%s %s(%s)", found++ ? "," : "", GET_NAME(k),
	    (!IS_NPC(k) ? "PC" : (!IS_MOB(k) ? "NPC" : "MOB")));
    strcat(buf, buf2);
    if (strlen(buf) >= 62) {
      if (k->next_in_room)
	send_to_char(strcat(buf, ",\r\n"), ch);
      else
	send_to_char(strcat(buf, "\r\n"), ch);
      *buf = found = 0;
    }
  }

  if (*buf)
    send_to_char(strcat(buf, "\r\n"), ch);

  *buf = '\0';
  if (rm->contents) {
    strcat(buf, "&+YContents:&n");
    for (found = 0, j = rm->contents; j; j = j->next_content) {
      if (!CAN_SEE_OBJ(ch, j))
	continue;
      sprintf(buf2, "%s %s", found++ ? "," : "", j->short_description);
      strcat(buf, buf2);
      if (strlen(buf) >= 62) {
	if (j->next_content)
	  send_to_char(strcat(buf, ",\r\n"), ch);
	else
	  send_to_char(strcat(buf, "\r\n"), ch);
	*buf = found = 0;
      }
    }

    if (*buf)
      send_to_char(strcat(buf, "\r\n"), ch);
  }
  for (i = 0; i < NUM_OF_DIRS; i++) {
    if (rm->dir_option[i]) {
      if (rm->dir_option[i]->to_room == NOWHERE)
	sprintf(buf1, " NONE");
      else
	sprintf(buf1, "%5d", world[rm->dir_option[i]->to_room].number);
      sprintbit(rm->dir_option[i]->exit_info, door_flags, buf2);
      sprintf(buf, "&+YExit&n %-5s:  &+YTo:&n [%s], &+YHP:&n [%3d], &+YKey:&n [%5d], &+YKeyword:&n %s, &+YType:&n %s\r\n ",
      dirs[i], buf1, rm->dir_option[i]->hitpoints, rm->dir_option[i]->key,
	rm->dir_option[i]->keyword ? rm->dir_option[i]->keyword : "None",
	      buf2);
      send_to_char(buf, ch);
      if (rm->dir_option[i]->general_description) {
	strcpy(buf, rm->dir_option[i]->general_description);
	send_to_char(buf, ch);
      }
    }
  }

  /* check the room for a script */
  do_sstat_room(ch);

}



void do_stat_object(struct char_data *ch, struct obj_data *j)
{
  int i, virtual, found, doses = 1;
  struct obj_data *j2;
  struct extra_descr_data *desc;
  struct char_data *jch;
  extern char *helmet_types[];
  extern char *shield_types[];
  extern char *armor_types[];
  extern char *body_types[];
  extern char *limb_types[];
  extern char *extremity_types[];

  sprintf(buf, "&+Y-=-=-=-=-= OBJECT STAT =-=-=-=-=-\r\n");
  send_to_char(buf, ch);

  virtual = GET_OBJ_VNUM(j);
  sprintf(buf, "&+YName:&N '%s', &+YAliases&N: %s\r\n",
    ((j->short_description) ? j->short_description : "<None>"), j->name);
  send_to_char(buf, ch);
  sprinttype(GET_OBJ_TYPE(j), item_types, buf1);
  if (GET_OBJ_RNUM(j) >= 0)
    strcpy(buf2, (obj_index[GET_OBJ_RNUM(j)].func ? "Exists" : "None"));
  else
    strcpy(buf2, "None");
  sprintf(buf, "&+YVNum:&N [%5d], &+YRNum:&N [%5d], &+YCopyOf:&n [%5d], &+YType:&N %s, &+YSpecProc:&N %s\r\n",
	  virtual, GET_OBJ_RNUM(j), GET_OBJ_ORIG_VNUM(j), buf1, buf2);
  send_to_char(buf, ch);
  sprintf(buf, "&+YL-Des:&N %s\r\n", ((j->description) ? j->description : "None"));
  send_to_char(buf, ch);

  if (j->ex_description) {
    sprintf(buf, "&+YExtra descs:&N");
    for (desc = j->ex_description; desc; desc = desc->next) {
      strcat(buf, " ");
      if ((desc->keyword[0] == 3) && (desc->keyword[1] == 1) &&
	  (desc->keyword[2] == 3))
	strcat(buf, "spells");
      else
	strcat(buf, desc->keyword);
    }
    send_to_char(strcat(buf, "\r\n"), ch);
  }
  send_to_char("&+YCan be worn on:&N ", ch);
  sprintbit(j->obj_flags.wear_flags, wear_bits, buf);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);

  send_to_char("&+YSet char bits :&N\r\n", ch);
  sprintbit(j->obj_flags.bitvector, affected_bits, buf);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);
  sprintbit(j->obj_flags.bitvector2, affected2_bits, buf);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);
  sprintbit(j->obj_flags.bitvector3, affected3_bits, buf);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);
  sprintbit(j->obj_flags.bitvector4, affected4_bits, buf);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);

  send_to_char("&+YExtra flags   :&N ", ch);
  sprintbit(GET_OBJ_EXTRA(j), extra_bits, buf);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);

  send_to_char("&+YExtra2 flags  :&N ", ch);
  sprintbit(GET_OBJ_EXTRA2(j), extra2_bits, buf);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);

  send_to_char("&+YAnti flags    :&N ", ch);
  sprintbit(GET_OBJ_ANTI(j), anti_bits, buf);
  strcat(buf, "\r\n");
  send_to_char(buf, ch);

  sprintf(buf, "&+YCondition:&N %d  &+YStatus:&N %d  &+YMaterial:&N %d  &+YCrafts:&N %d\r\n",
	  GET_OBJ_CONDITION(j), GET_OBJ_STATUS(j), GET_OBJ_MATERIAL(j), GET_OBJ_CRAFTSMANSHIP(j));
  send_to_char(buf, ch);

  sprintf(buf, "&+YWeight:&N %7.2f   &+YCopyOfVnum:&N %d  &+YTimer:&N %d\r\n&+YValue:&N %s\r\n",
	  GET_OBJ_WEIGHT(j), GET_OBJ_ORIG_VNUM(j), GET_OBJ_TIMER(j), coin_stringv(GET_OBJ_COST(j)));
  send_to_char(buf, ch);

  sprintf(buf, "&+YSize:&N %d  &+YSpace:&N %d  &+YRace:&N %d\r\n",
	  GET_OBJ_SIZE(j), GET_OBJ_SPACE(j), GET_OBJ_RACE(j));
  send_to_char(buf, ch);

  sprintf(buf, "&+YValues 0-7:&N [%d] [%d] [%d] [%d] [%d] [%d] [%d] [%d]\r\n",
	  GET_OBJ_VAL(j, 0), GET_OBJ_VAL(j, 1),
	  GET_OBJ_VAL(j, 2), GET_OBJ_VAL(j, 3),
	  GET_OBJ_VAL(j, 4), GET_OBJ_VAL(j, 5),
	  GET_OBJ_VAL(j, 6), GET_OBJ_VAL(j, 7));
  send_to_char(buf, ch);

  strcpy(buf, "&+YIn room:&N ");
  if (j->in_room == NOWHERE)
    strcat(buf, "Nowhere");
  else {
    sprintf(buf2, "%d", world[j->in_room].number);
    strcat(buf, buf2);
  }
  strcat(buf, ", &+YIn object:&N ");
  strcat(buf, j->in_obj ? j->in_obj->short_description : "None");
  strcat(buf, ", &+YCarried by:&N ");
  strcat(buf, j->carried_by ? GET_NAME(j->carried_by) : "Nobody");
  strcat(buf, ", &+YWorn by:&N ");
  strcat(buf, j->worn_by ? GET_NAME(j->worn_by) : "Nobody");
  strcat(buf, "\r\n");
  send_to_char(buf, ch);

  sprintf(buf, "&+YX-Cord:&N %d  &+YY-Cord:&N %d  &+YZ-Cord:&N %d\r\n",
	  j->obj_flags.x_cord, j->obj_flags.y_cord, j->obj_flags.z_cord);
  send_to_char(buf, ch);

  switch (GET_OBJ_TYPE(j)) {
  case ITEM_LIGHT:
    if (GET_OBJ_VAL(j, 2) == -1)
      strcpy(buf, "Hours left: Infinite");
    else
      sprintf(buf, "Hours left: [%d]", GET_OBJ_VAL(j, 2));
    break;
  case ITEM_SCROLL:
    sprintf(buf, "&+YSpells:&n (Level %d) %s", GET_OBJ_VAL(j, 0), spell_name(GET_OBJ_VAL(j, 1)));
    if (GET_OBJ_VAL(j, 2))
      sprintf(buf, "%s, %s", buf, spell_name(GET_OBJ_VAL(j, 2)));
    if (GET_OBJ_VAL(j, 3))
      sprintf(buf, "%s, %s", buf, spell_name(GET_OBJ_VAL(j, 3)));
    if (GET_OBJ_VAL(j, 4))
      sprintf(buf, "%s, %s", buf, spell_name(GET_OBJ_VAL(j, 4)));
    if (GET_OBJ_VAL(j, 5))
      sprintf(buf, "%s, %s", buf, spell_name(GET_OBJ_VAL(j, 5)));
    if (GET_OBJ_VAL(j, 6))
      sprintf(buf, "%s, %s", buf, spell_name(GET_OBJ_VAL(j, 6)));
    if (GET_OBJ_VAL(j, 7))
      sprintf(buf, "%s, %s", buf, spell_name(GET_OBJ_VAL(j, 7)));
    break;
  case ITEM_POTION:
    if (GET_OBJ_VAL(j, 2))
      doses++;
    if (GET_OBJ_VAL(j, 3))
      doses++;
    if (GET_OBJ_VAL(j, 4))
      doses++;
    if (GET_OBJ_VAL(j, 5))
      doses++;
    if (GET_OBJ_VAL(j, 6))
      doses++;
    if (GET_OBJ_VAL(j, 7))
      doses++;
    sprintf(buf, "&+YSpells:&n (Level %d) (Doses %d) %s", GET_OBJ_VAL(j, 0), doses,
	    spell_name(GET_OBJ_VAL(j, 1)));
    break;
  case ITEM_WAND:
  case ITEM_STAFF:
    sprintf(buf, "Spell: %s at level %d, %d (of %d) charges remaining",
	    spell_name(GET_OBJ_VAL(j, 3)), GET_OBJ_VAL(j, 0),
	    GET_OBJ_VAL(j, 2), GET_OBJ_VAL(j, 1));
    break;
  case ITEM_WEAPON:
    sprintf(buf, "Dam (SM): %dd%d, Dam (L): %dd%d, Speed:%d, Message type: %d, Weapon type: %s",
	    GET_OBJ_VAL(j, 1), GET_OBJ_VAL(j, 2),
	    GET_OBJ_VAL(j, 4), GET_OBJ_VAL(j, 5),
	    GET_OBJ_VAL(j, 6), GET_OBJ_VAL(j, 3), weapons_types[GET_OBJ_VAL(j, 7)]);
    break;
  case ITEM_ARMOR:
    if (CAN_WEAR(j, ITEM_WEAR_BODY)) {
      if (IS_SET(GET_OBJ_EXTRA(j), ITEM_WHOLE_BODY))
	sprintf(buf, "Armor Style: [%s]", armor_types[GET_OBJ_VAL(j, 0)]);
      else
	sprintf(buf, "Armor Style: [%s]", body_types[GET_OBJ_VAL(j, 0)]);
    } else if (CAN_WEAR(j, ITEM_WEAR_ARMS) || CAN_WEAR(j, ITEM_WEAR_LEGS))
      sprintf(buf, "Limb Style: [%s]", limb_types[GET_OBJ_VAL(j, 0)]);
    else if (CAN_WEAR(j, ITEM_WEAR_HEAD))
      sprintf(buf, "Helmet Style: [%s]", helmet_types[GET_OBJ_VAL(j, 0)]);
    else if (CAN_WEAR(j, ITEM_WEAR_FEET) || CAN_WEAR(j, ITEM_WEAR_HANDS))
      sprintf(buf, "Extremity Style: [%s]", extremity_types[GET_OBJ_VAL(j, 0)]);
    break;
  case ITEM_TRAP:
    sprintf(buf, "Spell: %d, - Hitpoints: %d",
	    GET_OBJ_VAL(j, 0), GET_OBJ_VAL(j, 1));
    break;
  case ITEM_CONTAINER:
    sprintbit(GET_OBJ_VAL(j, 1), container_bits, buf2);
    sprintf(buf, "Weight capacity: %d, Lock Type: %s, Key Num: %d, Corpse: %s, Max space:%d",
	    GET_OBJ_VAL(j, 0), buf2, GET_OBJ_VAL(j, 2),
	    YESNO(GET_OBJ_VAL(j, 3)), GET_OBJ_VAL(j, 4));
    break;
  case ITEM_DRINKCON:
    sprinttype(GET_OBJ_VAL(j, 2), drinks, buf2);
    sprintf(buf, "Capacity: %d, Contains: %d, Poisoned: %s, Liquid: %s",
	  GET_OBJ_VAL(j, 0), GET_OBJ_VAL(j, 1), YESNO(GET_OBJ_VAL(j, 3)),
	    buf2);
    break;
  case ITEM_NOTE:
    sprintf(buf, "Tongue: %d", GET_OBJ_VAL(j, 0));
    break;
  case ITEM_KEY:
    sprintf(buf, "Chance to break: %d",
	    GET_OBJ_VAL(j, 0));
    break;
  case ITEM_FOOD:
    sprintf(buf, "Makes full: %d, Poisoned: %s", GET_OBJ_VAL(j, 0),
	    YESNO(GET_OBJ_VAL(j, 3)));
    break;
  case ITEM_MONEY:
    sprintf(buf, "Coins: %d %s %s", GET_OBJ_VAL(j, 0), coin_abbrev[GET_OBJ_VAL(j, 1)], kingdom_list[GET_OBJ_VAL(j, 2)]);
    break;
  case ITEM_BOARD:
    sprintf(buf, "Read: [%d]  Write: [%d]  Remove: [%d]",
	    GET_OBJ_VAL(j, 0), GET_OBJ_VAL(j, 1),
	    GET_OBJ_VAL(j, 2));
    break;
  case ITEM_FIREWEAPON:
    sprintf(buf, "Range: %d, ROF: %d, Missile Type: %d, Speed: %d",
	    GET_OBJ_VAL(j, 0), GET_OBJ_VAL(j, 1),
	    GET_OBJ_VAL(j, 3), GET_OBJ_VAL(j, 6));
    break;
  case ITEM_MISSILE:
    sprintf(buf, "Dam (SM): %dd%d, Dam (L): %dd%d, Missile type: %d",
	    GET_OBJ_VAL(j, 1), GET_OBJ_VAL(j, 2),
	    GET_OBJ_VAL(j, 4), GET_OBJ_VAL(j, 5),
	    GET_OBJ_VAL(j, 3));
    break;
  case ITEM_BOOK:
    sprintf(buf, "# Page: %d",
	    GET_OBJ_VAL(j, 2));
    break;
  case ITEM_TELEPORT:
    sprintf(buf, "Target room: %d, Command: %d, # Charge: %d",
	    GET_OBJ_VAL(j, 0), GET_OBJ_VAL(j, 1),
	    GET_OBJ_VAL(j, 2));
    break;
  case ITEM_QUIVER:
    sprintbit(GET_OBJ_VAL(j, 1), container_bits, buf2);
    sprintf(buf, "Max capacity: %d, Lock Type: %s, Missile type: %d, Current #: %d",
	    GET_OBJ_VAL(j, 0), buf2, GET_OBJ_VAL(j, 2),
	    GET_OBJ_VAL(j, 3));
    break;
  case ITEM_PICK:
    sprintf(buf, "+ chance pick: %d, chance break: %d",
	    GET_OBJ_VAL(j, 0), GET_OBJ_VAL(j, 1));
    break;
  case ITEM_INSTRUMENT:
    sprintf(buf, "Type: %d, Break: %d, Min level: %d",
	    GET_OBJ_VAL(j, 0), GET_OBJ_VAL(j, 1),
	    GET_OBJ_VAL(j, 2));
    break;
  case ITEM_FURNITURE:
    sprintf(buf, "Minimum position: %s, Capacity: %d, ",
	    position_types[(int) GET_OBJ_VAL(j, 0)],
	    GET_OBJ_VAL(j, 1));
    break;
  case ITEM_SHIELD:
    sprintf(buf, "Shield Type: %s", shield_types[GET_OBJ_VAL(j, 0)]);
    break;
  case ITEM_HOLY_SYMBOL:
    sprintf(buf, "Type: %s",
	    GET_OBJ_VAL(j, 0) == 1 ? "Holy symbol" : "Misteltoe");
    break;
  default:
    strcpy(buf, "");
    break;
  }
  send_to_char(strcat(buf, "\r\n"), ch);

  /*
   * I deleted the "equipment status" code from here because it seemed
   * more or less useless and just takes up valuable screen space.
   */

  if (j->contains) {
    sprintf(buf, "\r\n&+YContents:&N");
    for (found = 0, j2 = j->contains; j2; j2 = j2->next_content) {
      sprintf(buf2, "%s %s", found++ ? "," : "", j2->short_description);
      strcat(buf, buf2);
      if (strlen(buf) >= 62) {
	if (j2->next_content)
	  send_to_char(strcat(buf, ",\r\n"), ch);
	else
	  send_to_char(strcat(buf, "\r\n"), ch);
	*buf = found = 0;
      }
    }

    if (*buf)
      send_to_char(strcat(buf, "\r\n"), ch);
  }
  /* List the people using this piece of furniture */
  if (j->people) {
    strcat(buf, "\r\nChars using Object:");
    for (found = 0, jch = j->people; jch; jch = jch->next_in_furniture) {
      if (!CAN_SEE(ch, jch))
	continue;
      sprintf(buf2, "%s %s (%s)", found++ ? "," : "", GET_NAME(jch),
	      (!IS_NPC(jch) ? "PC" : (!IS_MOB(jch) ? "NPC" : "MOB")));
      strcat(buf, buf2);
      if (strlen(buf) >= 62) {
	if (jch->next_in_furniture)
	  send_to_char(strcat(buf, ",\r\n"), ch);
	else
	  send_to_char(strcat(buf, "\r\n"), ch);
	*buf = found = 0;
      }
    }

    if (*buf)
      send_to_char(strcat(buf, "\r\n"), ch);
  }
  found = 0;
  send_to_char("&+YAffections:&N", ch);
  for (i = 0; i < MAX_OBJ_AFFECT; i++)
    if (j->affected[i].modifier) {
      sprinttype(j->affected[i].location, apply_types, buf2);
      sprintf(buf, "%s %+d to %s", found++ ? "," : "",
	      j->affected[i].modifier, buf2);
      send_to_char(buf, ch);
    }
  if (!found)
    send_to_char(" None", ch);

  send_to_char("\r\n", ch);

  /* check the object for a script */
  do_sstat_object(ch, j);

}


void do_stat_character(struct char_data *ch, struct char_data *k)
{
  int i, i2, found = 0;
  char buf3[256];
  struct obj_data *j;
  struct follow_type *fol;
  struct affected_type *aff;
  struct char_file_u chdata;

  sprintf(buf, "&+B-=-=-=-=-= PLAYER STAT =-=-=-=-=-\r\n");
  send_to_char(buf, ch);

  switch (GET_SEX(k)) {
  case SEX_NEUTRAL:
    strcpy(buf, "&+LSexless");
    break;
  case SEX_MALE:
    strcpy(buf, "&+LMale");
    break;
  case SEX_FEMALE:
    strcpy(buf, "&+LFemale");
    break;
  default:
    strcpy(buf, "&=LRILLEGAL-SEX!!");
    break;
  }

  sprintf(buf2, " %s&n '%s'  &+BIDNum: [&n%7ld&+B], In room [&n%5d&+B] X:&n%d &+BY:&n%d &+BZ:&n%d\r\n",
	  (!IS_NPC(k) ? "PC" : (!IS_MOB(k) ? "NPC" : "MOB")),
	  GET_NAME(k), GET_ID(k),
	  k->in_room != NOWHERE ? world[k->in_room].number : NOWHERE,
	  GET_X_CORD(k), GET_Y_CORD(k), GET_Z_CORD(k));
  send_to_char(strcat(buf, buf2), ch);

  if (IS_NPC(k)) {
    sprintf(buf, "&+BCopyOfVnum:&n %d\r\n", k->mob_specials.orig_vnum);
    send_to_char(buf, ch);
  }
  sprintf(buf, "&+BTitle:&n %s\r\n", (k->player.title ? k->player.title : "<None>"));
  send_to_char(buf, ch);

  sprintf(buf, "&+BAppearance:&n %s\r\n", (k->player.short_descr ? k->player.short_descr : "<None>\r\n"));
  send_to_char(buf, ch);

  sprintf(buf, "&+BDescription:&n %s\r\n", (k->player.long_descr ? k->player.long_descr : "<None>\r\n"));
  send_to_char(buf, ch);

  strcpy(buf, "&+BClass:&n ");
  if (GET_CLASS(k) != CLASS_UNDEFINED) {
    sprinttype(k->player.class, class_types, buf2);
    strcat(buf, buf2);
  } else {
    strcat(buf, "None");
  }
  send_to_char(buf, ch);

  if (IS_MAGE_SPECIALIST(k)) {
    sprintf(buf, " &+B(&n%s&+B)", specialist_list[(int) IS_MAGE_SPECIALIST(k) - 1]);
    send_to_char(buf, ch);
  }
  strcpy(buf, "&+B, Race: &n");
  sprinttype(k->player.race, race_types, buf2);
  strcat(buf, buf2);

  sprintf(buf2, "&+B, Size: &n%s\r\n",
	  size_types[(int) GET_SIZE(k)]);
  strcat(buf, buf2);
  send_to_char(buf, ch);

  sprintf(buf, "&+BLev: [&n%2d&+B], XP: [&n%7d&+B], Align: [&n%s &+cge&n%d&+clc&n%d&+B]&n\r\n",
	  GET_LEVEL(k), GET_EXP(k), alignment_types[GET_ALIGNMENT(k)],
	  k->points.align_ge, k->points.align_lc);
  send_to_char(buf, ch);

  strcpy(buf1, (char *) asctime(localtime(&(k->player.time.birth))));
  if (load_char(GET_NAME(k), &chdata) > -1)
    strcpy(buf2, (char *) asctime(localtime(&chdata.last_logon)));
  else
    strcpy(buf2, (char *) asctime(localtime(&(k->player.time.logon))));
  buf1[10] = buf2[10] = '\0';

  sprintf(buf, "&+BCreated: [&n%s&+B], Last Logon: [&n%s&+B], Played [&n%dh %dm&+B], Age [&n%d&+B]&n\r\n",
	  buf1, buf2, k->player.time.played / 3600,
	  ((k->player.time.played / 3600) % 60), age(k).year);
  send_to_char(buf, ch);

  /*. Display OLC zone for immorts . */
  if (GET_LEVEL(k) >= LVL_IMMORT) {
    sprintf(buf, "&+BOLC[&n%d&+B]&n", GET_OLC_ZONE(k));
    strcat(buf, "\r\n");
    send_to_char(buf, ch);
  }
  sprintf(buf, "&+CStr: [&n%d&+C/&n%d&+C]  Int: [&n%d&+C]  Wis: [&n%d&+C]  "
	  "Dex: [&n%d&+C]  Con: [&n%d&+C]  Cha: [&n%d&+C]&n\r\n",
	  GET_STR(k), GET_ADD(k), GET_INT(k), GET_WIS(k),
	  GET_DEX(k), GET_CON(k), GET_CHA(k));
  send_to_char(buf, ch);

  sprintf(buf, "&+BHit p.:[&n%d&+B/&n%d&+B+&n%d&+B]&n\r\n",
	  GET_HIT(k), GET_MAX_HIT(k), hit_gain(k));
  send_to_char(buf, ch);

  sprintf(buf, "&+BAC: [&n%d&+B], THAC0: [&n%3d&+B], Hitroll: [&n%2d&+B], Damroll: [&n%2d&+B]\r\n",
	  GET_AC(k), GET_THAC0(k), k->points.hitroll, k->points.damroll);
  send_to_char(buf, ch);

  sprintf(buf, "&+BSaving throws: [&n%d&+B/&n%d&+B/&n%d&+B/&n%d&+B/&n%d&+B], MR: [&n%3d&+B]\r\n",
	  GET_SAVE(k, 0), GET_SAVE(k, 1), GET_SAVE(k, 2), GET_SAVE(k, 3), GET_SAVE(k, 4),
	  GET_MAGIC_RESISTANCE(k));
  send_to_char(buf, ch);

  if (IS_MAGE(k)) {
    strcpy(buf, "&+BSchool: &n");
    sprintbit(GET_MAGE_SCHOOL(k), school_list, buf2);
    strcat(buf, buf2);
    send_to_char(buf, ch);
    send_to_char("\r\n", ch);
  }
  strcpy(buf, "\r\n&+BWorshiping: &N");
  strcat(buf, deity_list[GET_PRIEST_DEITY(k)].deity_name);
  send_to_char(buf, ch);
  send_to_char("\r\n", ch);

  if (IS_PRIEST(k)) {
    strcpy(buf, "&+BSphere major: &n");
    sprintbit(GET_PRIEST_SPHERE_MAJOR(k), sphere_list, buf2);
    strcat(buf, buf2);
    send_to_char(buf, ch);
    send_to_char("\r\n", ch);

    strcpy(buf, "&+BSphere minor: &n");
    sprintbit(GET_PRIEST_SPHERE_MINOR(k), sphere_list, buf2);
    strcat(buf, buf2);
    send_to_char(buf, ch);
    send_to_char("\r\n", ch);
  }
  sprintf(buf, "&+BNW/W prof. slot: [&n%2d&+B/&n%2d&+B], Thief skill slot: [&n%3d&+B]\r\n",
	  GET_NON_WEAPON_PROF(k),
	  GET_WEAPON_PROF(k),
	  GET_THIEF_SKILL(k));
  send_to_char(buf, ch);

  sprinttype(GET_POS(k), position_types, buf2);
  strcat(buf2, " ");
  sprintbit((GET_STAT(k) * 4), position_types, buf2 + strlen(buf2));
  sprintf(buf, "\r\n&+BPos:&n %s (%d) (%d)\r\n&+BFighting:&n %s, &+BHunting:&n %s",
	  buf2, GET_POS(k), GET_STAT(k),
	  (FIGHTING(k) ? GET_NAME(FIGHTING(k)) : "Nobody"),
	  (HUNTING(k) ? GET_NAME(HUNTING(k)) : "Nobody"));

  if (k->desc) {
    sprinttype(k->desc->connected, connected_types, buf2);
    strcat(buf, "&+B, Connected:&n ");
    strcat(buf, buf2);
  }
  send_to_char(strcat(buf, "\r\n"), ch);

  strcpy(buf, "&+BDefault position:&n ");
  sprinttype((k->mob_specials.default_pos), position_types, buf2);
  strcat(buf, buf2);

  sprintf(buf2, "&+B, Idle Timer (in tics) [&n%d&+B]&n\r\n", k->char_specials.timer);
  strcat(buf, buf2);
  send_to_char(buf, ch);

  sprintbit(PLR_FLAGS(k), player_bits, buf2);
  sprintf(buf, "&+BPLR:&n %s\r\n", buf2);
  send_to_char(buf, ch);
  sprintbit(PRF_FLAGS(k), preference_bits, buf2);
  sprintf(buf, "&+BPRF:&n %s\r\n", buf2);
  send_to_char(buf, ch);

  sprintf(buf, "&+BCarried: weight: &n%d/%d (%d%%), &+Bitems:&n %d; ",
	  IS_CARRYING_W(k), CAN_CARRY_W(k), carried_load_percent(k), IS_CARRYING_N(k));

  for (i = 0, j = k->carrying; j; j = j->next_content, i++);
  sprintf(buf, "%s&+BItems in: inventory:&n %d, ", buf, i);

  for (i = 0, i2 = 0; i < NUM_WEARS; i++)
    if (GET_EQ(k, i))
      i2++;
  sprintf(buf2, "&+Beq:&n %d\r\n", i2);
  strcat(buf, buf2);
  send_to_char(buf, ch);

  sprintf(buf, "&+BHunger:&n %d, &+BThirst:&n %d, &+BDrunk:&n %d\r\n",
	  GET_COND(k, FULL), GET_COND(k, THIRST), GET_COND(k, DRUNK));
  send_to_char(buf, ch);

  sprintf(buf, "&+BMaster is:&n %s, &+BFollowers are:&n",
	  ((k->master) ? GET_NAME(k->master) : "<none>"));

  for (fol = k->followers; fol; fol = fol->next) {
    sprintf(buf2, "%s %s", found++ ? "," : "", PERS(fol->follower, ch, FALSE));
    strcat(buf, buf2);
    if (strlen(buf) >= 62) {
      if (fol->next)
	send_to_char(strcat(buf, ",\r\n"), ch);
      else
	send_to_char(strcat(buf, "\r\n"), ch);
      *buf = found = 0;
    }
  }


  sprintf(buf, "&+BWatching:&n %s\r\n",
	  (k->watching) ? GET_NAME(k->watching->vict) : "<Nobody>");
  send_to_char(buf, ch);

  *buf = 0;
  if (FURNITURE(k)) {
    sprintf(buf, "%s on: %s\r\n",
      position_types[(int) GET_POS(k)], FURNITURE(k)->short_description);
    CAP(buf);
  }
  if (*buf)
    send_to_char(strcat(buf, "\r\n"), ch);

  /* Showing the bitvector */
  sprintbit(AFF_FLAGS(k), affected_bits, buf2);
  sprintbit(AFF2_FLAGS(k), affected2_bits, buf3);
  sprintf(buf, "&+BAFF 1/2:&n %s %s\r\n", buf2, buf3);
  send_to_char(buf, ch);
  sprintbit(AFF3_FLAGS(k), affected3_bits, buf2);
  sprintbit(AFF4_FLAGS(k), affected4_bits, buf3);
  sprintf(buf, "&+BAFF 3/4:&n %s %s\r\n", buf2, buf3);
  send_to_char(buf, ch);

  /* Routine to show what spells a char is affected by */
  if (k->affected) {
    for (aff = k->affected; aff; aff = aff->next) {
      *buf2 = '\0';
      sprintf(buf, "&+BSPL: (&n%3d&+Brds)&n %-21s ", aff->duration + 1,
	      (aff->type >= 0 && aff->type <= MAX_SPELLS) ?
	      spells[aff->type] : "TYPE UNDEFINED");
      if (aff->modifier) {
	sprintf(buf2, "%+d to %s", aff->modifier, apply_types[(int) aff->location]);
	strcat(buf, buf2);
      }
      if (aff->bitvector) {
	if (*buf2)
	  strcat(buf, ", sets ");
	else
	  strcat(buf, "sets ");
	sprintbit(aff->bitvector, affected_bits, buf2);
	strcat(buf, buf2);
      }
      send_to_char(strcat(buf, "\r\n"), ch);
    }
  }
  if (RIDING(k))
    send_to_char("Riding: Yes\r\n", ch);

  /* check mobiles for a script */
  if (IS_NPC(k))
    do_sstat_character(ch, k);

}


void do_stat_mobile(struct char_data *ch, struct char_data *k)
{
  int i, i2, found = 0;
  char buf3[256];
  struct obj_data *j;
  struct follow_type *fol;
  struct affected_type *aff;
  extern struct attack_hit_type attack_hit_text[];
  struct mob_attack_data *Attack_type, *Next_attack;
  memory_rec *names;

  sprintf(buf, "&+Y-=-=-=-=-= MOBILE STAT =-=-=-=-=-\r\n");
  send_to_char(buf, ch);

  switch (GET_SEX(k)) {
  case SEX_NEUTRAL:
    strcpy(buf, "&+LSexless");
    break;
  case SEX_MALE:
    strcpy(buf, "&+LMale");
    break;
  case SEX_FEMALE:
    strcpy(buf, "&+LFemale");
    break;
  default:
    strcpy(buf, "&=LRILLEGAL-SEX!!");
    break;
  }

  sprintf(buf2, " MOB&n '%s'  &+BIDNum: [&n%5ld&+B], In room [&n%5d&+B] X:&n%d &+BY:&n%d &+BZ:&n%d\r\n",
	  GET_NAME(k), GET_IDNUM(k),
	  k->in_room != NOWHERE ? world[k->in_room].number : NOWHERE,
	  GET_X_CORD(k), GET_Y_CORD(k), GET_Z_CORD(k));
  send_to_char(strcat(buf, buf2), ch);
  sprintf(buf, "&+BAlias: &n%s, &+BVNum: [&n%5d&+B], RNum: [&n%5d&+B]&n\r\n",
	  k->player.name, GET_MOB_VNUM(k), GET_MOB_RNUM(k));
  send_to_char(buf, ch);

  sprintf(buf, "&+BDescription:&n %s\r\n", (k->player.long_descr ? k->player.long_descr : "<None>\r\n"));
  send_to_char(buf, ch);

  strcpy(buf, "&+BClass:&n ");
  if (GET_CLASS(k) != CLASS_UNDEFINED) {
    sprinttype(k->player.class, class_types, buf2);
    strcat(buf, buf2);
  } else {
    strcat(buf, "None");
  }
  send_to_char(buf, ch);

  strcpy(buf, "&+B, Race: &n");
  sprinttype(k->player.race, race_types, buf2);
  strcat(buf, buf2);

  if (IS_MAGE_SPECIALIST(k)) {
    sprintf(buf, " &+B(&n%s&+B)", specialist_list[(int) IS_MAGE_SPECIALIST(k) - 1]);
    send_to_char(buf, ch);
  }
  sprintf(buf2, "&+B, Size: &n%s\r\n",
	  size_types[(int) GET_SIZE(k)]);
  strcat(buf, buf2);
  send_to_char(buf, ch);

  if (GET_HOMETOWN(k)) {
    sprintf(buf, "&+BCitizenOf: &n%s",
	    kingdom_list[(int) GET_HOMETOWN(k)]);
    send_to_char(buf, ch);
    if (IS_GUARD(k))
      send_to_char("  &+RGuard&n", ch);
    if (IS_CITIZEN(k))
      send_to_char("  &+YCitizen&n", ch);
    /* debug line 4/9/99 */
    sprintf(buf, "  %d/%d", GET_HOMETOWN(k), zone_table[world[k->in_room].zone].kingdom);
    send_to_char(buf, ch);

    send_to_char("\r\n", ch);
  }
  sprintf(buf, "&+BHD: [&n%2d (d%d)+%2d&+B], XP: [&n%7d&+B], Align: [&n%s&+B]&n\r\n",
	  GET_LEVEL(k), GET_HPDIE(k), GET_HPPLUS(k), GET_EXP(k), alignment_types[GET_ALIGNMENT(k)]);
  send_to_char(buf, ch);

  sprintf(buf, "&+BStr: [&n%d&+B/&n%d&+B]  Int: [&n%d&+B]  Wis: [&n%d&+B]  "
	  "Dex: [&n%d&+B]  Con: [&n%d&+B]  Cha: [&n%d&+B]&n\r\n",
	  GET_STR(k), GET_ADD(k), GET_INT(k), GET_WIS(k),
	  GET_DEX(k), GET_CON(k), GET_CHA(k));
  send_to_char(buf, ch);

  sprintf(buf, "&+BHit p.:[&n%d&+B/&n%d&+B]&n &+BAC: [&n%d&+B], THAC0: [&n%3d&+B]\r\n",
	  GET_HIT(k), GET_MAX_HIT(k), GET_AC(k), GET_THAC0(k));
  send_to_char(buf, ch);

  sprintf(buf, "&+BHitroll: [&n%2d&+B], Damroll: [&n%2d&+B]\r\n",
	  k->points.hitroll, k->points.damroll);
  send_to_char(buf, ch);

  sprintf(buf, "&+BSaving throws: [&n%d&+B/&n%d&+B/&n%d&+B/&n%d&+B/&n%d&+B], MR: [&n%3d&+B]\r\n",
	  GET_SAVE(k, 0), GET_SAVE(k, 1), GET_SAVE(k, 2), GET_SAVE(k, 3), GET_SAVE(k, 4),
	  GET_MAGIC_RESISTANCE(k));
  send_to_char(buf, ch);

  if (IS_MAGE(k)) {
    strcpy(buf, "&+BSchool: &n");
    sprintbit(GET_MAGE_SCHOOL(k), school_list, buf2);
    strcat(buf, buf2);
    send_to_char(buf, ch);
    send_to_char("\r\n", ch);
  }
  strcpy(buf, "\r\n&+BWorshiping: &N");
  strcat(buf, deity_list[GET_PRIEST_DEITY(k)].deity_name);
  send_to_char(buf, ch);
  send_to_char("\r\n", ch);

  if (IS_PRIEST(k)) {
    strcpy(buf, "&+BSphere major: &n");
    sprintbit(GET_PRIEST_SPHERE_MAJOR(k), sphere_list, buf2);
    strcat(buf, buf2);
    send_to_char(buf, ch);
    send_to_char("\r\n", ch);

    strcpy(buf, "&+BSphere minor: &n");
    sprintbit(GET_PRIEST_SPHERE_MINOR(k), sphere_list, buf2);
    strcat(buf, buf2);
    send_to_char(buf, ch);
    send_to_char("\r\n", ch);
  }
  send_to_char("&+BAttack type&n\r\n", ch);
  if (k->mob_specials.mob_attack != NULL) {
    for (Attack_type = k->mob_specials.mob_attack; Attack_type; Attack_type = Next_attack) {
      Next_attack = Attack_type->next;
      sprintf(buf, "  &+BDamage: [&n%d&+B-&n%d&+B], Type: [&n%s&+B]\r\n", Attack_type->min_damage, Attack_type->max_damage, attack_hit_text[Attack_type->attack_type].singular);
      send_to_char(buf, ch);
    }
  }
  sprinttype(GET_POS(k), position_types, buf2);
  strcat(buf2, " ");
  sprintbit((GET_STAT(k) * 4), position_types, buf2 + strlen(buf2));
  sprintf(buf, "\r\n&+BPos:&n %s (%d) (%d)\r\n&+BFighting:&n %s, &+BHunting:&n %s",
	  buf2, GET_POS(k), GET_STAT(k),
	  (FIGHTING(k) ? GET_NAME(FIGHTING(k)) : "Nobody"),
	  (HUNTING(k) ? GET_NAME(HUNTING(k)) : "Nobody"));

  send_to_char(strcat(buf, "\r\n"), ch);

  strcpy(buf, "&+BDefault position:&n ");
  sprinttype((k->mob_specials.default_pos), position_types, buf2);
  strcat(buf, buf2);

  sprintf(buf2, "&+B, Idle Timer (in tics) [&n%d&+B]&n\r\n", k->char_specials.timer);
  strcat(buf, buf2);
  send_to_char(buf, ch);

  sprintbit(MOB_FLAGS(k), action_bits, buf2);
  sprintf(buf, "&+BNPC flags:&n %s\r\n", buf2);
  send_to_char(buf, ch);

  sprintf(buf, "&+BMob Spec-Proc:&n %s\r\n",
	  (mob_index[GET_MOB_RNUM(k)].func ? "Exists" : "None"));
  send_to_char(buf, ch);

  sprintf(buf, "&+BCarried: weight: &n%d/%d (%d%%), &+Bitems:&n %d; ",
	  IS_CARRYING_W(k), CAN_CARRY_W(k), carried_load_percent(k), IS_CARRYING_N(k));

  for (i = 0, j = k->carrying; j; j = j->next_content, i++);
  sprintf(buf, "%s&+BItems in: inventory:&n %d, ", buf, i);

  for (i = 0, i2 = 0; i < NUM_WEARS; i++)
    if (GET_EQ(k, i))
      i2++;
  sprintf(buf2, "&+Beq:&n %d &+Btreasure type:&n %d\r\n", i2, GET_MOB_TREASURE(k));
  strcat(buf, buf2);
  send_to_char(buf, ch);

  sprintf(buf, "&+BMaster is:&n %s, &+BFollowers are:&n",
	  ((k->master) ? GET_NAME(k->master) : "<none>"));

  for (fol = k->followers; fol; fol = fol->next) {
    sprintf(buf2, "%s %s", found++ ? "," : "", PERS(fol->follower, ch, FALSE));
    strcat(buf, buf2);
    if (strlen(buf) >= 62) {
      if (fol->next)
	send_to_char(strcat(buf, ",\r\n"), ch);
      else
	send_to_char(strcat(buf, "\r\n"), ch);
      *buf = found = 0;
    }
  }

  if (*buf)
    send_to_char(strcat(buf, "\r\n"), ch);

  /* Show player on mobs piss list */
  send_to_char("&+RPissed List&n:\r\n&+Y--------------&n\r\n", ch);
  if (MOB_FLAGGED(k, MOB_MEMORY) && MEMORY(k)) {
    for (names = MEMORY(ch); names; names = names->next) {
      sprintf(buf2, "  %s\r\n", names->name);
      strcat(buf, buf2);
    }
    strcat(buf, "\r\n");
    send_to_char(buf, ch);
  }
  sprintf(buf, "&+BWatching:&n %s\r\n",
	  (k->watching) ? GET_NAME(k->watching->vict) : "<Nobody>");
  send_to_char(buf, ch);

  sprintf(buf, "&+BHunger:&n %d, &+BThirst:&n %d, &+BDrunk:&n %d\r\n",
	  GET_COND(k, FULL), GET_COND(k, THIRST), GET_COND(k, DRUNK));
  send_to_char(buf, ch);
  buf[0] = '\0';

  /* Showing the bitvector */
  sprintbit(AFF_FLAGS(k), affected_bits, buf2);
  sprintbit(AFF2_FLAGS(k), affected2_bits, buf3);
  sprintf(buf, "&+BAFF 1/2:&n %s %s\r\n", buf2, buf3);
  send_to_char(buf, ch);
  sprintbit(AFF3_FLAGS(k), affected3_bits, buf2);
  sprintbit(AFF4_FLAGS(k), affected4_bits, buf3);
  sprintf(buf, "&+BAFF 3/4:&n %s %s\r\n", buf2, buf3);
  send_to_char(buf, ch);

  /* Routine to show what spells a char is affected by */
  if (k->affected) {
    for (aff = k->affected; aff; aff = aff->next) {
      *buf2 = '\0';
      sprintf(buf, "&+BSPL: (&n%3d&+Bhr)&n %-21s ", aff->duration + 1,
	      (aff->type >= 0 && aff->type <= MAX_SPELLS) ?
	      spells[aff->type] : "TYPE UNDEFINED");
      if (aff->modifier) {
	sprintf(buf2, "%+d to %s", aff->modifier, apply_types[(int) aff->location]);
	strcat(buf, buf2);
      }
      if (aff->bitvector) {
	if (*buf2)
	  strcat(buf, ", sets ");
	else
	  strcat(buf, "sets ");
	sprintbit(aff->bitvector, affected_bits, buf2);
	strcat(buf, buf2);
      }
      send_to_char(strcat(buf, "\r\n"), ch);
    }
  }
  send_to_char("&+RSpells Known&n:\r\n&+Y--------------&n\r\n", ch);
  display_mob_spells(k, ch);

  /* check mobiles for a script */
  if (IS_NPC(k))
    do_sstat_character(ch, k);

}

ACMD(do_stat)
{
  struct char_data *victim = 0;
  struct obj_data *object = 0;
  struct char_file_u tmp_store;
  char Gbuf[MAX_STRING_LENGTH];
  int tmp;

  half_chop(argument, buf1, buf2);

  if (!*buf1) {
    send_to_char("Stats on who or what?\r\n", ch);
    return;
  } else if (is_abbrev(buf1, "room")) {
    do_stat_room(ch);
  } else if (is_abbrev(buf1, "mob")) {
    if (!*buf2)
      send_to_char("Stats on which mobile?\r\n", ch);
    else if (isdigit(*buf2)) {
      tmp = atoi(buf2);
      if ((victim = get_char_num(real_mobile(tmp)))) {
	if (IS_MOB(victim)) {
	  do_stat_mobile(ch, victim);
	} else {
	  send_to_char("Mobile is not a mob?!?\r\n", ch);
	}
      } else {
	send_to_char("No mobs found by that vnum.\r\n", ch);
      }
    } else {
      if ((victim = get_char_vis(ch, buf2))) {
	if (IS_MOB(victim)) {
	  do_stat_mobile(ch, victim);
	} else {
	  send_to_char("That name is a character? Use 'char' then!\r\n", ch);
	}
      } else {
	send_to_char("No mobs found with that name.\r\n", ch);
      }
    }
  } else if (is_abbrev(buf1, "zone")) {
    if (!*buf2)
      send_to_char("Stats on which zone?\r\n", ch);
    else if (isdigit(*buf2)) {
      Gbuf[0] = '\0';
      print_zone_to_buf(Gbuf, atoi(buf2), TRUE);
      send_to_char(Gbuf, ch);
    } else {
      send_to_char("Stats on which zone?\r\n", ch);
      return;
    }
  } else if (is_abbrev(buf1, "player") || is_abbrev(buf1, "character")) {
    if (!*buf2) {
      send_to_char("Stats on which player?\r\n", ch);
    } else {
      if ((victim = get_player_vis(ch, buf2, 0))) {
	if (IS_PC(victim)) {
	  do_stat_character(ch, victim);
	} else {
	  send_to_char("No such player around.\r\n", ch);
	}
      } else {
	send_to_char("No such player around.\r\n", ch);
      }
    }
  } else if (is_abbrev(buf1, "file")) {
    if (!*buf2) {
      send_to_char("Stats on which player?\r\n", ch);
    } else {
      CREATE(victim, struct char_data, 1);
      clear_char(victim);
      if (load_char(buf2, &tmp_store) > -1) {
	store_to_char(&tmp_store, victim);
	char_to_room(victim, 0, -1);
	if (GET_LEVEL(victim) > GET_LEVEL(ch))
	  send_to_char("Sorry, you can't do that.\r\n", ch);
	else
	  do_stat_character(ch, victim);
	extract_char(victim);
      } else {
	send_to_char("There is no such player.\r\n", ch);
	FREE(victim);
      }
    }
  } else if (is_abbrev(buf1, "object")) {
    if (!*buf2)
      send_to_char("Stats on which object?\r\n", ch);
    else if (isdigit(*buf2)) {
      tmp = atoi(buf2);
      if ((object = get_obj_num(real_object(tmp))))
	do_stat_object(ch, object);
      else
	send_to_char("No such object around.\r\n", ch);
    } else {
      if ((object = get_obj_vis(ch, buf2)))
	do_stat_object(ch, object);
      else
	send_to_char("No such object around.\r\n", ch);
    }
  } else {
    if ((object = get_object_in_equip_vis(ch, buf1, ch->equipment, &tmp))) {
      do_stat_object(ch, object);
    } else if ((object = get_obj_in_list_vis(ch, buf1, ch->carrying))) {
      do_stat_object(ch, object);
    } else if ((victim = get_char_room_vis(ch, buf1))) {
      if (IS_PC(victim)) {
	do_stat_character(ch, victim);
      } else {
	do_stat_mobile(ch, victim);
      }
    } else if ((object = get_obj_in_list_vis(ch, buf1, world[ch->in_room].contents))) {
      do_stat_object(ch, object);
    } else if ((victim = get_char_vis(ch, buf1))) {
      if (IS_PC(victim)) {
	do_stat_character(ch, victim);
      } else {
	do_stat_mobile(ch, victim);
      }
    } else if ((object = get_obj_vis(ch, buf1))) {
      do_stat_object(ch, object);
    } else {
      send_to_char("Nothing around by that name.\r\n", ch);
    }
  }
}


ACMD(do_shutdown)
{
  extern int circle_shutdown, circle_reboot;
  struct char_data *i;

  if (subcmd != SCMD_SHUTDOWN && subcmd != SCMD_REBOOT) {
    send_to_char("If you want to shut something down, say so!\r\n", ch);
    return;
  }
  one_argument(argument, arg);

  if (!*arg && subcmd != SCMD_REBOOT) {
    sprintf(buf, "(GC) Shutdown by %s.", GET_NAME(ch));
    log(buf);
    send_to_all("Shutting down.\r\n");
    circle_shutdown = 1;
  } else if (!str_cmp(arg, "reboot") || subcmd == SCMD_REBOOT) {
    if (!olc_save_list) {
      sprintf(buf, "(GC) Reboot by %s.", GET_NAME(ch));
      log(buf);
      send_to_all("Rebooting.. come back in a minute or two.\r\n");
      /* save with the char list, cause we may wish to save mobs as well
         some day. Who cares about lag when your shutting down? */
      for (i = character_list; i; i = i->next) {
	GET_LOADROOM(ch) = world[IN_ROOM(ch)].number;
	if (IS_PC(i))
	  save_char(i, i->in_room);
      }
      send_to_char("All players saved.\r\n", ch);
      touch(FASTBOOT_FILE);
      circle_shutdown = circle_reboot = 1;
    } else {
      send_to_char("There are olc files to be saved!\r\nEither save them first, or force a reboot with shutdown...\r\n", ch);
      return;
    }
  } else if (!str_cmp(arg, "now")) {
    sprintf(buf, "(GC) Shutdown NOW by %s.", GET_NAME(ch));
    log(buf);
    send_to_all("Rebooting.. come back in a minute or two.\r\n");
    circle_shutdown = 1;
    circle_reboot = 2;
  } else if (!str_cmp(arg, "die")) {
    sprintf(buf, "(GC) Shutdown by %s.", GET_NAME(ch));
    log(buf);
    send_to_all("Shutting down for maintenance.\r\n");
    touch(KILLSCRIPT_FILE);
    circle_shutdown = 1;
  } else if (!str_cmp(arg, "crash")) {
    sprintf(buf, "(GC) Shutdown by %s.", GET_NAME(ch));
    log(buf);
    raise(SIGSEGV);
    circle_shutdown = 1;
  } else if (!str_cmp(arg, "pause")) {
    sprintf(buf, "(GC) Shutdown by %s.", GET_NAME(ch));
    log(buf);
    send_to_all("Shutting down for maintenance.\r\n");
    touch(PAUSE_FILE);
    circle_shutdown = 1;
  } else
    send_to_char("Unknown shutdown option.\r\n", ch);
}


void stop_snooping(struct char_data *ch)
{
  if (!ch->desc->snooping)
    send_to_char("You aren't snooping anyone.\r\n", ch);
  else {
    send_to_char("You stop snooping.\r\n", ch);
    ch->desc->snooping->snoop_by = NULL;
    ch->desc->snooping = NULL;
  }
}


ACMD(do_snoop)
{
  struct char_data *victim, *tch;

  if (!ch->desc)
    return;

  one_argument(argument, arg);

  if (!*arg)
    stop_snooping(ch);
  else if (!(victim = get_char_vis(ch, arg)))
    send_to_char("No such person around.\r\n", ch);
  else if (!victim->desc)
    send_to_char("There's no link.. nothing to snoop.\r\n", ch);
  else if (victim == ch)
    stop_snooping(ch);
  else if (victim->desc->snoop_by)
    send_to_char("Busy already. \r\n", ch);
  else if (victim->desc->snooping == ch->desc)
    send_to_char("Don't be stupid.\r\n", ch);
  else {
    if (victim->desc->original)
      tch = victim->desc->original;
    else
      tch = victim;

    if (GET_LEVEL(tch) >= GET_LEVEL(ch)) {
      send_to_char("You can't.\r\n", ch);
      return;
    }
    send_to_char(OK, ch);

    if (ch->desc->snooping)
      ch->desc->snooping->snoop_by = NULL;

    ch->desc->snooping = victim->desc;
    victim->desc->snoop_by = ch->desc;
  }
}



ACMD(do_switch)
{
  struct char_data *victim;

  one_argument(argument, arg);

  if (ch->desc->original)
    send_to_char("You're already switched.\r\n", ch);
  else if (!*arg)
    send_to_char("Switch with who?\r\n", ch);
  else if (!(victim = get_char_vis(ch, arg)))
    send_to_char("No such character.\r\n", ch);
  else if (ch == victim)
    send_to_char("Hee hee... we are jolly funny today, eh?\r\n", ch);
  else if (victim->desc)
    send_to_char("You can't do that, the body is already in use!\r\n", ch);
  else if ((GET_LEVEL(ch) < LVL_GOD7) && !IS_NPC(victim))
    send_to_char("You aren't holy enough to use a mortal's body.\r\n", ch);
  else if ((GET_LEVEL(ch) < LVL_IMPL) && (GET_LEVEL(victim) > LVL_IMMORT))
    send_to_char("Why?  So you can ruin their fine (ha!) reputation?!\r\n", ch);
  else {
    send_to_char(OK, ch);

    ch->desc->character = victim;
    ch->desc->original = ch;

    victim->desc = ch->desc;
    ch->desc = NULL;
  }
}


ACMD(do_return)
{
  if (MORPH_MOB(ch))
    un_morph(ch);
  else if (CHAR_POLYMORPH_OBJ(ch))
    return_from_poly_obj(ch);

  if (ch->desc && ch->desc->original) {
    send_to_char("You return to your original body.\r\n", ch);

    /* JE 2/22/95 */
    /* if someone switched into your original body, disconnect them */
    if (ch->desc->original->desc)
      close_socket(ch->desc->original->desc);

    ch->desc->character = ch->desc->original;
    ch->desc->original = NULL;

    ch->desc->character->desc = ch->desc;
    ch->desc = NULL;
  }
}



ACMD(do_load)
{
  struct char_data *mob;
  struct obj_data *obj;
  int number, r_num;

  two_arguments(argument, buf, buf2);

  if (!*buf || !*buf2 || !isdigit(*buf2)) {
    send_to_char("Usage: load { obj | mob } <number>\r\n", ch);
    return;
  }
  if ((number = atoi(buf2)) < 0) {
    send_to_char("A NEGATIVE number??\r\n", ch);
    return;
  }
  if (is_abbrev(buf, "mob")) {
    if ((r_num = real_mobile(number)) < 0) {
      send_to_char("There is no monster with that number.\r\n", ch);
      return;
    }
    mob = read_mobile(r_num, REAL);
    /* loads them same spot as god */
    put_char_to_room(mob, ch->in_room, -1, GET_X_CORD(ch), GET_Y_CORD(ch), GET_Z_CORD(ch));
    act("$n makes a quaint, magical gesture with one hand.", TRUE, ch,
	0, 0, TO_PROXIMITY);
    act("$n has created $N!", FALSE, ch, 0, mob, TO_PROXIMITY);
    act("You create $N.", FALSE, ch, 0, mob, TO_CHAR);
    load_mtrigger(mob);
  } else if (is_abbrev(buf, "obj")) {
    if ((r_num = real_object(number)) < 0) {
      send_to_char("There is no object with that number.\r\n", ch);
      return;
    }
    obj = read_object(r_num, REAL);
    if (!(CAN_WEAR(obj, ITEM_TAKE)))
      put_obj_to_room(obj, ch->in_room, GET_X_CORD(ch), GET_Y_CORD(ch), GET_Z_CORD(ch));
    else
      obj_to_char(obj, ch);
    act("$n makes a strange magical gesture.", TRUE, ch, 0, 0, TO_PROXIMITY);
    act("$n has created $p!", FALSE, ch, obj, 0, TO_PROXIMITY);
    act("You create $p.", FALSE, ch, obj, 0, TO_CHAR);
    load_otrigger(obj);
  } else
    send_to_char("That'll have to be either 'obj' or 'mob'.\r\n", ch);
}



ACMD(do_vstat)
{
  int number, r_num;

  two_arguments(argument, buf, buf2);

  if (!*buf || !*buf2 || !isdigit(*buf2)) {
    send_to_char("Usage: vstat { obj | mob } <number>\r\n", ch);
    return;
  }
  if ((number = atoi(buf2)) < 0) {
    send_to_char("A NEGATIVE number??\r\n", ch);
    return;
  }
  if (is_abbrev(buf, "mob")) {
    if ((r_num = real_mobile(number)) < 0) {
      send_to_char("There is no monster with that number.\r\n", ch);
      return;
    }
    do_stat_character(ch, mob_proto + r_num);
  } else if (is_abbrev(buf, "obj")) {
    if ((r_num = real_object(number)) < 0) {
      send_to_char("There is no object with that number.\r\n", ch);
      return;
    }
    do_stat_object(ch, obj_proto + r_num);
  } else
    send_to_char("That'll have to be either 'obj' or 'mob'.\r\n", ch);
}




/* clean a room of all mobiles and objects */
ACMD(do_purge)
{
  int x, room;
  struct char_data *vict, *next_v;
  struct obj_data *obj, *next_o;

  one_argument(argument, buf);

  if (*buf) {			/* argument supplied. destroy single object
				 * or char */
    if ((vict = get_char_room_vis(ch, buf))) {
      if (!IS_NPC(vict) && (GET_LEVEL(ch) <= GET_LEVEL(vict))) {
	send_to_char("Fuuuuuuuuu!\r\n", ch);
	return;
      }
      act("$n disintegrates $N.", FALSE, ch, 0, vict, TO_NOTVICT);

      if (!IS_NPC(vict)) {
	sprintf(buf, "(GC) %s has purged %s.", GET_NAME(ch), GET_NAME(vict));
	mudlog(buf, BRF, LVL_GOD, TRUE);
	if (vict->desc) {
	  close_socket(vict->desc);
	  vict->desc = NULL;
	}
      }
      extract_char(vict);
    } else if ((obj = get_obj_in_list_vis(ch, buf, world[ch->in_room].contents))) {
      act("$n destroys $p.", FALSE, ch, obj, 0, TO_PROXIMITY);
      extract_obj(obj);
    } else if (!str_cmp(buf, "zone")) {
      act("$n gestures... You are surrounded by scorching flames!",
	  FALSE, ch, 0, 0, TO_PROXIMITY);
      send_to_room("The zone seems a little cleaner.\r\n", ch->in_room);

      room = world[ch->in_room].zone * 100;
      for (x = 0; x < 100; x++) {
	if (real_room(room + x) < 1)
	  continue;
	for (vict = world[real_room(room) + x].people; vict; vict = next_v) {
	  next_v = vict->next_in_room;
	  if (IS_NPC(vict))
	    extract_char(vict);
	}
	for (obj = world[real_room(room) + x].contents; obj; obj = next_o) {
	  next_o = obj->next_content;
	  extract_obj(obj);
	}
      }
    } else {
      send_to_char("Nothing here by that name.\r\n", ch);
      return;
    }

    send_to_char(OK, ch);
  } else {			/* no argument. clean out the room */
    act("$n gestures... You are surrounded by scorching flames!",
	FALSE, ch, 0, 0, TO_PROXIMITY);
    send_to_room("The room seems a little cleaner.\r\n", ch->in_room);

    for (vict = world[ch->in_room].people; vict; vict = next_v) {
      next_v = vict->next_in_room;
      if (IS_NPC(vict))
	extract_char(vict);
    }

    for (obj = world[ch->in_room].contents; obj; obj = next_o) {
      next_o = obj->next_content;
      extract_obj(obj);
    }
  }
}



static char *logtypes[] =
{
  "off", "brief", "normal", "complete", "\n"};

ACMD(do_syslog)
{
  int tp;

  one_argument(argument, arg);

  if (!*arg) {
    tp = ((PRF_FLAGGED(ch, PRF_LOG1) ? 1 : 0) +
	  (PRF_FLAGGED(ch, PRF_LOG2) ? 2 : 0));
    sprintf(buf, "Your syslog is currently %s.\r\n", logtypes[tp]);
    send_to_char(buf, ch);
    return;
  }
  if (((tp = search_block(arg, logtypes, FALSE)) == -1)) {
    send_to_char("Usage: syslog { Off | Brief | Normal | Complete }\r\n", ch);
    return;
  }
  REMOVE_BIT(PRF_FLAGS(ch), PRF_LOG1 | PRF_LOG2);
  SET_BIT(PRF_FLAGS(ch), (PRF_LOG1 * (tp & 1)) | (PRF_LOG2 * (tp & 2) >> 1));

  sprintf(buf, "Your syslog is now %s.\r\n", logtypes[tp]);
  send_to_char(buf, ch);
}

void send_to_imms(char *msg)
{
  struct descriptor_data *pt;

  for (pt = descriptor_list; pt; pt = pt->next)
    if (!pt->connected && pt->character && GET_LEVEL(pt->character) >= LVL_GOD)
      send_to_char(msg, pt->character);

}


ACMD(do_level)
{
  struct char_data *victim;
  char *name = arg, *level = buf2;
  int newlevel, oldlevel;
  void do_start(struct char_data *ch);

  void gain_exp(struct char_data *ch, int gain);

  two_arguments(argument, name, level);

  if (*name) {
    if (!(victim = get_char_vis(ch, name))) {
      send_to_char("That player is not here.\r\n", ch);
      return;
    }
  } else {
    send_to_char("Advance who?\r\n", ch);
    return;
  }

  if (GET_LEVEL(ch) <= GET_LEVEL(victim)) {
    send_to_char("Maybe that's not such a great idea.\r\n", ch);
    return;
  }
  if (IS_NPC(victim)) {
    send_to_char("NO!  Not on NPC's.\r\n", ch);
    return;
  }
  if (!*level || (newlevel = atoi(level)) <= 0) {
    send_to_char("That's not a level!\r\n", ch);
    return;
  }
  if (newlevel > LVL_IMPL) {
    sprintf(buf, "%d is the highest possible level.\r\n", LVL_IMPL);
    send_to_char(buf, ch);
    return;
  }
  if (newlevel >= GET_LEVEL(ch) && GET_LEVEL(ch) != LVL_IMPL) {
    send_to_char("Yeah, right.\r\n", ch);
    return;
  }
  if (newlevel == GET_LEVEL(victim)) {
    send_to_char("They are already at that level.\r\n", ch);
    return;
  }
  oldlevel = GET_LEVEL(victim);
  if (newlevel < GET_LEVEL(victim)) {
    do_start(victim);
    GET_LEVEL(victim) = newlevel;
    GET_TOT_LEVEL(victim) -= (oldlevel - newlevel);
    send_to_char("You are momentarily enveloped by darkness!\r\n"
		 "You feel somewhat diminished.\r\n", victim);
  } else {
    act("$n makes some strange gestures.\r\n"
	"A strange feeling comes upon you,\r\n"
	"Like a giant hand, light comes down\r\n"
	"from above, grabbing your body, that\r\n"
	"begins to pulse with colored lights\r\n"
	"from inside.\r\n\r\n"
	"Your head seems to be filled with demons\r\n"
	"from another plane as your body dissolves\r\n"
	"to the elements of time and space itself.\r\n"
	"Suddenly a silent explosion of light\r\n"
	"snaps you back to reality.\r\n\r\n"
	"You feel slightly different.", FALSE, ch, 0, victim, TO_VICT);
  }

  send_to_char(OK, ch);

  sprintf(buf, "(GC) %s has advanced %s to level %d (from %d)",
	  GET_NAME(ch), GET_NAME(victim), newlevel, oldlevel);
  log(buf);
  gain_exp_regardless(victim,
	       level_exp(GET_CLASS(victim), newlevel) - GET_EXP(victim));
  /* just in case */
  GET_LEVEL(victim) = newlevel;
  save_char(victim, NOWHERE);
}



ACMD(do_restore)
{
  struct char_data *vict;

  one_argument(argument, buf);
  if (!*buf)
    send_to_char("Whom do you wish to restore?\r\n", ch);
  else if (!(vict = get_char_vis(ch, buf)))
    send_to_char(NOPERSON, ch);
  else {
    alter_hit(vict, -GET_MAX_HIT(vict), -1, 0);

    if ((GET_LEVEL(ch) >= LVL_GRGOD) && (GET_LEVEL(vict) >= LVL_IMMORT)) {
/*      for (i = 1; i <= MAX_SKILLS; i++)
   SET_SKILL(vict, i, 100); */

      if (GET_LEVEL(vict) == LVL_IMPL) {
	vict->real_abils.str_add = 0;
	vict->real_abils.str = 25;
	vict->real_abils.dex = 25;
	vict->real_abils.con = 25;
	vict->real_abils.wis = 25;
	vict->real_abils.intel = 25;
	vict->real_abils.cha = 25;
      }
      if (GET_LEVEL(vict) == LVL_GRGOD) {
	vict->real_abils.str_add = 0;
	vict->real_abils.str = 24;
	vict->real_abils.dex = 24;
	vict->real_abils.con = 24;
	vict->real_abils.wis = 24;
	vict->real_abils.intel = 24;
	vict->real_abils.cha = 24;
      }
      if (GET_LEVEL(vict) == LVL_GOD) {
	vict->real_abils.str_add = 0;
	vict->real_abils.str = 23;
	vict->real_abils.dex = 23;
	vict->real_abils.con = 23;
	vict->real_abils.wis = 23;
	vict->real_abils.intel = 23;
	vict->real_abils.cha = 23;
      }
      if (GET_LEVEL(vict) == LVL_IMMORT) {
	vict->real_abils.str_add = 0;
	vict->real_abils.str = 20;
	vict->real_abils.dex = 20;
	vict->real_abils.con = 20;
	vict->real_abils.wis = 20;
	vict->real_abils.intel = 20;
	vict->real_abils.cha = 20;
      }
      vict->aff_abils = vict->real_abils;
    }
    update_pos(vict);
    send_to_char(OK, ch);
    act("You have been fully healed by $N!", FALSE, vict, 0, ch, TO_CHAR);
  }
}


void perform_immort_vis(struct char_data *ch)
{
  void appear(struct char_data *ch);

  if (GET_INVIS_LEV(ch) == 0 && !IS_AFFECTED(ch, AFF_HIDE | AFF_INVISIBLE)) {
    send_to_char("You are already fully visible.\r\n", ch);
    return;
  }
  GET_INVIS_LEV(ch) = 0;
  appear(ch);
  send_to_char("You are now fully visible.\r\n", ch);
}


void perform_immort_invis(struct char_data *ch, int level)
{
  struct char_data *tch;

  if (IS_NPC(ch))
    return;

  for (tch = world[ch->in_room].people; tch; tch = tch->next_in_room) {
    if (tch == ch)
      continue;
    if (GET_LEVEL(tch) >= GET_INVIS_LEV(ch) && GET_LEVEL(tch) < level)
      act("You blink and suddenly realize that $n is gone.", FALSE, ch, 0,
	  tch, TO_VICT);
    if (GET_LEVEL(tch) < GET_INVIS_LEV(ch) && GET_LEVEL(tch) >= level)
      act("You suddenly realize that $n is standing beside you.", FALSE, ch, 0,
	  tch, TO_VICT);
  }

  GET_INVIS_LEV(ch) = level;
  sprintf(buf, "Your invisibility level is %d.\r\n", level);
  send_to_char(buf, ch);
}


ACMD(do_invis)
{
  int level;

  if (IS_NPC(ch)) {
    send_to_char("You can't do that!\r\n", ch);
    return;
  }
  one_argument(argument, arg);
  if (!*arg) {
    if (GET_INVIS_LEV(ch) > 0)
      perform_immort_vis(ch);
    else
      perform_immort_invis(ch, GET_LEVEL(ch));
  } else {
    level = atoi(arg);
    if (level > GET_LEVEL(ch))
      send_to_char("You can't go invisible above your own level.\r\n", ch);
    else if (level < 1)
      perform_immort_vis(ch);
    else
      perform_immort_invis(ch, level);
  }
}


ACMD(do_gecho)
{
  struct descriptor_data *pt;

  skip_spaces(&argument);
  delete_doubledollar(argument);

  if (!*argument)
    send_to_char("That must be a mistake...\r\n", ch);
  else {
    sprintf(buf, "%s\r\n", argument);
    sprintf(buf2, "(%s) %s\r\n", GET_NAME(ch), argument);
    for (pt = descriptor_list; pt; pt = pt->next)
      if (!pt->connected && pt->character && pt->character != ch) {
	if (GET_LEVEL(pt->character) < GET_LEVEL(ch))
	  send_to_char(buf, pt->character);
	else
	  send_to_char(buf2, pt->character);
      }
    if (PRF_FLAGGED(ch, PRF_NOREPEAT))
      send_to_char(OK, ch);
    else
      send_to_char(buf, ch);
  }
}

ACMD(do_poofset)
{

  skip_spaces(&argument);

  switch (subcmd) {
  case SCMD_POOFIN:
    if (!*argument)
      POOFIN(ch) = NULL;
    else
      POOFIN(ch) = str_dup(argument);
    break;
  case SCMD_POOFOUT:
    if (!*argument)
      POOFOUT(ch) = NULL;
    else
      POOFOUT(ch) = str_dup(argument);
    break;
  default:
    return;
    break;
  }
  send_to_char(OK, ch);
}


ACMD(do_dc)
{
  struct descriptor_data *d;
  int num_to_dc;

  one_argument(argument, arg);
  if (!(num_to_dc = atoi(arg))) {
    send_to_char("Usage: DC <user number> (type USERS for a list)\r\n", ch);
    return;
  }
  for (d = descriptor_list; d && d->desc_num != num_to_dc; d = d->next);

  if (!d) {
    send_to_char("No such connection.\r\n", ch);
    return;
  }
  if (d->character && GET_LEVEL(d->character) >= GET_LEVEL(ch)) {
    if (!CAN_SEE(ch, d->character))
      send_to_char("No such connection.\r\n", ch);
    else
      send_to_char("Umm.. maybe that's not such a good idea...\r\n", ch);
    return;
  }
  /* We used to just close the socket here using close_socket(), but
   * various people pointed out this could cause a crash if you're
   * closing the person below you on the descriptor list.  Just setting
   * to CON_CLOSE leaves things in a massively inconsistent state so I
   * had to add this new flag to the descriptor.
   */
  d->close_me = 1;
  sprintf(buf, "Connection #%d closed.\r\n", num_to_dc);
  send_to_char(buf, ch);
  sprintf(buf, "(GC) Connection closed by %s.", GET_NAME(ch));
  log(buf);
}



ACMD(do_wizlock)
{
  int value;
  char *when;

  one_argument(argument, arg);
  if (*arg) {
    value = atoi(arg);
    if (value < 0 || value > GET_LEVEL(ch)) {
      send_to_char("Invalid wizlock value.\r\n", ch);
      return;
    }
    restricted = value;
    when = "now";
  } else
    when = "currently";

  switch (restricted) {
  case 0:
    sprintf(buf, "The game is %s completely open.\r\n", when);
    break;
  case 1:
    sprintf(buf, "The game is %s closed to new players.\r\n", when);
    break;
  default:
    sprintf(buf, "Only level %d and above may enter the game %s.\r\n",
	    restricted, when);
    break;
  }
  send_to_char(buf, ch);
}


ACMD(do_date)
{
  char *tmstr;
  time_t mytime;
  int d, h, m;
  extern time_t boot_time;

  if (subcmd == SCMD_DATE)
    mytime = time(0);
  else
    mytime = boot_time;

  tmstr = (char *) asctime(localtime(&mytime));
  *(tmstr + strlen(tmstr) - 1) = '\0';

  if (subcmd == SCMD_DATE)
    sprintf(buf, "Current machine time: %s\r\n", tmstr);
  else {
    mytime = time(0) - boot_time;
    d = mytime / 86400;
    h = (mytime / 3600) % 24;
    m = (mytime / 60) % 60;

    sprintf(buf, "Up since %s: %d day%s, %d:%02d\r\n", tmstr, d,
	    ((d == 1) ? "" : "s"), h, m);
  }

  send_to_char(buf, ch);
}



ACMD(do_last)
{
  struct char_file_u chdata;
  extern char *class_abbrevs[];

  one_argument(argument, arg);
  if (!*arg) {
    send_to_char("For whom do you wish to search?\r\n", ch);
    return;
  }
  if (load_char(arg, &chdata) < 0) {
    send_to_char("There is no such player.\r\n", ch);
    return;
  }
  if ((chdata.level > GET_LEVEL(ch)) && (GET_LEVEL(ch) < LVL_IMPL)) {
    send_to_char("You are not sufficiently godly for that!\r\n", ch);
    return;
  }
  sprintf(buf, "[%5ld] [%2d %s] %-12s : %-18s : %-20s\r\n",
	  chdata.char_specials_saved.idnum, (int) chdata.level,
	  class_abbrevs[(int) chdata.class], chdata.name, chdata.host,
	  ctime(&chdata.last_logon));
  send_to_char(buf, ch);
}


ACMD(do_force)
{
  struct descriptor_data *i, *next_desc;
  struct char_data *vict, *next_force;
  char to_force[MAX_INPUT_LENGTH + 2];

  half_chop(argument, arg, to_force);

  sprintf(buf1, "$n has forced you to '%s'.", to_force);

  if (!*arg || !*to_force)
    send_to_char("Whom do you wish to force do what?\r\n", ch);
  else if ((GET_LEVEL(ch) < LVL_GRGOD) || (str_cmp("all", arg) && str_cmp("room", arg))) {
    if (!(vict = get_char_vis(ch, arg)))
      send_to_char(NOPERSON, ch);
    else if (GET_LEVEL(ch) <= GET_LEVEL(vict) && IS_PC(vict))
      send_to_char("No, no, no!\r\n", ch);
    else {
      send_to_char(OK, ch);
      act(buf1, TRUE, ch, NULL, vict, TO_VICT);
      sprintf(buf, "(GC) %s forced %s to %s", GET_NAME(ch), GET_NAME(vict), to_force);
      mudlog(buf, NRM, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE);
      command_interpreter(vict, to_force);
    }
  } else if (!str_cmp("room", arg)) {
    send_to_char(OK, ch);
    sprintf(buf, "(GC) %s forced room %d to %s", GET_NAME(ch), world[ch->in_room].number, to_force);
    mudlog(buf, NRM, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE);

    for (vict = world[ch->in_room].people; vict; vict = next_force) {
      next_force = vict->next_in_room;
      if (GET_LEVEL(vict) >= GET_LEVEL(ch))
	continue;
      act(buf1, TRUE, ch, NULL, vict, TO_VICT);
      command_interpreter(vict, to_force);
    }
  } else {			/* force all */
    send_to_char(OK, ch);
    sprintf(buf, "(GC) %s forced all to %s", GET_NAME(ch), to_force);
    mudlog(buf, NRM, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE);

    for (i = descriptor_list; i; i = next_desc) {
      next_desc = i->next;

      if (i->connected || !(vict = i->character) || GET_LEVEL(vict) >= GET_LEVEL(ch))
	continue;
      act(buf1, TRUE, ch, NULL, vict, TO_VICT);
      command_interpreter(vict, to_force);
    }
  }
}



ACMD(do_wiznet)
{
  struct descriptor_data *d, *d_tmp;
  char emote = FALSE;
  char any = FALSE;
  int level = LVL_IMMORT;

  skip_spaces(&argument);
  delete_doubledollar(argument);

  if (!*argument) {
    send_to_char("Usage: wiznet <text> | #<level> <text> | *<emotetext> |\r\n "
		 "       wiznet @<level> *<emotetext> | wiz @\r\n", ch);
    return;
  }
  switch (*argument) {
  case '*':
    emote = TRUE;
  case '#':
    one_argument(argument + 1, buf1);
    if (is_number(buf1)) {
      half_chop(argument + 1, buf1, argument);
      level = MAX(atoi(buf1), LVL_IMMORT);
      if (level > GET_LEVEL(ch)) {
	send_to_char("You can't wizline above your own level.\r\n", ch);
	return;
      }
    } else if (emote)
      argument++;
    break;
  case '@':
    for (d = descriptor_list; d; d = d->next) {
      if (!d->connected && GET_LEVEL(d->character) >= LVL_IMMORT &&
	  !PRF_FLAGGED(d->character, PRF_NOWIZ) &&
	  (CAN_SEE(ch, d->character) || GET_LEVEL(ch) == LVL_IMPL)) {
	if (!any) {
	  sprintf(buf1, "Gods online:\r\n");
	  any = TRUE;
	}
	sprintf(buf1, "%s  %s", buf1, GET_NAME(d->character));
	if (PLR_FLAGGED(d->character, PLR_WRITING))
	  sprintf(buf1, "%s (Writing)\r\n", buf1);
	else if (PLR_FLAGGED(d->character, PLR_MAILING))
	  sprintf(buf1, "%s (Writing mail)\r\n", buf1);
	else
	  sprintf(buf1, "%s\r\n", buf1);

      }
    }
    any = FALSE;
    for (d = descriptor_list; d; d = d->next) {
      if (!d->connected && GET_LEVEL(d->character) >= LVL_IMMORT &&
	  PRF_FLAGGED(d->character, PRF_NOWIZ) &&
	  CAN_SEE(ch, d->character)) {
	if (!any) {
	  sprintf(buf1, "%sGods offline:\r\n", buf1);
	  any = TRUE;
	}
	sprintf(buf1, "%s  %s\r\n", buf1, GET_NAME(d->character));
      }
    }
    send_to_char(buf1, ch);
    return;
    break;
  case '\\':
    ++argument;
    break;
  default:
    break;
  }
  if (PRF_FLAGGED(ch, PRF_NOWIZ)) {
    send_to_char("You are offline!\r\n", ch);
    return;
  }
  skip_spaces(&argument);

  if (!*argument) {
    send_to_char("Don't bother the gods like that!\r\n", ch);
    return;
  }
  if (level > LVL_IMMORT) {
    sprintf(buf1, "&+C[%s:]&n&+Y <%d>&n %s%s\r\n", GET_NAME(ch), level,
	    emote ? "<--- " : "", argument);
    sprintf(buf2, "&+C[Someone:]&n&+Y <%d>&n %s%s\r\n", level, emote ? "<--- " : "",
	    argument);
  } else {
    sprintf(buf1, "&+C[%s]:&n %s%s\r\n", GET_NAME(ch), emote ? "<--- " : "",
	    argument);
    sprintf(buf2, "&+C[Someone:]&n %s%s\r\n", emote ? "<--- " : "", argument);
  }

  for (d_tmp = descriptor_list; d_tmp; d_tmp = d_tmp->next) {
/*
   if (MORPH_MOB(d_tmp->character))
   d = MORPH_MOB(d_tmp->character)->desc;
   else
 */
    d = d_tmp;

    if ((!d->connected) && (GET_LEVEL(d->character) >= level) &&
	(!PRF_FLAGGED(d->character, PRF_NOWIZ)) &&
	(!PLR_FLAGGED(d->character, PLR_WRITING | PLR_MAILING))
      && (d != ch->desc || !(PRF_FLAGGED(d->character, PRF_NOREPEAT)))) {
      if (CAN_SEE(d->character, ch))
	send_to_char(buf1, d->character);
      else
	send_to_char(buf2, d->character);
    }
  }

  if (PRF_FLAGGED(ch, PRF_NOREPEAT))
    send_to_char(OK, ch);
}



ACMD(do_zreset)
{
  void reset_zone(int zone);

  int i, j;

  one_argument(argument, arg);
  if (!*arg) {
    send_to_char("You must specify a zone.\r\n", ch);
    return;
  }
  if (*arg == '*') {
    for (i = 0; i <= top_of_zone_table; i++)
      reset_zone(i);
    send_to_char("Reset world.\r\n", ch);
    sprintf(buf, "(GC) %s reset entire world.", GET_NAME(ch));
    mudlog(buf, NRM, MAX(LVL_GRGOD, GET_INVIS_LEV(ch)), TRUE);
    return;
  } else if (*arg == '.')
    i = world[ch->in_room].zone;
  else {
    j = atoi(arg);
    for (i = 0; i <= top_of_zone_table; i++)
      if (zone_table[i].number == j)
	break;
  }
  if (i >= 0 && i <= top_of_zone_table) {
    reset_zone(i);
    sprintf(buf, "Reset zone %d (#%d): %s.\r\n", i, zone_table[i].number,
	    zone_table[i].name);
    send_to_char(buf, ch);
    sprintf(buf, "(GC) %s reset zone %d (#%d): %s", GET_NAME(ch), i, zone_table[i].number, zone_table[i].name);
    mudlog(buf, NRM, MAX(LVL_GRGOD, GET_INVIS_LEV(ch)), TRUE);
  } else
    send_to_char("Invalid zone number.\r\n", ch);
  check_path();
}


/*
 *  General fn for wizcommands of the sort: cmd <player>
 */

ACMD(do_wizutil)
{
  struct char_data *vict;
  long result;
  void roll_real_abils(struct char_data *ch);

  one_argument(argument, arg);

  if (!*arg)
    send_to_char("Yes, but for whom?!?\r\n", ch);
  else if (!(vict = get_char_vis(ch, arg)))
    send_to_char("There is no such player.\r\n", ch);
  else if (IS_NPC(vict))
    send_to_char("You can't do that to a mob!\r\n", ch);
  else if (GET_LEVEL(vict) > GET_LEVEL(ch))
    send_to_char("Hmmm...you'd better not.\r\n", ch);
  else {
    switch (subcmd) {
    case SCMD_REROLL:
      send_to_char("Rerolled...\r\n", ch);
      roll_real_abils(vict);
      sprintf(buf, "(GC) %s has rerolled %s.", GET_NAME(ch), GET_NAME(vict));
      log(buf);
      sprintf(buf, "New stats: Str %d/%d, Int %d, Wis %d, Dex %d, Con %d, Cha %d\r\n",
	      GET_STR(vict), GET_ADD(vict), GET_INT(vict), GET_WIS(vict),
	      GET_DEX(vict), GET_CON(vict), GET_CHA(vict));
      send_to_char(buf, ch);
      break;
    case SCMD_PARDON:
      break;
    case SCMD_NOTITLE:
      result = PLR_TOG_CHK(vict, PLR_NOTITLE);
      sprintf(buf, "(GC) Notitle %s for %s by %s.", ONOFF(result),
	      GET_NAME(vict), GET_NAME(ch));
      mudlog(buf, NRM, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE);
      strcat(buf, "\r\n");
      send_to_char(buf, ch);
      break;
    case SCMD_SQUELCH:
      result = PLR_TOG_CHK(vict, PLR_NOSHOUT);
      sprintf(buf, "(GC) Squelch %s for %s by %s.", ONOFF(result),
	      GET_NAME(vict), GET_NAME(ch));
      mudlog(buf, BRF, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE);
      strcat(buf, "\r\n");
      send_to_char(buf, ch);
      break;
    case SCMD_FREEZE:
      if (ch == vict) {
	send_to_char("Oh, yeah, THAT'S real smart...\r\n", ch);
	return;
      }
      if (PLR_FLAGGED(vict, PLR_FROZEN)) {
	send_to_char("Your victim is already pretty cold.\r\n", ch);
	return;
      }
      SET_BIT(PLR_FLAGS(vict), PLR_FROZEN);
      GET_FREEZE_LEV(vict) = GET_LEVEL(ch);
      send_to_char("A bitter wind suddenly rises and drains every erg of heat from your body!\r\nYou feel frozen!\r\n", vict);
      send_to_char("Frozen.\r\n", ch);
      act("A sudden cold wind conjured from nowhere freezes $n!", FALSE, vict, 0, 0, TO_PROXIMITY);
      sprintf(buf, "(GC) %s frozen by %s.", GET_NAME(vict), GET_NAME(ch));
      mudlog(buf, BRF, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE);
      break;
    case SCMD_THAW:
      if (!PLR_FLAGGED(vict, PLR_FROZEN)) {
	send_to_char("Sorry, your victim is not morbidly encased in ice at the moment.\r\n", ch);
	return;
      }
      if (GET_FREEZE_LEV(vict) > GET_LEVEL(ch)) {
	sprintf(buf, "Sorry, a level %d God froze %s... you can't unfreeze %s.\r\n",
		GET_FREEZE_LEV(vict), GET_NAME(vict), HMHR(vict));
	send_to_char(buf, ch);
	return;
      }
      sprintf(buf, "(GC) %s un-frozen by %s.", GET_NAME(vict), GET_NAME(ch));
      mudlog(buf, BRF, MAX(LVL_GOD, GET_INVIS_LEV(ch)), TRUE);
      REMOVE_BIT(PLR_FLAGS(vict), PLR_FROZEN);
      send_to_char("A fireball suddenly explodes in front of you, melting the ice!\r\nYou feel thawed.\r\n", vict);
      send_to_char("Thawed.\r\n", ch);
      act("A sudden fireball conjured from nowhere thaws $n!", FALSE, vict, 0, 0, TO_PROXIMITY);
      break;
    case SCMD_UNAFFECT:
      if (vict->affected) {
	while (vict->affected)
	  affect_remove(vict, vict->affected);
	send_to_char("There is a brief flash of light!\r\n"
		     "You feel slightly different.\r\n", vict);
	send_to_char("All spells removed.\r\n", ch);
	check_regen_rates(vict);
      } else {
	send_to_char("Your victim does not have any affections!\r\n", ch);
	return;
      }
      break;
    default:
      log("SYSERR: Unknown subcmd passed to do_wizutil (act.wizard.c)");
      break;
    }
    save_char(vict, NOWHERE);
  }
}


/* single zone printing fn used by "show zone" so it's not repeated in the
   code 3 times ... -je, 4/6/93 */

void print_zone_to_buf(char *bufptr, int zone, int exit_info)
{
  int i, i2, i3;
  char closed[10];

  bufptr[0] = '\0';

  if (zone_table[zone].closed)
    sprintf(closed, "&=rw &n");
  else
    sprintf(closed, "&=gw &n");

  sprintf(bufptr, "%s%4d %s %-35.35s &+BA:&n %3d &+BR:&n %3d &+BM:&n %1d &+BT:&n %5d\r\n",
	  bufptr, zone_table[zone].number, closed, zone_table[zone].name,
	  zone_table[zone].age, zone_table[zone].lifespan,
	  zone_table[zone].reset_mode, zone_table[zone].top);

  if (!exit_info)
    return;

  if (zone_table[zone].kingdom)
    sprintf(bufptr + strlen(bufptr), "&+YControlling Kingdom:&n %s\r\n", kingdom_list[zone_table[zone].kingdom]);

  sprintf(bufptr + strlen(bufptr), "&+YExits:&n\r\n");
  for (i3 = 0, i = real_room(zone_table[zone].number * 100); (i != NOWHERE) && (i <= real_room(zone_table[zone].top)); i++)
    for (i2 = 0; i2 < NUM_OF_DIRS; i2++)
      if (world[i].dir_option[i2]) {
	if ((world[i].dir_option[i2]->to_room == NOWHERE) ||
	(world[world[i].dir_option[i2]->to_room].zone != world[i].zone)) {
	  if (!i3)
	    i3 = 1;
	  if (world[i].dir_option[i2]->to_room <= 1)
	    sprintf(bufptr + strlen(bufptr), " &+Y[&n%5d&+Y](&n%5d&+Y)&n &+R%-5s&n to &+WOUT OF ZONE\r\n",
		    world[i].number, i, dirs[i2]);
	  else
	    sprintf(bufptr + strlen(bufptr),
		    " &+Y[&n%5d&+Y](&n%5d&+Y)&n &+R%-5s&n to &+Y[&+R%3d&n:&+Y%5d&+Y](&n%5d&+Y)&n %s\r\n",
		    world[i].number, i, dirs[i2], world[world[i].dir_option[i2]->to_room].zone,
		    world[world[i].dir_option[i2]->to_room].number, world[i].dir_option[i2]->to_room,
		    world[world[i].dir_option[i2]->to_room].name);
	}
      }
  if (!i3)
    strcat(bufptr, "&+RNONE!&n\r\n");

}


ACMD(do_show)
{
  struct char_file_u vbuf;
  int i, j, k, l, con, d, h, m;
  char *tmstr, self = 0;
  time_t mytime;
  struct char_data *vict;
  struct obj_data *obj;
  char field[MAX_INPUT_LENGTH], value[MAX_INPUT_LENGTH], birth[80];
  extern char *class_abbrevs[];
  extern char *genders[];
  extern int buf_switches, buf_largecount, buf_overflows;
  extern time_t boot_time;
  void show_shops(struct char_data *ch, char *value);
  void hcontrol_list_houses(struct char_data *ch);

  struct show_struct {
    char *cmd;
    char level;
  } fields[] = {
    {
      "nothing", 0
    },				/* 0 */
    {
      "zones", LVL_IMMORT
    },				/* 1 */
    {
      "player", LVL_GOD
    },
    {
      "rent", LVL_GOD
    },
    {
      "stats", LVL_IMMORT
    },
    {
      "errors", LVL_GOD
    },				/* 5 */
    {
      "death", LVL_GOD
    },
    {
      "godrooms", LVL_GOD
    },
    {
      "shops", LVL_IMMORT
    },
    {
      "houses", LVL_GOD
    },
    {
      "memory", LVL_GOD
    },
    {
      "\n", 0
    }
  };

  if (!IS_TRUSTED(ch)) {
    do_pshow(ch, argument, cmd, subcmd);
    return;
  }
  skip_spaces(&argument);

  if (!*argument) {
    strcpy(buf, "Show options:\r\n");
    for (j = 0, i = 1; fields[i].level; i++)
      if (fields[i].level <= GET_LEVEL(ch))
	sprintf(buf, "%s%-15s%s", buf, fields[i].cmd, (!(++j % 5) ? "\r\n" : ""));
    strcat(buf, "\r\n");
    send_to_char(buf, ch);
    return;
  }
  strcpy(arg, two_arguments(argument, field, value));

  for (l = 0; *(fields[l].cmd) != '\n'; l++)
    if (!strncmp(field, fields[l].cmd, strlen(field)))
      break;

  if (GET_LEVEL(ch) < fields[l].level) {
    send_to_char("You are not godly enough for that!\r\n", ch);
    return;
  }
  if (!strcmp(value, "."))
    self = 1;
  buf[0] = '\0';
  switch (l) {
  case 1:			/* zone */
    buf[0] = '\0';
    if (self)
      print_zone_to_buf(buf, world[ch->in_room].zone, TRUE);
    else if (*value && is_number(value)) {
      for (j = atoi(value), i = 0; zone_table[i].number != j && i <= top_of_zone_table; i++);
      if (i <= top_of_zone_table)
	print_zone_to_buf(buf, i, TRUE);
      else {
	send_to_char("That is not a valid zone.\r\n", ch);
	return;
      }

    } else if (*value) {
      for (i = 0; i <= top_of_zone_table; i++) {
	if (zone_table[i].name && isname(value, zone_table[i].name))
	  print_zone_to_buf(buf, i, FALSE);
      }
      send_to_char("Zones matching '", ch);
      send_to_char(value, ch);
      send_to_char("'\r\n", ch);
      send_to_char(buf, ch);

    } else
      for (i = 0; i <= top_of_zone_table; i++) {
	if (zone_table[i].number < 50)
	  continue;
	else if (zone_table[i].number >= 450)
	  break;
	print_zone_to_buf(buf, i, FALSE);
      }
    page_string(ch->desc, buf, 1);
    break;
  case 2:			/* player */
    if (!*value) {
      send_to_char("A name would help.\r\n", ch);
      return;
    }
    if (load_char(value, &vbuf) < 0) {
      send_to_char("There is no such player.\r\n", ch);
      return;
    }
    sprintf(buf, "Player: %-12s (%s) [%2d %s]\r\n", vbuf.name,
    genders[(int) vbuf.sex], vbuf.level, class_abbrevs[(int) vbuf.class]);
    sprintf(buf,
	    "%sExp: %-8d  Align: FIXME!\r\n",
	    buf, vbuf.points.exp	/*,
					   alignment_types[GET_ALIGNMENT(vbuf)] */ );
    strcpy(birth, ctime(&vbuf.birth));
    sprintf(buf,
	    "%sStarted: %-20.16s  Last: %-20.16s  Played: %3dh %2dm\r\n",
	 buf, birth, ctime(&vbuf.last_logon), (int) (vbuf.played / 3600),
	    (int) (vbuf.played / 60 % 60));
    send_to_char(buf, ch);
    break;
  case 3:
    Crash_listrent(ch, value);
    break;
  case 4:
    i = 0;
    j = 0;
    k = 0;
    con = 0;
    mytime = time(0) - boot_time;
    tmstr = (char *) asctime(localtime(&boot_time));
    *(tmstr + strlen(tmstr) - 1) = '\0';
    d = mytime / 86400;
    h = (mytime / 3600) % 24;
    m = (mytime / 60) % 60;
    /* sheesh, now thats a lot of initializing :) */
    for (vict = character_list; vict; vict = vict->next) {
      if (IS_NPC(vict))
	j++;
      else if (CAN_SEE(ch, vict)) {
	i++;
	if (vict->desc)
	  con++;
      }
    }
    for (obj = object_list; obj; obj = obj->next)
      k++;
    sprintf(buf, "Current stats:\r\n");
    sprintf(buf, "%s  %5d players in game  %5d connected\r\n", buf, i, con);
    sprintf(buf, "%s  %5d registered\r\n", buf, top_of_p_table + 1);
    sprintf(buf, "%s  %5d mobiles          %5d prototypes\r\n",
	    buf, j, top_of_mobt + 1);
    sprintf(buf, "%s  %5d objects          %5d prototypes\r\n",
	    buf, k, top_of_objt + 1);
    sprintf(buf, "%s  %5d rooms            %5d zones\r\n",
	    buf, top_of_world + 1, top_of_zone_table + 1);
    sprintf(buf, "%s  %5ld coordinates\r\n",
	    buf, top_of_grid_count);
    sprintf(buf, "%s  %5dk total bytes sent across net\r\n", buf, total_bytes_written / 1024);
    sprintf(buf, "%s  %5d large bufs\r\n", buf, buf_largecount);
    sprintf(buf, "%s  %5d buf switches     %5d overflows\r\n", buf,
	    buf_switches, buf_overflows);
    sprintf(buf, "%s  Up since %s: %d day%s, %d:%02d\r\n", buf, tmstr, d,
	    ((d == 1) ? "" : "s"), h, m);
    send_to_char(buf, ch);
    break;
  case 5:
    strcpy(buf, "Errant Rooms\r\n------------\r\n(contain map errors)\r\n");
    for (i = 0; i <= top_of_world; i++)
      if (world[i].map)
	for (j = 0; j < world[i].x_size; j++)
	  for (k = 0; k < world[i].y_size; k++)
	    if (world[i].map->map_grid[j][k] >= MAP_ERROR) {
	      sprintf(buf, "%s%2d: [%5d] %s\r\n", buf, ++k, world[i].number,
		      world[i].name);
	      /*  break; */
	    }
#if 0
    strcpy(buf, "Errant Objs\r\n------------\r\n(contain bad copyof vnums)\r\n");
    for (i = 0; i < top_of_objt; i++)
      if (obj_index[i].obj_flags.orig_vnum <= 0)
	sprintf(buf, "%s%2d: %s\r\n", buf, obj_index[i].virtual, obj_index[i].description);
#endif
    page_string(ch->desc, buf, 1);
    break;
  case 6:
    strcpy(buf, "Death Traps\r\n-----------\r\n");
    for (i = 0, j = 0; i <= top_of_world; i++)
      if (IS_SET(ROOM_FLAGS(i), ROOM_DEATH))
	sprintf(buf, "%s%2d: [%5d] %s\r\n", buf, ++j,
		world[i].number, world[i].name);
    page_string(ch->desc, buf, 1);
    break;
  case 7:
    strcpy(buf, "Godrooms\r\n--------------------------\r\n");
    for (i = 0, j = 0; i < top_of_world; i++)
      if (ROOM_FLAGGED(i, ROOM_GODROOM))
	sprintf(buf, "%s%2d: [%5d] %s\r\n", buf, ++j, world[i].number, world[i].name);
    page_string(ch->desc, buf, 1);
    break;
  case 8:
    show_shops(ch, value);
    break;
  case 9:
    hcontrol_list_houses(ch);
    break;
  case 10:
    show_mreport(ch);
    break;
  default:
    send_to_char("Sorry, I don't understand that.\r\n", ch);
    break;
  }
}


/***************** The do_set function ***********************************/

#define PC   1
#define NPC  2
#define BOTH 3
#define ROOM 4
#define SET_ALL 5

#define MISC	0
#define BINARY	1
#define NUMBER	2

#define SET_OR_REMOVE(flagset, flags) { \
	if (on) SET_BIT(flagset, flags); \
	else if (off) REMOVE_BIT(flagset, flags); }

#define RANGE(low, high) (value = MAX((low), MIN((high), (value))))


/* The set options available */
struct set_struct {
  char *cmd;
  char level;
  char pcnpc;
  char type;
} set_fields[] = {

  {
    "olc", LVL_GOD6, PC, NUMBER
  },				/* 0 */
  {
    "invstart", LVL_GRGOD, PC, BINARY
  },				/* 1 */
  {
    "title", LVL_GRGOD, PC, MISC
  },
  {
    "maxhit", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "hit", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "align", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "str", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "stradd", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "int", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "wis", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "dex", LVL_GRGOD, BOTH, NUMBER
  },				/* 10 */
  {
    "con", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "cha", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "ac", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "exp", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "hitroll", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "damroll", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "invis", LVL_IMPL, PC, NUMBER
  },
  {
    "nohassle", LVL_GRGOD, PC, BINARY
  },
  {
    "frozen", LVL_FREEZE, PC, BINARY
  },
  {
    "drunk", LVL_GRGOD, BOTH, MISC
  },				/* 20 */
  {
    "hunger", LVL_GRGOD, BOTH, MISC
  },
  {
    "thirst", LVL_GRGOD, BOTH, MISC
  },
  {
    "level", LVL_IMPL, BOTH, NUMBER
  },
  {
    "room", LVL_IMPL, BOTH, NUMBER
  },
  {
    "roomflag", LVL_GRGOD, PC, BINARY
  },
  {
    "siteok", LVL_GRGOD, PC, BINARY
  },
  {
    "deleted", LVL_IMPL, PC, BINARY
  },
  {
    "class", LVL_GRGOD, BOTH, MISC
  },
  {
    "nowizlist", LVL_GRGOD, PC, BINARY
  },
  {
    "loadroom", LVL_GRGOD, PC, MISC
  },				/* 30 */
  {
    "idnum", LVL_IMPL, PC, NUMBER
  },
  {
    "passwd", LVL_IMPL, PC, MISC
  },
  {
    "nodelete", LVL_GRGOD, PC, BINARY
  },
  {
    "sex", LVL_GRGOD, BOTH, MISC
  },
  {
    "olc", LVL_IMPL, PC, NUMBER
  },
  {
    "xcord", LVL_GOD4, BOTH, NUMBER
  },
  {
    "ycord", LVL_GOD4, BOTH, NUMBER
  },
  {
    "race", LVL_GRGOD, BOTH, MISC
  },
  {
    "gold", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "zcord", LVL_GOD4, BOTH, NUMBER
  },				/* 40 */
  {
    "size", LVL_GRGOD, BOTH, NUMBER
  },
  {
    "symbol", LVL_GOD2, ROOM, NUMBER
  },
  {
    "current_dir", LVL_GOD2, ROOM, MISC
  },
  {
    "current_speed", LVL_GOD2, ROOM, NUMBER
  },
  {
    "\n", 0, SET_ALL, MISC
  }
};


int perform_set(struct char_data *ch, struct char_data *vict, int mode,
		char *val_arg)
{
  int i, on = 0, off = 0, value = 0;
  char output[MAX_STRING_LENGTH];
  int parse_class(struct char_data *ch, char arg);

  /* Check to make sure all the levels are correct */
  if (GET_LEVEL(ch) != LVL_IMPL) {
    if (!IS_NPC(vict) && GET_LEVEL(ch) <= GET_LEVEL(vict) && vict != ch) {
      send_to_char("Maybe that's not such a great idea...\r\n", ch);
      return 0;
    }
  }
  if (GET_LEVEL(ch) < set_fields[mode].level) {
    send_to_char("You are not godly enough for that!\r\n", ch);
    return 0;
  }
  /* Make sure the PC/NPC is correct */
  if (IS_NPC(vict) && !(set_fields[mode].pcnpc & NPC)) {
    send_to_char("You can't do that to a beast!\r\n", ch);
    return 0;
  } else if (!IS_NPC(vict) && !(set_fields[mode].pcnpc & PC)) {
    send_to_char("That can only be done to a beast!\r\n", ch);
    return 0;
  }
  /* Find the value of the argument */
  if (set_fields[mode].type == BINARY) {
    if (!strcmp(val_arg, "on") || !strcmp(val_arg, "yes"))
      on = 1;
    else if (!strcmp(val_arg, "off") || !strcmp(val_arg, "no"))
      off = 1;
    if (!(on || off)) {
      send_to_char("Value must be 'on' or 'off'.\r\n", ch);
      return 0;
    }
    sprintf(output, "%s %s for %s.", set_fields[mode].cmd, ONOFF(on),
	    GET_NAME(vict));
  } else if (set_fields[mode].type == NUMBER) {
    value = atoi(val_arg);
    sprintf(output, "%s's %s set to %d.", GET_NAME(vict),
	    set_fields[mode].cmd, value);
  } else {
    strcpy(output, "Okay.");	/* can't use OK macro here 'cause of \r\n */
  }

  one_argument(val_arg, buf1);

  switch (mode) {
  case 0:
    GET_OLC_ZONE(vict) = RANGE(1, 500);
    break;
  case 1:
    SET_OR_REMOVE(PLR_FLAGS(vict), PLR_INVSTART);
    break;
  case 2:
    set_title(vict, val_arg);
    sprintf(output, "%s's title is now: %s", GET_NAME(vict), GET_TITLE(vict));
    break;
  case 3:
    vict->points.max_hit = RANGE(1, 5000);
    affect_total(vict);		/* affect_total() handles regen updates */
    break;
  case 4:
    vict->points.hit = RANGE(-9, vict->points.max_hit);
    affect_total(vict);		/* affect_total() handles regen updates */
    break;
  case 5:
    SET_ALIGNMENT(vict, RANGE(1, 9));
    affect_total(vict);
    break;
  case 6:
    if (IS_NPC(vict) || GET_LEVEL(vict) >= LVL_GRGOD)
      RANGE(3, 25);
    else
      RANGE(3, 18);
    vict->real_abils.str = value;
    vict->real_abils.str_add = 0;
    affect_total(vict);
    break;
  case 7:
    vict->real_abils.str_add = RANGE(0, 100);
    if (value > 0)
      vict->real_abils.str = 18;
    affect_total(vict);
    break;
  case 8:
    if (IS_NPC(vict) || GET_LEVEL(vict) >= LVL_GRGOD)
      RANGE(3, 25);
    else
      RANGE(3, 18);
    vict->real_abils.intel = value;
    affect_total(vict);
    break;
  case 9:
    if (IS_NPC(vict) || GET_LEVEL(vict) >= LVL_GRGOD)
      RANGE(3, 25);
    else
      RANGE(3, 18);
    vict->real_abils.wis = value;
    affect_total(vict);
    break;
  case 10:
    if (IS_NPC(vict) || GET_LEVEL(vict) >= LVL_GRGOD)
      RANGE(3, 25);
    else
      RANGE(3, 18);
    vict->real_abils.dex = value;
    affect_total(vict);
    break;
  case 11:
    if (IS_NPC(vict) || GET_LEVEL(vict) >= LVL_GRGOD)
      RANGE(3, 25);
    else
      RANGE(3, 18);
    vict->real_abils.con = value;
    affect_total(vict);
    break;
  case 12:
    if (IS_NPC(vict) || GET_LEVEL(vict) >= LVL_GRGOD)
      RANGE(3, 25);
    else
      RANGE(3, 18);
    vict->real_abils.cha = value;
    affect_total(vict);
    break;
  case 13:
    vict->points.armor = RANGE(-10, 10);
    affect_total(vict);
    break;
  case 14:
    vict->points.exp = RANGE(0, 50000000);
    break;
  case 15:
    vict->points.hitroll = RANGE(-20, 20);
    affect_total(vict);
    break;
  case 16:
    vict->points.damroll = RANGE(-20, 20);
    affect_total(vict);
    break;
  case 17:
    if (GET_LEVEL(ch) < LVL_IMPL && ch != vict) {
      send_to_char("You aren't godly enough for that!\r\n", ch);
      return 0;
    }
    GET_INVIS_LEV(vict) = RANGE(0, GET_LEVEL(vict));
    break;
  case 18:
    if (GET_LEVEL(ch) < LVL_IMPL && ch != vict) {
      send_to_char("You aren't godly enough for that!\r\n", ch);
      return 0;
    }
    SET_OR_REMOVE(PRF_FLAGS(vict), PRF_NOHASSLE);
    break;
  case 19:
    if (ch == vict) {
      send_to_char("Better not -- could be a long winter!\r\n", ch);
      return 0;
    }
    SET_OR_REMOVE(PLR_FLAGS(vict), PLR_FROZEN);
    break;
  case 20:
  case 21:
  case 22:
    if (!str_cmp(val_arg, "off")) {
      GET_COND(vict, (mode - 20)) = -1;		/* warning: magic number here */
      sprintf(output, "%s's %s now off.", GET_NAME(vict), set_fields[mode].cmd);
    } else if (is_number(val_arg)) {
      value = atoi(val_arg);
      RANGE(0, 24);
      GET_COND(vict, (mode - 20)) = (char) value;	/* and here too */
      sprintf(output, "%s's %s set to %d.", GET_NAME(vict),
	      set_fields[mode].cmd, value);
    } else {
      send_to_char("Must be 'off' or a value from 0 to 24.\r\n", ch);
      return 0;

    }
    check_regen_rates(vict);
    break;
  case 23:
    if (value > GET_LEVEL(ch) || value > LVL_IMPL) {
      send_to_char("You can't do that.\r\n", ch);
      return 0;
    }
    RANGE(0, LVL_IMPL);
    vict->player.level = (byte) value;
    break;
  case 24:
    if ((i = real_room(value)) < 0) {
      send_to_char("No room exists with that number.\r\n", ch);
      return 0;
    }
    char_from_room(vict);
    char_to_room(vict, i, -1);
    break;
  case 25:
    SET_OR_REMOVE(PRF_FLAGS(vict), PRF_ROOMFLAGS);
    break;
  case 26:
    SET_OR_REMOVE(PLR_FLAGS(vict), PLR_SITEOK);
    break;
  case 27:
    SET_OR_REMOVE(PLR_FLAGS(vict), PLR_DELETED);
    break;
  case 28:
    if (!is_number(buf1)) {
      CAP(buf1);
      if ((i = search_block(buf1, class_types, FALSE)) == -1) {
	sprintf(buf, "%s is not a valid class at this time.\r\n", buf1);
	send_to_char(buf, ch);
	return 0;
      }
    } else {
      i = atoi(val_arg);
    }
    GET_CLASS(vict) = i;
    check_regen_rates(vict);
    break;
  case 29:
    SET_OR_REMOVE(PLR_FLAGS(vict), PLR_NOWIZLIST);
    break;
  case 30:
    if (!str_cmp(val_arg, "off")) {
      REMOVE_BIT(PLR_FLAGS(vict), PLR_LOADROOM);
    } else if (is_number(val_arg)) {
      value = atoi(val_arg);
      if (real_room(value) != NOWHERE) {
	SET_BIT(PLR_FLAGS(vict), PLR_LOADROOM);
	GET_LOADROOM(vict) = value;
	sprintf(output, "%s will enter at room #%d.", GET_NAME(vict),
		GET_LOADROOM(vict));
      } else {
	send_to_char("That room does not exist!\r\n", ch);
	return 0;
      }
    } else {
      send_to_char("Must be 'off' or a room's virtual number.\r\n", ch);
      return 0;
    }
    break;
  case 31:
    if (GET_IDNUM(ch) != 1 || !IS_NPC(vict))
      return 0;
    GET_IDNUM(vict) = value;
    break;
  case 32:
    if (GET_IDNUM(ch) > 1) {
      send_to_char("Please don't use this command, yet.\r\n", ch);
      return 0;
    }
    if (GET_LEVEL(vict) >= LVL_GRGOD) {
      send_to_char("You cannot change that.\r\n", ch);
      return 0;
    }
    strncpy(GET_PASSWD(vict), CRYPT(val_arg, GET_NAME(vict)), MAX_PWD_LENGTH);
    *(GET_PASSWD(vict) + MAX_PWD_LENGTH) = '\0';
    sprintf(output, "Password changed to '%s'.", val_arg);
    break;
  case 33:
    SET_OR_REMOVE(PLR_FLAGS(vict), PLR_NODELETE);
    break;
  case 34:
    if (!str_cmp(val_arg, "male"))
      vict->player.sex = SEX_MALE;
    else if (!str_cmp(val_arg, "female"))
      vict->player.sex = SEX_FEMALE;
    else if (!str_cmp(val_arg, "neutral"))
      vict->player.sex = SEX_NEUTRAL;
    else {
      send_to_char("Must be 'male', 'female', or 'neutral'.\r\n", ch);
      return 0;
    }
    break;
  case 35:
    GET_OLC_ZONE(vict) = value;
    break;
  case 36:
    GET_X_CORD(vict) = value;
    break;
  case 37:
    GET_Y_CORD(vict) = value;
    break;
  case 38:
    CAP(buf1);
    if ((i = search_block(buf1, race_types, FALSE)) == -1) {
      sprintf(buf, "%s is not a valid race at this time.\r\n", buf1);
      send_to_char(buf, ch);
      return 0;
    }
    sprintf(output, "race changed to %s", buf1);
    GET_RACE(vict) = i;
    break;
  case 39:
    vict->points.gold = value;
    break;
  case 40:
    GET_Z_CORD(vict) = value;
    break;
  case 41:
    GET_SIZE(vict) = value;
    break;
  case 42:
  case 43:
  case 44:
    /* this is a room command */
    break;
  default:
    send_to_char("Can't set that!\r\n", ch);
    return 0;
    break;
  }

  strcat(output, "\r\n");
  send_to_char(CAP(output), ch);
  return 1;
}

int perform_room_set(struct char_data *ch, int room_rnum, int mode, char *val_arg)
{
  int on = 0, off = 0, value = 0;
  int room_vnum, i;
  char output[MAX_STRING_LENGTH];

  room_vnum = world[ch->in_room].number;

  /* Check to make sure all the levels are correct */
  if (GET_LEVEL(ch) < set_fields[mode].level) {
    send_to_char("You are not godly enough for that!\r\n", ch);
    return 0;
  }
  /* Make sure the PC/NPC is correct */
  if (!(set_fields[mode].pcnpc & ROOM) && !(set_fields[mode].pcnpc & SET_ALL)) {
    sprintf(buf, "Serious error in perform_room_set()!\r\nMode = %d\r\n", mode);
    send_to_char(buf, ch);
/*    return 0; */
  }
  /* Find the value of the argument */
  if (set_fields[mode].type == BINARY) {
    if (!strcmp(val_arg, "on") || !strcmp(val_arg, "yes"))
      on = 1;
    else if (!strcmp(val_arg, "off") || !strcmp(val_arg, "no"))
      off = 1;
    if (!(on || off)) {
      send_to_char("Value must be 'on' or 'off'.\r\n", ch);
      return 0;
    }
    sprintf(output, "%s %s for %d.", set_fields[mode].cmd, ONOFF(on), room_vnum);
  } else if (set_fields[mode].type == NUMBER) {
    value = atoi(val_arg);
    sprintf(output, "%d %s set to %d.", room_vnum,
	    set_fields[mode].cmd, value);
  } else {
    strcpy(output, "Okay.");	/* can't use OK macro here 'cause of \r\n */
  }
  one_argument(val_arg, buf1);

  switch (mode) {
    /* dont forget to add these to the player version, as blanks */
  case 42:
    if (world[ch->in_room].shape != ROOM_SHAPE_PCMAP && world[ch->in_room].shape != ROOM_SHAPE_WILDERNESS) {
      send_to_char("You may only altar the symbols of maprooms. (This one is an olc shape)\r\n", ch);
      return 0;
    }
    if (value < 0 || value > NUM_MAP_SYMBOLS) {
      send_to_char("You must supply a valid icon number!\r\n", ch);
      return 0;
    }
    if (value == 0) {
      send_to_char("Don't use BLANK please, its reserved for code. You may use NOTBLANK instead if you so wish.\r\n", ch);
      return 0;
    }
    if (world[ch->in_room].map && world[ch->in_room].map->map_grid[GET_X_CORD(ch)][GET_Y_CORD(ch)]) {
      world[ch->in_room].map->map_grid[GET_X_CORD(ch)][GET_Y_CORD(ch)] = value;
    } else {
      send_to_char("Odd, this room has no map structure!\r\n", ch);
      return 0;
    }
    olc_add_to_save_list(zone_table[world[ch->in_room].zone].number, OLC_SAVE_ROOM);
    break;
  case 43:
    if ((i = search_block(buf1, dirs, FALSE)) == -1) {
      send_to_char("That's not a direction.\r\n", ch);
      return 0;
    }
    sprintf(output, "Current direction changed to %s", buf1);
    world[room_rnum].current_direction = i;
    break;
  case 44:
    if (value < 1 || value > 100) {
      send_to_char("Value must be between 1-100.\r\n", ch);
      return 0;
    }
    world[room_rnum].current_speed = value;
    break;
  default:
    send_to_char("Can't set that!\r\n", ch);
    return 0;
    break;
  }

  strcat(output, "\r\n");
  send_to_char(CAP(output), ch);
  return 1;

}

ACMD(do_set)
{
  struct char_data *vict = NULL, *cbuf = NULL;
  struct char_file_u tmp_store;
  char field[MAX_INPUT_LENGTH], name[MAX_INPUT_LENGTH], val_arg[MAX_INPUT_LENGTH];
  int mode = -1, len = 0, player_i = 0, retval, rnumber;
  char is_file = 0, is_mob = 0, is_player = 0, is_room = 0;

  half_chop(argument, name, buf);

  if (!strcmp(name, "file")) {
    is_file = 1;
    half_chop(buf, name, buf);
  } else if (!str_cmp(name, "room")) {
    is_room = 1;
    half_chop(buf, name, buf);
  } else if (!str_cmp(name, "player")) {
    is_player = 1;
    half_chop(buf, name, buf);
  } else if (!str_cmp(name, "mob")) {
    is_mob = 1;
    half_chop(buf, name, buf);
  }
  half_chop(buf, field, buf);
  strcpy(val_arg, buf);

  if (!*name || !*field) {
    send_to_char("Usage: set <victim> <field> <value>\r\n", ch);
    return;
  }
  /* find the target */
  if (!is_file && !is_room) {
    if (is_player) {
      if (!(vict = get_player_vis(ch, name, 0))) {
	send_to_char("There is no such player.\r\n", ch);
	return;
      }
    } else {
      if (!(vict = get_char_vis(ch, name))) {
	send_to_char("There is no such creature.\r\n", ch);
	return;
      }
    }
  } else if (is_file) {
    /* try to load the player off disk */
    CREATE(cbuf, struct char_data, 1);
    clear_char(cbuf);
    if ((player_i = load_char(name, &tmp_store)) > -1) {
      store_to_char(&tmp_store, cbuf);
      if (GET_LEVEL(cbuf) >= GET_LEVEL(ch)) {
	free_char(cbuf);
	send_to_char("Sorry, you can't do that.\r\n", ch);
	return;
      }
      vict = cbuf;
    } else {
      FREE(cbuf);
      send_to_char("There is no such player.\r\n", ch);
      return;
    }
  }
  /* find the command in the list */
  len = strlen(field);
  for (mode = 0; *(set_fields[mode].cmd) != '\n'; mode++)
    if (!strncmp(field, set_fields[mode].cmd, len))
      break;

  /* perform the set */
  if (is_room) {
/*    if (isdigit(name))
   rnumber = real_room(atoi(name));
   else */
    rnumber = ch->in_room;
    perform_room_set(ch, rnumber, mode, val_arg);
    return;
  }
  retval = perform_set(ch, vict, mode, val_arg);

  /* save the character if a change was made */
  if (retval) {
    if (!is_file && !IS_NPC(vict))
      save_char(vict, NOWHERE);
    if (is_file) {
      char_to_store(vict, &tmp_store);
      fseek(player_fl, (player_i) * sizeof(struct char_file_u), SEEK_SET);
      fwrite(&tmp_store, sizeof(struct char_file_u), 1, player_fl);
      send_to_char("Saved in file.\r\n", ch);
    }
  }
  /* free the memory if we allocated it earlier */
  if (is_file)
    free_char(cbuf);
}

ACMD(do_liblist)
{
  extern struct room_data *world;
  extern struct index_data *mob_index;
  extern struct char_data *mob_proto;
  extern struct index_data *obj_index;
  extern struct obj_data *obj_proto;
  extern int top_of_objt;
  extern int top_of_mobt;
  extern int top_of_world;

  int first = 0, last = 99, nr, found = 0;

  two_arguments(argument, buf, buf2);

  if (*buf)
    first = atoi(buf);
  else
    first = world[ch->in_room].zone * 100;
  if (*buf2)
    last = atoi(buf2);
  else
    last = first + 99;

  if ((first < 0) || (first > 999999) || (last < 0) || (last > 999999)) {
    send_to_char("Values must be between 0 and 999999.\n\r", ch);
    return;
  }
  if (first >= last) {
    send_to_char("Second value must be greater than first.\n\r", ch);
    return;
  }
  /* keep list managable */
  if (last - first > 5000)
    last = first + 5000;

  switch (subcmd) {
  case SCMD_SLIST:
    list_all_shops(ch);
    return;
    break;
  case SCMD_RLIST:
    sprintf(buf, "Room List From Vnum %d to %d\r\n", first, last);
    for (nr = 0; nr <= top_of_world && (world[nr].number <= last); nr++) {
      if (world[nr].number >= first) {
	if (strlen(buf) > MAX_STRING_LENGTH - 50) {
	  sprintf(buf, "%s\r\n...and the list goes on...\r\n", buf);
	  break;
	} else {
	  sprintf(buf, "%s%5d. [%5d] (%3d) %s\r\n", buf, ++found,
		  world[nr].number, world[nr].zone,
		  world[nr].name);
	}
      }
    }
    break;
  case SCMD_OLIST:
    sprintf(buf, "Object List From Vnum %d to %d\r\n", first, last);
    for (nr = 0; nr <= top_of_objt && (obj_index[nr].virtual <= last); nr++) {
      if (obj_index[nr].virtual >= first) {
	if (strlen(buf) > MAX_STRING_LENGTH - 50) {
	  sprintf(buf, "%s\r\n...and the list goes on...\r\n", buf);
	  break;
	} else {
	  sprintf(buf, "%s%5d. [%5d] %s\r\n", buf, ++found,
		  obj_index[nr].virtual,
		  obj_proto[nr].short_description);
	}
      }
    }
    break;
  case SCMD_MLIST:
    sprintf(buf, "Mob List From Vnum %d to %d\r\n", first, last);
    for (nr = 0; nr <= top_of_mobt && (mob_index[nr].virtual <= last); nr++) {
      if (mob_index[nr].virtual >= first) {
	if (strlen(buf) > MAX_STRING_LENGTH - 50) {
	  sprintf(buf, "%s\r\n...and the list goes on...\r\n", buf);
	  break;
	} else {
	  sprintf(buf, "%s%5d. [%5d] %s\r\n", buf, ++found,
		  mob_index[nr].virtual,
		  mob_proto[nr].player.short_descr);
	}
      }
    }
    break;
  default:
    sprintf(buf, "SYSERR:: invalid SCMD passed to ACMDdo_build_list!");
    mudlog(buf, BRF, LVL_GOD, TRUE);
    return;
  }

  if (!found) {
    switch (subcmd) {
    case SCMD_RLIST:
      send_to_char("No rooms found within those parameters.\r\n", ch);
      break;
    case SCMD_OLIST:
      send_to_char("No objects found within those parameters.\r\n", ch);
      break;
    case SCMD_MLIST:
      send_to_char("No mobiles found within those parameters.\r\n", ch);
      break;
    case SCMD_SLIST:
      send_to_char("No shops found within those parameters.\r\n", ch);
      break;
    default:
      sprintf(buf, "SYSERR:: invalid SCMD passed to do_build_list!");
      mudlog(buf, BRF, LVL_GOD, TRUE);
      break;
    }
    return;
  }
  page_string(ch->desc, buf, 1);
}

ACMD(do_copyto)
{
  extern void olc_add_to_save_list(int zone, byte type);

  char buf[80];
  int iroom = 0, rroom = 0, x, y, c;
  struct room_data *room;

  two_arguments(argument, buf1, buf2);
  /* buf2 is room to copy to */

  CREATE(room, struct room_data, 1);

  iroom = atoi(buf2);
  rroom = real_room(atoi(buf2));
  *room = world[rroom];

  if (!*buf1 || !*buf2) {
    send_to_char("Format: copy <desc|title|map|flags|all> <to number>\r\n", ch);
    return;
  }
  if (rroom <= 0) {
    sprintf(buf, "There is no room with the number %d.\r\n", iroom);
    send_to_char(buf, ch);
    return;
  }
/* Main stuff */

  if (!str_cmp("desc", buf1) || !str_cmp("all", buf1)) {
    if (world[ch->in_room].description) {
      world[rroom].description = str_dup(world[ch->in_room].description);
      olc_add_to_save_list((iroom / 100), OLC_SAVE_ROOM);
      sprintf(buf, "You copy the description to room %d.\r\n", iroom);
      send_to_char(buf, ch);
    } else {
      send_to_char("This room has no description!\r\n", ch);
    }
  }
  if (!str_cmp("title", buf1) || !str_cmp("all", buf1)) {
    if (world[ch->in_room].name) {
      world[rroom].name = str_dup(world[ch->in_room].name);
      olc_add_to_save_list((iroom / 100), OLC_SAVE_ROOM);
      sprintf(buf, "You copy the title to room %d.\r\n", iroom);
      send_to_char(buf, ch);
    } else {
      send_to_char("This room has no title!\r\n", ch);
    }
  }
  if (!str_cmp("flags", buf1) || !str_cmp("all", buf1)) {
    world[rroom].room_flags = world[ch->in_room].room_flags;
    olc_add_to_save_list((iroom / 100), OLC_SAVE_ROOM);
    sprintf(buf, "You copy the room flags to room %d.\r\n", iroom);
    send_to_char(buf, ch);
  }
  if (!str_cmp("map", buf1) /* || !str_cmp("all", buf1) */ ) {
    world[rroom].x_size = world[ch->in_room].x_size;
    world[rroom].y_size = world[ch->in_room].y_size;
    world[rroom].z_size = world[ch->in_room].z_size;
    if (world[ch->in_room].map) {
      if (world[rroom].map == NULL) {
	CREATE(world[rroom].map, struct map_data, 1);
#ifdef NEWMAP
	CREATE(world[rroom].map->map_grid, sh_int *, world[rroom].x_size + 1);
	for (c = 0; c < world[rroom].x_size + 1; c++)
	  CREATE(world[rroom].map->map_grid[c], sh_int, world[rroom].y_size + 1);
#endif
      }
      for (x = 0; x < world[rroom].x_size; x++) {
	for (y = 0; y < world[rroom].y_size; y++) {
	  world[rroom].map->map_grid[x][y] = world[ch->in_room].map->map_grid[x][y];
	}
      }
      olc_add_to_save_list((iroom / 100), OLC_SAVE_ROOM);
      sprintf(buf, "You copy the rooms map to room %d.\r\n", iroom);
      send_to_char(buf, ch);
    } else
      send_to_char("But this room doesnt have a map to copy from!\r\n", ch);
  }
}


ACMD(do_connect)
{
  extern void olc_add_to_save_list(int zone, byte type);

  char buf3[10];
  char buf[80];
  int iroom = 0, rroom = 0;
  int dir = 0, odir = 0, xdoor = 0, ydoor = 0;

  two_arguments(argument, buf2, buf3);
  /* buf2 is the direction, buf3 is the room */

  iroom = atoi(buf3);
  rroom = real_room(iroom);

  if (!*buf2) {
    send_to_char("Format: connect <dir> <room number>\r\n", ch);
    return;
  } else if (!*buf3) {
    send_to_char("Format: connect <dir> <room number>\r\n", ch);
    return;
  }
  if (rroom <= 0) {
    sprintf(buf, "There is no room with the number %d", iroom);
    send_to_char(buf, ch);
    return;
  }
/* Main stuff */
  switch (*buf2) {
  case 'n':
  case 'N':
    dir = NORTH;
    break;
  case 'e':
  case 'E':
    dir = EAST;
    break;
  case 's':
  case 'S':
    dir = SOUTH;
    break;
  case 'w':
  case 'W':
    dir = WEST;
    break;
  case 'u':
  case 'U':
    dir = UP;
    break;
  case 'd':
  case 'D':
    dir = DOWN;
    break;
  }

  odir = rev_dir[dir];
  switch (odir) {
  case NORTH:
    xdoor = 0;
    ydoor = world[rroom].y_size / 2;
    break;
  case EAST:
    xdoor = world[rroom].x_size / 2;
    ydoor = world[rroom].y_size - 1;
    break;
  case SOUTH:
    xdoor = world[rroom].x_size - 1;
    ydoor = world[rroom].y_size / 2;
    break;
  case WEST:
    xdoor = world[rroom].x_size / 2;
    ydoor = 0;
    break;
  default:
    send_to_char("Invalid direction given!\r\n", ch);
    return;
    break;
  }
  if (!world[rroom].dir_option[rev_dir[dir]]) {
    CREATE(world[rroom].dir_option[rev_dir[dir]], struct room_direction_data, 1);
    world[rroom].dir_option[rev_dir[dir]]->general_description = NULL;
    world[rroom].dir_option[rev_dir[dir]]->keyword = NULL;
    world[rroom].dir_option[rev_dir[dir]]->to_room = ch->in_room;
    world[rroom].dir_option[rev_dir[dir]]->x_cord = xdoor;
    world[rroom].dir_option[rev_dir[dir]]->y_cord = ydoor;
    world[rroom].dir_option[rev_dir[dir]]->z_cord = 0;
  }
  switch (dir) {
  case NORTH:
    xdoor = 0;
    ydoor = world[ch->in_room].y_size / 2;
    break;
  case EAST:
    xdoor = world[ch->in_room].x_size / 2;
    ydoor = world[ch->in_room].y_size - 1;
    break;
  case SOUTH:
    xdoor = world[ch->in_room].x_size - 1;
    ydoor = world[ch->in_room].y_size / 2;
    break;
  case WEST:
    xdoor = world[ch->in_room].x_size / 2;
    ydoor = 0;
    break;
  default:
    send_to_char("Invalid direction given!\r\n", ch);
    return;
    break;
  }
  if (!world[ch->in_room].dir_option[dir]) {
    CREATE(world[ch->in_room].dir_option[dir], struct room_direction_data, 1);
    world[ch->in_room].dir_option[dir]->general_description = NULL;
    world[ch->in_room].dir_option[dir]->keyword = NULL;
    world[ch->in_room].dir_option[dir]->to_room = rroom;
    world[ch->in_room].dir_option[dir]->x_cord = xdoor;
    world[ch->in_room].dir_option[dir]->y_cord = ydoor;
    world[ch->in_room].dir_option[dir]->z_cord = 0;
  }
  olc_add_to_save_list((iroom / 100), OLC_SAVE_ROOM);

  sprintf(buf, "You create an exit %s to room %d.\r\n", buf2, iroom);
  send_to_char(buf, ch);
}

ACMD(do_playerlog)
{
  FILE *f;

  if (!*argument) {
    send_to_char("Need playername.", ch);
    return;
  }
  sprintf(buf, "egrep '%s' ../syslog > playercheck ; egrep '%s' =../log/* >> playercheck",
	  CAP(argument), CAP(argument));
  system(buf);

  f = fopen("playercheck", "r");
  fread(buf, MAX_STRING_LENGTH - 5, 1, f);
  buf[MAX(0, ftell(f))] = 0;
  fclose(f);

  send_to_char(OK, ch);
  page_string(ch->desc, buf, 1);
}

struct grantset_struct grant_fields[] =
{
  {
    "level", LVL_IMPL, PC, BINARY, BIT_1
  },				/* 0 */
  {
    "ban", LVL_IMPL, PC, BINARY, BIT_2
  },
  {
    "dc", LVL_IMPL, PC, BINARY, BIT_3
  },
  {
    "force", LVL_IMPL, PC, BINARY, BIT_4
  },
  {
    "freeze", LVL_IMPL, PC, BINARY, BIT_5
  },
  {
    "hcontrol", LVL_IMPL, PC, BINARY, BIT_6
  },
  {
    "load", LVL_IMPL, PC, BINARY, BIT_7
  },
  {
    "pardon", LVL_IMPL, PC, BINARY, BIT_8
  },
  {
    "purge", LVL_IMPL, PC, BINARY, BIT_9
  },
  {
    "set", LVL_IMPL, PC, BINARY, BIT_10
  },
  {
    "shutdown", LVL_IMPL, PC, BINARY, BIT_11
  },
  {
    "skillset", LVL_IMPL, PC, BINARY, BIT_12
  },
  {
    "snoop", LVL_IMPL, PC, BINARY, BIT_13
  },
  {
    "stat", LVL_IMPL, PC, BINARY, BIT_14
  },
  {
    "unaffect", LVL_IMPL, PC, BINARY, BIT_15
  },
  {
    "zreset", LVL_IMPL, PC, BINARY, BIT_16
  },
  {
    "olc", LVL_IMPL, PC, BINARY, BIT_17
  },
  {
    "aedit", LVL_IMPL, PC, BINARY, BIT_18
  },
  {
    "redit", LVL_IMPL, PC, BINARY, BIT_19
  },
  {
    "medit", LVL_IMPL, PC, BINARY, BIT_20
  },
  {
    "oedit", LVL_IMPL, PC, BINARY, BIT_21
  },
  {
    "zedit", LVL_IMPL, PC, BINARY, BIT_22
  },
  {
    "sedit", LVL_IMPL, PC, BINARY, BIT_23
  },
  {
    "hedit", LVL_IMPL, PC, BINARY, BIT_24
  },
  {
    "qedit", LVL_IMPL, PC, BINARY, BIT_25
  },
  {
    "gedit", LVL_IMPL, PC, BINARY, BIT_26
  },
  {
    "all", LVL_IMPL, PC, BINARY, BIT_32
  },
  {
    "\n", 0, BOTH, MISC, 0
  }
};

ACMD(do_grant)
{
  int l;
  struct char_data *vict = NULL, *cbuf = NULL;
  struct char_file_u tmp_store;
  char field[MAX_INPUT_LENGTH], name[MAX_INPUT_LENGTH], val_arg[MAX_INPUT_LENGTH];
  int on = 0, off = 0, value = 0;
  char is_file = 0, is_mob = 0, is_player = 0;
  int player_i = 0;

  half_chop(argument, name, buf);
  if (GET_LEVEL(ch) != LVL_IMPL) {
    send_to_char("Huh?!?\r\n", ch);
    return;
  }
  if (!strcmp(name, "file")) {
    is_file = 1;
    half_chop(buf, name, buf);
  } else if (!str_cmp(name, "player")) {
    is_player = 1;
    half_chop(buf, name, buf);
  } else if (!str_cmp(name, "mob")) {
    is_mob = 1;
    half_chop(buf, name, buf);
  }
  half_chop(buf, field, buf);
  strcpy(val_arg, buf);

  if (!*name || !*field) {
    send_to_char("Usage: grant <victim> <field> <value>\r\n", ch);
    return;
  }
  if (!is_file) {
    if (is_player) {
      if (!(vict = get_player_vis(ch, name, 0))) {
	send_to_char("There is no such player.\r\n", ch);
	return;
      }
    } else {
      if (!(vict = get_char_vis(ch, name))) {
	send_to_char("There is no such creature.\r\n", ch);
	return;
      }
    }
  } else if (is_file) {
    CREATE(cbuf, struct char_data, 1);
    clear_char(cbuf);
    if ((player_i = load_char(name, &tmp_store)) > -1) {
      store_to_char(&tmp_store, cbuf);
      if (GET_LEVEL(cbuf) >= GET_LEVEL(ch)) {
	free_char(cbuf);
	send_to_char("Sorry, you can't do that.\r\n", ch);
	return;
      }
      vict = cbuf;
    } else {
      FREE(cbuf);
      send_to_char("There is no such player.\r\n", ch);
      return;
    }
  }
  for (l = 0; *(grant_fields[l].cmd) != '\n'; l++)
    if (!strncmp(field, grant_fields[l].cmd, strlen(field)))
      break;

  if (GET_LEVEL(ch) < grant_fields[l].level) {
    send_to_char("You are not godly enough for that!\r\n", ch);
    return;
  }
  if (IS_NPC(vict) && !(grant_fields[l].pcnpc & NPC)) {
    send_to_char("You can't do that to a beast!\r\n", ch);
    return;
  } else if (!IS_NPC(vict) && !(grant_fields[l].pcnpc & PC)) {
    send_to_char("That can only be done to a beast!\r\n", ch);
    return;
  }
  if (grant_fields[l].type == BINARY) {
    if (!strcmp(val_arg, "on") || !strcmp(val_arg, "yes"))
      on = 1;
    else if (!strcmp(val_arg, "off") || !strcmp(val_arg, "no"))
      off = 1;
    if (!(on || off)) {
      send_to_char("Value must be on or off.\r\n", ch);
      return;
    }
  } else if (grant_fields[l].type == NUMBER) {
    value = atoi(val_arg);
  }
  strcpy(buf, "Okay.");		/* can't use OK macro here 'cause of \r\n */
  if (grant_fields[l].bit <= BIT_32) {
    SET_OR_REMOVE(GRANT_FLAGS(vict), grant_fields[l].bit);
  } else {
    SET_OR_REMOVE(GRANT2_FLAGS(vict), grant_fields[l].bit);
  }
  if (grant_fields[l].type == BINARY) {
    sprintf(buf, "%s %s for %s.\r\n", grant_fields[l].cmd, ONOFF(on),
	    GET_NAME(vict));
    CAP(buf);
    sprintf(buf2, "(GC) [Grant]: %s set %s's command %s %s",
	    GET_NAME(ch), GET_NAME(vict), grant_fields[l].cmd, ONOFF(on));
    mudlog(buf2, BRF, GET_LEVEL(ch) + 1, TRUE);
  } else if (grant_fields[l].type == NUMBER) {
    sprintf(buf, "%s's %s set to %d.\r\n", GET_NAME(vict),
	    grant_fields[l].cmd, value);
  } else
    strcat(buf, "\r\n");
  send_to_char(CAP(buf), ch);

  if (!is_file && !IS_NPC(vict))
    save_char(vict, NOWHERE);

  if (is_file) {
    char_to_store(vict, &tmp_store);
    fseek(player_fl, (player_i) * sizeof(struct char_file_u), SEEK_SET);
    fwrite(&tmp_store, sizeof(struct char_file_u), 1, player_fl);
    free_char(cbuf);
    send_to_char("Saved in file.\r\n", ch);
  }
}

ACMD(do_new_wizhelp)
{
#if 0
  int nums = 0;

  int comsend(long cmdbit, char *cmdname, int cmdnum) {
    if (CMD_FLAGGED(ch, cmdbit)) {
      sprintf(buf, "%-11s", cmdname);
      send_to_char(buf, ch);
      cmdnum++;
      if (cmdnum == 7) {
	send_to_char("\r\n", ch);
	cmdnum = 0;
      }
    }
    return (cmdnum);
  }

  int comsend2(long cmdbit, char *cmdname, int cmdnum) {
    if (CMD2_FLAGGED(ch, cmdbit)) {
      sprintf(buf, "%-11s", cmdname);
      send_to_char(buf, ch);
      cmdnum++;
      if (cmdnum == 7) {
	send_to_char("\r\n", ch);
	cmdnum = 0;
      }
    }
    return (cmdnum);
  }

  if (!CMD_FLAGGED(ch, CMD_IMM)) {
    send_to_char("Huh?!?\r\n", ch);
    return;
  }
  send_to_char("You have the following privledged commands:\r\n", ch);
  nums = comsend(CMD_IMM, ";", nums);
  nums = comsend(CMD_IMM, "at", nums);
  nums = comsend(CMD_BAN, "ban", nums);
  nums = comsend(CMD_IMM, "date", nums);
  nums = comsend(CMD_DC, "dc", nums);
  nums = comsend(CMD_IMM, "echo", nums);
  nums = comsend(CMD_FORCE, "force", nums);
  nums = comsend(CMD_FREEZE, "freeze", nums);
  nums = comsend(CMD_IMM, "gecho", nums);
  nums = comsend(CMD_IMM, "goto", nums);
  nums = comsend(CMD_GRANT, "grant", nums);
  nums = comsend(CMD_IMM, "handbook", nums);
  nums = comsend(CMD_HCONTROL, "hcontrol", nums);
  nums = comsend(CMD_IMM, "holylight", nums);
  nums = comsend(CMD_ADVANCE, "level", nums);
  nums = comsend(CMD_IMM, "invis", nums);
  nums = comsend(CMD_IMM, "last", nums);
  nums = comsend(CMD_LOAD, "load", nums);
  nums = comsend(CMD_OLC, "medit", nums);
  nums = comsend(CMD_OLC, "mlist", nums);
  nums = comsend(CMD_IMM, "nohassle", nums);
  nums = comsend(CMD_NOTITLE, "notitle", nums);
  nums = comsend(CMD_IMM, "nowiz", nums);
  nums = comsend(CMD_OLC, "oedit", nums);
  nums = comsend(CMD_IMM, "page", nums);
  nums = comsend(CMD_PARDON, "pardon", nums);
  nums = comsend(CMD_PCHECK, "pcheck", nums);
  nums = comsend(CMD_PEACE, "peace", nums);
  nums = comsend(CMD_IMM, "poofin", nums);
  nums = comsend(CMD_IMM, "poofout", nums);
  nums = comsend(CMD_PURGE, "purge", nums);
  nums = comsend(CMD_IMM, "qecho", nums);
  nums = comsend(CMD_OLC, "redit", nums);
  nums = comsend(CMD_RELOAD, "reload", nums);
  nums = comsend(CMD_REROLL, "reroll", nums);
  nums = comsend(CMD_RESTORE, "restore", nums);
  nums = comsend(CMD_IMM, "roomflags", nums);
  nums = comsend(CMD_OLC, "sedit", nums);
  nums = comsend(CMD_IMM, "send", nums);
  nums = comsend(CMD_SET, "set", nums);
  nums = comsend(CMD_SHOW, "show", nums);
  nums = comsend(CMD_SHUTDOWN, "shutdow", nums);
  nums = comsend(CMD_SHUTDOWN, "shutdown", nums);
  nums = comsend(CMD_SKILLSET, "skillset", nums);
  nums = comsend(CMD_IMPCMDS, "slowns", nums);
  nums = comsend(CMD_SNOOP, "snoop", nums);
  nums = comsend(CMD_IMM, "snowball", nums);
  nums = comsend(CMD_STAT, "stat", nums);
  nums = comsend(CMD_SNOOP, "snoop", nums);
  nums = comsend(CMD_IMM, "syslog", nums);
  nums = comsend(CMD_TELEPORT, "teleport", nums);
  nums = comsend(CMD_FREEZE, "freeze", nums);
  nums = comsend(CMD_TRANSFER, "transfer", nums);
  nums = comsend(CMD_UNAFFECT, "unaffect", nums);
  nums = comsend(CMD_BAN, "ban", nums);
  nums = comsend(CMD_IMM, "uptime", nums);
  nums = comsend(CMD_IMM, "users", nums);
  nums = comsend(CMD_IMM, "vnum", nums);
  nums = comsend(CMD_STAT, "vstat", nums);
  nums = comsend(CMD_IMM, "wizhelp", nums);
  nums = comsend(CMD_IMPCMDS, "wizlock", nums);
  nums = comsend(CMD_IMM, "wiznet", nums);
  nums = comsend(CMD_OLC, "zedit", nums);
  nums = comsend(CMD_ZRESET, "zreset", nums);
#endif
}

ACMD(do_terminate)
{
  struct char_data *victim = NULL;
  char buf[MAX_STRING_LENGTH];

  if (IS_NPC(ch))
    return;

  one_argument(argument, buf);

  if (!*buf) {
    send_to_char("But oh Mighty One, whom do you wish to utterly annihilate?\r\n", ch);
    return;
  }
  if (!(victim = get_char_room_vis(ch, buf))) {
    send_to_char("You see no person by that name here.\r\n", ch);
    return;
  }
  if (IS_NPC(victim)) {
    send_to_char("Who cares about NPC's...\r\n", ch);
    return;
  }
  if ((GET_LEVEL(victim) >= GET_LEVEL(ch)) || (GET_LEVEL(victim) >= 34)) {
    send_to_char("Go away jackass!\r\n", ch);
    return;
  }
  act("&+r$n is surrounded by a red aura, and $s &+Weyes&n &+rglow.", FALSE, ch, 0, victim, TO_VICT);
  act("&+r$n raises $s hands and points them at YOU! and a&n &+Lblack ", FALSE, ch, 0, victim, TO_VICT);
  act("&+Lbeam&n &+r shoots out to strike at YOU!", FALSE, ch, 0, victim, TO_VICT);
  act("&+rYou feel your soul being invaded by $n as $e begins to", FALSE, ch, 0, victim, TO_VICT);
  act("&+runravel the mysteries of your existance! You feel every part", FALSE, ch, 0, victim, TO_VICT);
  act("&+rof your body being torn to shreds, and you suddenly cry out in", FALSE, ch, 0, victim, TO_VICT);
  act("&+rutter terror as $n stands over the remains of you in righteous", FALSE, ch, 0, victim, TO_VICT);
  act("&+rjustice!  You fall away into complete&n &+Lblackness.......", FALSE, ch, 0, victim, TO_VICT);

  send_to_char("&+rYou raise your hands and feel the power of life and death\r\n", ch);
  send_to_char("&+rflowing through your soul!  You unleash the power in a \r\n", ch);
  act("&+Lblack beam&N &+rof death upon $N!!!", FALSE, ch, 0, victim, TO_CHAR);
  act("&+r$N is completely obliterated into a million bits!", FALSE, ch, 0, victim, TO_CHAR);
  act("&+rYou smile as $N will never again challenge your greatness!", FALSE, ch, 0, victim, TO_CHAR);

  act("&+r$n is surrounded by a red aura, and $s &+Weyes&n &+rglow.", FALSE, ch, 0, victim, TO_NOTVICT);
  act("&+r$n raises $s hands and points them at $N and a&n &+Lblack ", FALSE, ch, 0, victim, TO_NOTVICT);
  act("&+Lbeam&n &+r shoots out to strike at $N!", FALSE, ch, 0, victim, TO_NOTVICT);
  act("&+r$N cries out and $E shatters into a million bits!", FALSE, ch, 0, victim, TO_NOTVICT);

  deleteChar(victim);
  if (victim->desc)
    close_socket(victim->desc);
  victim->desc = NULL;
  extract_char(victim);
/*  free_char(victim); */
  victim = NULL;
  return;
}


extern int top_of_objt;
extern int top_of_mobt;
extern int top_of_world;
extern int top_of_helpt;
extern int top_of_socialt;
extern int top_of_aquestt;
extern int top_shop;
extern int top_of_zone_table;
extern int top_of_p_file;
extern int top_of_door_table;

void show_mreport(struct char_data *ch)
{
  int i, x = 0, j = 0;
  struct char_data *vict;

  for (vict = character_list; vict; vict = vict->next)
    if (vict->desc)
      j++;

  for (i = 0; i <= top_of_zone_table; i++)
    if (!zone_table[i].unloaded)
      x++;

  strcpy(buf, "&+YMemory Report&n\r\n");
  strcat(buf, "&+Y-------------&n\r\n");
  sprintf(buf, "%s        %7s %4s %10s\r\n", buf, "Number", "byte", "total used");
  sprintf(buf, "%sPlayers  :%7d %4d %10d\r\n", buf, j, sizeof(struct char_data) + sizeof(struct descriptor_data), (j) * (sizeof(struct char_data) + sizeof(struct descriptor_data)));
  sprintf(buf, "%sObjects  :%7d %4d %10d\r\n", buf, top_of_objt + 1, sizeof(struct obj_data), (top_of_objt + 1) * sizeof(struct obj_data));
  sprintf(buf, "%sMobProto :%7d %4d %10d\r\n", buf, top_of_mobt + 1, sizeof(struct char_data), (top_of_mobt + 1) * sizeof(struct char_data));
  sprintf(buf, "%s  Loaded :%7d %4d %10d\r\n", buf, top_of_loaded_mobs_table + 1, sizeof(struct char_data), (top_of_loaded_mobs_table + 1) * sizeof(struct char_data));
  sprintf(buf, "%sRooms    :%7d %4d %10d\r\n", buf, top_of_world + 1, sizeof(struct room_data), (top_of_world + 1) * sizeof(struct room_data));
  sprintf(buf, "%s  Exits  :%7d %4d %10d\r\n", buf, top_of_door_table + 1, sizeof(struct room_direction_data), (top_of_door_table + 1) * sizeof(struct room_direction_data));
  sprintf(buf, "%s  Maps   :%7d %4d %10d\r\n", buf, x + 1, sizeof(struct map_data), (x + 1) * sizeof(struct map_data));
  sprintf(buf, "%sHelp     :%7d %4d %10d\r\n", buf, top_of_helpt + 1, sizeof(struct help_index_element), (top_of_helpt + 1) * sizeof(struct help_index_element));
  sprintf(buf, "%sSocials  :%7d %4d %10d\r\n", buf, top_of_socialt + 1, sizeof(struct command_info), (top_of_socialt + 1) * sizeof(struct command_info));
  sprintf(buf, "%sQuests   :%7d \r\n", buf, top_of_aquestt + 1);
  sprintf(buf, "%sShops    :%7d \r\n", buf, top_shop + 1);
  sprintf(buf, "%sZones    :%7d %4d %10d\r\n", buf, top_of_zone_table + 1, sizeof(struct zone_data), (top_of_zone_table + 1) * sizeof(struct zone_data));
  send_to_char(buf, ch);
}

ACMD(do_inroom)
{
  char buf1[MAX_STRING_LENGTH], buf2[MAX_STRING_LENGTH];
  char *p;
  struct char_data *v, *v_next;
  int target;

  strcpy(buf1, argument);

  if ((p = strstr(buf1, " %p")))
    target = 1;
  else if ((p = strstr(buf1, " %m")))
    target = 2;
  else if ((p = strstr(buf1, " %a")))
    target = 3;
  else {
    /* error.. no token provided  */
    send_to_char("Eh?  try: \"inroom <string>\"\r\n", ch);
    send_to_char("  <string> should contain 1 occurance of ONE of the following:\r\n", ch);
    send_to_char("    %p - all players in the room\r\n", ch);
    send_to_char("    %m - all mobs in the room\r\n", ch);
    send_to_char("    %a - both mobs and players in the room\r\n", ch);
    send_to_char("  <string> will then be executed once for each pc and/or npc\r\n", ch);
    send_to_char("  in the room, replacing the \% token with the char name\r\n", ch);
    return;
  }

  /* okay... now we have p pointing to the space before the % token.
     move it forward two places, and replace the letter with an 's' for
     use in sprintf  */

  p++;
  p++;
  *p = 's';

  /* okay.. now buf1 is setup as an arguement for sprintf...   */

  for (v = world[ch->in_room].people; v; v = v_next) {
    v_next = v->next_in_room;
    if ((!CAN_SEE(ch, v)) ||
	(IS_PC(v) && (target == 2)) ||
	(IS_NPC(v) && (target == 1)) ||
	(ch == v))
      continue;

    /*
     * Serious flaw in this (and MANY other functions): if the users
     * does "inroom grin %pc %s" that extra %s is going to cause
     * problems... For now, I'm going to just "hope" that people
     * aren't that stupid (considering thats what the code does
     * everywhere else)
     */

    sprintf(buf2, buf1, FirstWord(GET_NAME(v)));

    /* okay.. now just dump buf2 to the command interpretter  */

    command_interpreter(ch, buf2);
  }
}

ACMD(do_playerlink)
{
  struct char_data *victim = 0;
  struct char_file_u tmp_store;
  char *action = arg, *vict = buf2;

  two_arguments(argument, action, vict);

  if (!*action || !*vict) {
    send_to_char("Usage: playerlink [ load | remove ] <player>\r\n", ch);
    return;
  }
  if (is_abbrev(action, "load")) {
    if (get_player_vis(ch, vict, 0)) {
      send_to_char("That player is already connected/loaded!\r\n", ch);
      return;
    }
    CREATE(victim, struct char_data, 1);
    clear_char(victim);
    if (load_char(vict, &tmp_store) > -1) {
      store_to_char(&tmp_store, victim);
      if (GET_LEVEL(victim) <= GET_LEVEL(ch)) {
	Crash_load(victim);
	victim->next = character_list;
	character_list = victim;
	victim->desc = NULL;
	put_char_to_room(victim, ch->in_room, -1, GET_X_CORD(ch), GET_Y_CORD(ch), GET_Z_CORD(ch));
	act("You gesture and a statue of $N forms from nothingness.",
	    FALSE, ch, 0, victim, TO_CHAR);
	act("$n gestures and a statue of $N appears from nowhere.", FALSE,
	    ch, 0, victim, TO_NOTVICT);
	/* read_aliases(victim); */
	sprintf(buf, "(GC) %s has loaded %s.", GET_NAME(ch),
		GET_NAME(victim));
	mudlog(buf, BRF, MAX(LVL_IMPL, GET_INVIS_LEV(ch)), TRUE);
      } else {
	send_to_char("Sorry, you aren't high enough level to load that char.\r\n", ch);
	free_char(victim);
      }
    } else {
      send_to_char("No such player.\r\n", ch);
      free(victim);
    }
  } else if (is_abbrev(action, "remove")) {
    if (!(victim = get_player_vis(ch, vict, 0))) {
      send_to_char("That player isn't in the game right now.\r\n", ch);
      return;
    } else if (victim->desc) {
      send_to_char("That player isn't linkdead.\r\n", ch);
      return;
    }
    act("You gesture and $N dissolves into nothingness.", FALSE, ch, 0,
	victim, TO_CHAR);
    act("$n gestures and $N dissolves into nothingness.", FALSE, ch, 0,
	victim, TO_NOTVICT);
    sprintf(buf, "(GC) %s has unloaded %s.", GET_NAME(ch), GET_NAME(victim));
    Crash_rentsave(victim, 0);
    extract_char(victim);
    mudlog(buf, BRF, MAX(LVL_IMPL, GET_INVIS_LEV(ch)), TRUE);
  }
  return;
}


ACMD(do_copyover)
{
  FILE *fp;
  struct descriptor_data *d, *d_next;
  char buf[100], buf2[100];
  struct olc_save_info *entry;

  fp = fopen(COPYOVER_FILE, "w");

  if (!fp) {
    send_to_char("Copyover file not writeable, aborted.\n\r", ch);
    return;
  }
  sprintf(buf, "\n\r *** COPYOVER by %s - please remain seated!\n\r", GET_NAME(ch));

  /* First off, save all OLC */
  if (olc_save_list) {
    for (entry = olc_save_list; entry; entry = entry->next) {
      switch (entry->type) {
      case SCMD_OLC_AEDIT:
	aedit_save_to_disk(entry->zone);
	break;
      case SCMD_OLC_HEDIT:
	hedit_save_to_disk(entry->zone);
	break;
      case SCMD_OLC_REDIT:
	redit_save_to_disk(entry->zone);
	break;
      case SCMD_OLC_MEDIT:
	medit_save_to_disk(entry->zone);
	break;
      case SCMD_OLC_OEDIT:
	oedit_save_to_disk(entry->zone);
	break;
      case SCMD_OLC_ZEDIT:
	zedit_save_to_disk(entry->zone);
	break;
      }
    }
  }
  /* For each playing descriptor, save its state */
  for (d = descriptor_list; d; d = d_next) {
    struct char_data *och = d->character;
    d_next = d->next;		/* We delete from the list , so need to save this */

    if (!d->character || d->connected > CON_PLAYING) {	/* drop those logging on */
      write_to_descriptor(d->descriptor, "\n\rSorry, we are rebooting. Come back in a few minutes.\n\r");
      close_socket(d);		/* throw'em out */
    } else {
      fprintf(fp, "%d %s %s\n", d->descriptor, GET_NAME(och), d->host);

      /* save och */
      Crash_rentsave(och, 0);
      save_char(och, och->in_room);
      write_to_descriptor(d->descriptor, buf);
    }
  }

  fprintf(fp, "-1\n");
  fclose(fp);

  /* Close reserve and other always-open files and release other resources */

  fclose(player_fl);
  touch(COPYOVER_FILE2);	/* prevent autorun from interfering */

  /* exec - descriptors are inherited */

  sprintf(buf, "%d", port);
  sprintf(buf2, "-C%d", mother_desc);

  /* Ugh, seems it is expected we are 1 step above lib - this may be dangerous! */
  chdir("..");

  execl(EXE_FILE, "greyhawk", buf2, buf, (char *) NULL);
  vlogf("Copyover command: %s %s %s %s", EXE_FILE, "greyhawk", buf2, buf);
  /* Failed - sucessful exec will not return */

  perror("do_copyover: execl");
  log("do_copyover: execl failed");
  send_to_char("Copyover FAILED!\n\r", ch);

  exit(1);			/* too much trouble to try to recover! */
}

void vwear_position(int wearpos, struct char_data *ch)
{
  char localbuf[MAX_STRING_LENGTH];
  int nr, found = 0;

  sprintbit(wearpos, wear_bits, buf);
  strcpy(localbuf, "VWEAR: Wear Position Search for ");
  sprintf(localbuf + strlen(localbuf), "%s.\r\n", buf);
  for (nr = 0; nr <= top_of_objt; nr++) {
    if (CAN_WEAR(&obj_proto[nr], wearpos)) {
      sprintf(localbuf + strlen(localbuf), "%3d. [%5d] %s\r\n",
	++found, obj_index[nr].virtual, obj_proto[nr].short_description);
    }
  }
  if (!found)
    sprintf(localbuf + strlen(localbuf), "     [-----] Not Found !\r\n");
  page_string(ch->desc, localbuf, 1);
}

void vwear_type(int type, struct char_data *ch)
{
  char localbuf[MAX_STRING_LENGTH];
  int nr, found = 0;

  strcpy(localbuf, "VWEAR: Object Type Search for ");
  sprintf(localbuf + strlen(localbuf), "%s.\r\n", item_types[type]);
  for (nr = 0; nr <= top_of_objt; nr++) {
    if (GET_OBJ_TYPE(&obj_proto[nr]) == type) {
      sprintf(localbuf + strlen(localbuf), "%3d. [%5d] %s\r\n",
	++found, obj_index[nr].virtual, obj_proto[nr].short_description);
    }
  }
  if (!found)
    sprintf(localbuf + strlen(localbuf), "     [-----] Not Found ! \r\n");
  page_string(ch->desc, localbuf, 1);
}

ACMD(do_vwear)
{
  int i, j, l, types = 0;

  skip_spaces(&argument);

  if (!*argument) {
    strcpy(buf, "Usage: vwear <option>\r\n\r\n");
    strcat(buf, "Vwear options are:\r\n\r\n");
    strcat(buf, "Object types:\r\n");
    for (j = 0, i = 1; i < NUM_ITEM_TYPES; i++)
      sprintf(buf + strlen(buf), "%-15s%s", item_types[i], (!(++j % 5)
							 ? "\r\n" : ""));
    strcat(buf, "\r\n");
    strcat(buf, "Wear positions:\r\n");
    for (j = 0, i = 1; i < NUM_ITEM_WEARS; i++)
      sprintf(buf + strlen(buf), "%-15s%s", wear_bits[i], (!(++j % 5)
							 ? "\r\n" : ""));
    strcat(buf, "\r\n");
    send_to_char(buf, ch);
    return;
  }
  for (l = 1; l < NUM_ITEM_TYPES; l++) {
    if (is_abbrev(argument, item_types[l])) {
      types = 1;
      break;
    }
  }

  if (!types) {
    for (l = 1; l < NUM_ITEM_WEARS; l++) {
      if (is_abbrev(argument, wear_bits[l])) {
	types = 2;
	break;
      }
    }
  }
  if (types == 1)
    vwear_type(l, ch);
  else if (types == 2)
    vwear_position(1 << l, ch);
  else
    send_to_char("You must use a valid type or position!\r\n", ch);
}


ACMD(do_rename)
{
  int player_i;
  extern struct player_index_element *player_table;
  struct char_file_u tmp_store;
  struct char_data *victim = NULL;
  char tmp_name[MAX_INPUT_LENGTH], arg1[MAX_INPUT_LENGTH], arg2[MAX_INPUT_LENGTH];
  two_arguments(argument, arg1, arg2);

  if (!ch || IS_NPC(ch))
    return;

  if (!arg1 || !*arg1 || !arg2 || !*arg2) {
    send_to_char("Usage: rename <player name> <new name>\r\n", ch);
    return;
  }
  if (!(victim = get_char_vis(ch, arg1))) {
    send_to_char(NOPERSON, ch);
    return;
  }
  if ((GET_LEVEL(ch) <= GET_LEVEL(victim)) && !(GET_LEVEL(ch) == LVL_IMPL)) {
    send_to_char("You don't have permission to change that name.", ch);
    return;
  }
  if ((_parse_name(arg2, tmp_name)) || strlen(tmp_name) < 2 ||
      strlen(tmp_name) > MAX_NAME_LENGTH ||
      fill_word(strcpy(buf, tmp_name)) || reserved_word(buf)) {
    send_to_char("The new name is invalid.\r\n", ch);
    return;
  }
  if (!Valid_Name(tmp_name)) {
    send_to_char("The new name is invalid.\r\n", ch);
    return;
  }
  if ((player_i = load_char(tmp_name, &tmp_store)) > -1) {
    send_to_char("There is already a player with that name.\r\n", ch);
    return;
  }
  sprintf(buf2, "&+RYou have renamed &n%s& &+Rto &n%s.\r\n", GET_NAME(victim), CAP(tmp_name));
  send_to_char(buf2, ch);
  sprintf(buf2, "%s has renamed %s to %s", GET_NAME(ch), GET_NAME(victim), tmp_name);
  mudlog(buf2, NRM, LVL_GOD, TRUE);
  strcpy((player_table + GET_PFILEPOS(victim))->name, CAP(tmp_name));
  strcpy(victim->player.name, CAP(tmp_name));
  save_char(victim, victim->in_room);
  Crash_crashsave(victim);
  sprintf(buf2, "&+R!!! You have been renamed to &n%s.\r\n", GET_NAME(victim));
  send_to_char(buf2, victim);
}

ACMD(do_depiss)
{
  void forget(struct char_data *ch, struct char_data *victim);

  char buf3[80];
  struct char_data *vic = 0;
  struct char_data *mob = 0;

  two_arguments(argument, buf1, buf2);

  if (!*buf1 || !*buf2) {
    send_to_char("Usage: depiss <player> <mobile>\r\n", ch);
    return;
  }
  if (((vic = get_char_vis(ch, buf1))) && (!IS_NPC(vic))) {
    if (((mob = get_char_vis(ch, buf2))) && (IS_NPC(mob))) {
      if (MOB_FLAGGED(mob, MOB_MEMORY))
	forget(mob, vic);
      else {
	send_to_char("Mobile does not have the memory flag set!\r\n", ch);
	return;
      }
    } else {
      send_to_char("Sorry, Player Not Found!\r\n", ch);
      return;
    }
  } else {
    send_to_char("Sorry, Mobile Not Found!\r\n", ch);
    return;
  }
  sprintf(buf3, "%s has been removed from %s pissed list.\r\n",
	  GET_NAME(vic), GET_NAME(mob));
  send_to_char(buf3, ch);
}

ACMD(do_repiss)
{
  void remember(struct char_data *ch, struct char_data *victim);

  char buf3[80];
  struct char_data *vic = 0;
  struct char_data *mob = 0;

  two_arguments(argument, buf1, buf2);

  if (!*buf1 || !*buf2) {
    send_to_char("Usage: repiss <player> <mobile>\r\n", ch);
    return;
  }
  if (((vic = get_char_vis(ch, buf1))) && (!IS_NPC(vic))) {
    if (((mob = get_char_vis(ch, buf2))) && (IS_NPC(mob))) {
      if (MOB_FLAGGED(mob, MOB_MEMORY))
	remember(mob, vic);
      else {
	send_to_char("Mobile does not have the memory flag set!\r\n", ch);
	return;
      }
    } else {
      send_to_char("Sorry, Player Not Found!\r\n", ch);
      return;
    }
  } else {
    send_to_char("Sorry, Mobile Not Found!\r\n", ch);
    return;
  }
  sprintf(buf3, "%s has been added to %s pissed list.\r\n",
	  GET_NAME(vic), GET_NAME(mob));
  send_to_char(buf3, ch);
}
