/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"


#include "guild.h"
#include "structs.h"
#include "utils.h"
#include "db.h"

#include "comm.h"
#include "handler.h"
#include "spells.h"
#include "mail.h"
#include "interpreter.h"
#include "house.h"
#include "quest.h"
#include "boards.h"
#include "plugin.h"
#include "dg_scripts.h"

extern char *dirs[];
extern int top_of_world;
extern struct deity_data deity_list[];
extern char *school_list[];
extern char *sphere_list[];
extern const char *specialist_list[];
extern const char *race_types[];
extern const char *class_types[];
extern struct descriptor_data *descriptor_list;
extern struct dex_app_type dex_app[];
extern const int thaco[NUM_CLASSES][LVL_IMPL + 1];
extern int level_exp(int class, int level);
struct spell_info_type spell_info[TOP_SPELL_DEFINE + 1];
extern const char *alignment_types[];
extern const char *size_types[];

ACMD(do_testdesc)
{
  struct char_data *vict;

  one_argument(argument, arg);

  if (!(vict = get_char_room_vis(ch, arg))) {
    send_to_char("Give random eq to who?\r\n", ch);
    return;
  }
/*  check_random_equip(vict); */
  send_to_char("Done! Damn sure hope it worked...\r\n", ch);
}

/* used at creation and do_score, displays standard AD&D style char sheet */
void disp_char_sheet(struct char_data *ch)
{
  char buf3[256];

  if (MORPH_MOB(ch)) {
    sprintf(buf, "Currently polymorphed into %s.\r\n", GET_NAME(ch));
    send_to_char(buf, ch);
  }
  buf[0] = '\0';

  if (GET_THIEF_SKILL(ch) > 0)
    sprintf(buf2, "&+BThief skill slot:&n%d", GET_THIEF_SKILL(ch));
  else
    strcpy(buf2, "\r\n");

  if (GET_ADD(ch) > 0)
    sprintf(buf3, "&+YStrength:&n     %3d/%3d", GET_STR(ch), GET_ADD(ch));
  else
    sprintf(buf3, "&+YStrength:&n     %3d    ", GET_STR(ch));


  strcpy(buf, "&+L----------------------------------------------------------------------&N\r\n");

  send_to_char(buf, ch);
  sprintf(buf,
	  "&+BName: &n%s %s\r\n"
	  "&+BRace: &n%-20s &+BClass: &n%s %s\r\n"
	  "&+BLevel:&n%-5d &+BExp:&n %-10d  &+BExp for level:&n%-10d\r\n"
	  "&+BAlignment:&n%-16s &+BAge:&n%-5d &+BHeight:&n%-5d &+BWeight:&n%-5d\r\n"
	  "&+BAppearance:&n %-60s\r\n"
	  "\r\n"
	  "\r\n"
	  "%s        &+YSaving Throws&n\r\n"
	  "&+YDexterity:&n    %3d            &+YPara  :&n %3d\r\n"
	  "&+YConstitution:&n %3d            &+YRSW   :&n %3d\r\n"
	  "&+YIntelligence:&n %3d            &+YPetri :&n %3d\r\n"
	  "&+YWisdom:&n       %3d            &+YBreath:&n %3d\r\n"
	  "&+YCharisma:&n     %3d            &+YSpell :&n %3d\r\n"
	  "\r\n",
	  GET_NAME(ch),
	  IS_PC(ch) ? GET_TITLE(ch) : "",
	  race_types[(int) GET_RACE(ch)],
	  class_types[(int) GET_CLASS(ch)],
	  IS_MAGE_SPECIALIST(ch) ? specialist_list[(int) IS_MAGE_SPECIALIST(ch) - 1] : "",
	  GET_LEVEL(ch),
	  GET_EXP(ch),
	  GET_LEVEL(ch) >= LVL_IMMORT ? 0 : level_exp(GET_CLASS(ch), GET_LEVEL(ch) + 1) - GET_EXP(ch),
	  alignment_types[GET_ALIGNMENT(ch)],
	  GET_AGE(ch),
	  GET_HEIGHT(ch),
	  GET_WEIGHT(ch),
	  IS_PC(ch) ? GET_SHORT(ch) : GET_LONG(ch),
	  buf3,
	  GET_DEX(ch),
	  GET_SAVE(ch, 0),
	  GET_CON(ch),
	  GET_SAVE(ch, 1),
	  GET_INT(ch),
	  GET_SAVE(ch, 2),
	  GET_WIS(ch),
	  GET_SAVE(ch, 3),
	  GET_CHA(ch),
	  GET_SAVE(ch, 4)
      );
  send_to_char(buf, ch);


  sprintf(buf,
	  "\r\n"
	  "&+BAC: &n%3d  &+BHit Points: &n%d/%d  &+BTHAC0: &n%d\r\n"
	  "&+BAttacks/Round:&n\r\n"
	  "&+BDominant Hand:&n %s\r\n"
	  "&+BFacing:&n %s\r\n"
	  "&+BSize: &n%s\r\n"
	  "\r\n"
	  "&+BNon weapon/weapon proficiency slot:&n%2d/%2d %s"
	  "\r\n",
	  GET_AC(ch) + (dex_app[GET_DEX(ch)].defensive),
	  GET_HIT(ch),
	  GET_MAX_HIT(ch),
	  thaco[(int) GET_CLASS(ch)][(int) GET_LEVEL(ch)],
	  (GET_DOM_HAND(ch) == HAND_RIGHT) ? "Right" : "Left",
	  dirs[GET_FACING(ch)],
	  size_types[(int) GET_SIZE(ch)],
	  GET_NON_WEAPON_PROF(ch),
	  GET_WEAPON_PROF(ch),
	  buf2
      );
  send_to_char(buf, ch);


  if (IS_MAGE(ch)) {
    strcpy(buf, "\r\n&+BSchool: &n");
    sprintbit(GET_MAGE_SCHOOL(ch), school_list, buf2);
    strcat(buf, buf2);
    strcat(buf, "\r\n");
    send_to_char(buf, ch);
  }
  strcpy(buf, "\r\n&+BWorshiping: &N");
  strcat(buf, deity_list[GET_PRIEST_DEITY(ch)].deity_name);
  send_to_char(buf, ch);
  send_to_char("\r\n", ch);

  if (IS_PRIEST(ch)) {
    strcpy(buf, "\r\n&+BSphere major: &n");
    sprintbit(GET_PRIEST_SPHERE_MAJOR(ch), sphere_list, buf2);
    strcat(buf, buf2);
    send_to_char(buf, ch);
    send_to_char("\r\n", ch);

    strcpy(buf, "&+BSphere minor: &n");
    sprintbit(GET_PRIEST_SPHERE_MINOR(ch), sphere_list, buf2);
    strcat(buf, buf2);
    send_to_char(buf, ch);
    send_to_char("\r\n", ch);
  }
  send_to_char("\r\n&N&+L----------------------------------------------------------------------&N\r\n", ch);
}


void disp_char_sheet1(struct char_data *ch)
{
  if (MORPH_MOB(ch)) {
    sprintf(buf, "Currently polymorphed into %s.\r\n", GET_NAME(ch));
    send_to_char(buf, ch);
    ch = MORPH_MOB(ch);
  } else if (IS_NPC(ch)) {
    send_to_char("Sorry, no information for you...\r\n", ch);
    return;
  }
  sprintf(buf,
	  "%s%s|%s|"
	  "%s|%s|%s|"
	  "%d|%d|%d|"
	  "%s|%d|%d|%d|"
	  "%d|%d|"
	  "%d|%d|"
	  "%d|%d|"
	  "%d|%d|"
	  "%d|%d|"
	  "%d|%d|"
	  "%d|%d|%d|%d|"
	  "%s|%d|%d|%d|",
	  PLUGIN_SCORE_START,
	  GET_NAME(ch),
	  strip_color(GET_TITLE(ch)),
	  race_types[(int) GET_RACE(ch)],
	  class_types[(int) GET_CLASS(ch)],
	  IS_MAGE_SPECIALIST(ch) ? specialist_list[(int) IS_MAGE_SPECIALIST(ch) - 1] : "",
	  GET_LEVEL(ch),
	  GET_EXP(ch),
	  GET_LEVEL(ch) >= LVL_IMMORT ? 0 : level_exp(GET_CLASS(ch), GET_LEVEL(ch) + 1) - GET_EXP(ch),
	  alignment_types[GET_ALIGNMENT(ch)],
	  GET_AGE(ch),
	  GET_HEIGHT(ch),
	  GET_WEIGHT(ch),
	  GET_STR(ch),
	  GET_ADD(ch),
	  GET_DEX(ch),
	  GET_SAVE(ch, 0),
	  GET_CON(ch),
	  GET_SAVE(ch, 1),
	  GET_INT(ch),
	  GET_SAVE(ch, 2),
	  GET_WIS(ch),
	  GET_SAVE(ch, 3),
	  GET_CHA(ch),
	  GET_SAVE(ch, 4),
	  GET_AC(ch) + (dex_app[GET_DEX(ch)].defensive),
	  GET_HIT(ch),
	  GET_MAX_HIT(ch),
	  thaco[(int) GET_CLASS(ch)][(int) GET_LEVEL(ch)],
	  size_types[(int) GET_SIZE(ch)],
	  GET_NON_WEAPON_PROF(ch),
	  GET_WEAPON_PROF(ch),
	  GET_THIEF_SKILL(ch)
      );

  if (IS_MAGE(ch)) {
    sprintbit(GET_MAGE_SCHOOL(ch), school_list, buf2);
    strcat(buf, buf2);
  }
  strcat(buf, "|");

  strcat(buf, deity_list[GET_PRIEST_DEITY(ch)].deity_name);
  strcat(buf, "|");

  if (IS_PRIEST(ch)) {
    sprintbit(GET_PRIEST_SPHERE_MAJOR(ch), sphere_list, buf2);
    strcat(buf, buf2);
    strcat(buf, "|");
    sprintbit(GET_PRIEST_SPHERE_MINOR(ch), sphere_list, buf2);
    strcat(buf, buf2);
    strcat(buf, "|");
  } else {
    strcat(buf, "||");
  }

  strcat(buf, PLUGIN_SCORE_END);
  send_to_char(buf, ch);
}


/* 
 * sets spell levels for chars
 */
void init_spells(struct char_data *ch)
{
  int i, spellnum = 0;

  for (i = 1; i <= MAX_SPELLS; i++) {
    if (IS_GOD(ch)) {
      if (i <= MAX_SPELLS) {
	SET_SPELL(ch, i, MEMINFO_READY);
      } else {
	SET_SPELL(ch, i, 100);
      }
    } else {
      if (i <= MAX_SPELLS) {
	spellnum = i;
	if (!(IS_MAGE(ch) && IS_MAGE_SPELL(i)) &&
	    !(IS_PRIEST(ch) && IS_PRIEST_SPELL(i))) {
	  SET_SPELL(ch, i, MEMINFO_CANTLEARN);
	} else {
	  SET_SPELL(ch, i, MEMINFO_UNKNOWN);
	}
      } else {
	SET_SPELL(ch, i, 1);
      }
    }
  }
}


/* random name generator */
char *random_name(void)
{
  FILE *f;
  int antal_start = 0, antal_mitt = 0, antal_slut = 0;
  char tempstring[80], *start[100], *mitt[100], *slut[100];
  static char namn[20];

  if (!(f = fopen("descs/names", "r"))) {
    log("desc/names file not found!");
    return NULL;
  }
  while (tempstring[0] != '2') {
    fgets(tempstring, 80, f);
    tempstring[strlen(tempstring) - 1] = '\0';	/* remove linefeed */
    start[antal_start++] = str_dup(tempstring);
  }

  while (tempstring[0] != '3') {
    fgets(tempstring, 80, f);
    tempstring[strlen(tempstring) - 1] = '\0';	/* remove linefeed */
    mitt[antal_mitt++] = str_dup(tempstring);
  }

  while (tempstring[0] != '4') {
    fgets(tempstring, 80, f);
    tempstring[strlen(tempstring) - 1] = '\0';	/* remove linefeed */
    slut[antal_slut++] = str_dup(tempstring);
  }
  fclose(f);

  /* correct the nr of available syllables... */
  antal_start--;
  antal_mitt--;
  antal_slut--;
  strcpy(namn, start[number(1, antal_start)]);	/* get a start  */
  strcat(namn, mitt[number(1, antal_mitt)]);	/* get a middle */
  strcat(namn, slut[number(1, antal_slut)]);	/* get an ending */
  return namn;
}
