
/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "utils.h"
#include "db.h"
#include "interpreter.h"
#include "comm.h"

extern char *class_types[];

/* CUSTOMIZABLE OPTIONS */

/* Dual system defines */
#define MULTI_MAGIC_USER	(1 << 0)	/* Has dualed to magic user */
#define MULTI_CLERIC		(1 << 1)	/* Has dualed to cleric     */
#define MULTI_THIEF		(1 << 2)	/* Has dualed to thief      */
#define MULTI_WARRIOR		(1 << 3)	/* Has dualed to warrior    */

/* Add new defines above, adding in sequential order. 
 * ie: Next would be (1 << 4) 
 */

/* Set to -1 if you don't want a char to be in a particular room, otherwise
 * set to whatever room you wish.
 */
#define MULTI_ROOM		-1

/* The level you wish to be the dual level */
#define MULTI_LEVEL		5
#define MULTI_MAX_LEVEL		8

/* Stats char should start at after dual */
#define MULTI_HP		20

struct dual_classes {
  char *name;
  int flag;
} dual_class[] = {

  {
    "mage", MULTI_MAGIC_USER
  },
  {
    "cleric", MULTI_CLERIC
  },
  {
    "thief", MULTI_THIEF
  },
  {
    "warrior", MULTI_WARRIOR
  },
  /* Insert new classes here            */
  {
    "\n", 0
  }
};

/* Dual message - modify this message to set dual message */
char *dual_message =
"You have dualed, and must begin anew. However, you will retain knowledge\r\n"
"of your previous skills and spells, you just will not be able to use them\r\n"
"until you reach the appropriate level.\r\n";

/* END CUSTOMIZABLE OPTIONS 

 * Only modify code below this point if you know what you are doing. It is set
 * up however, so that if you are a newbie coder, but want a functional dual
 * system, you will not have to modify ANYTHING below here.
 *
 */

#define MULTI_NAME(i)		(dual_class[i].name)
#define MULTI_FLAG(i)		(dual_class[i].flag)

/* Will parse dual_class for proper passed argument */
int find_dual_flag(char *arg)
{
  int i;

  for (i = 0; *MULTI_NAME(i) != '\n'; i++)
    if (is_abbrev(arg, MULTI_NAME(i)))
      return i;

  return -1;
}

int okay_to_dual(struct char_data *ch, int flag)
{
  int room;

  /* Is wanted class same as current class? */
  if (flag == GET_CLASS(ch)) {
    sprintf(buf, "You are currently a %s!\r\n", class_types[(int) GET_CLASS(ch)]);
    send_to_char(buf, ch);
    return FALSE;
  }
  /* Has char already completed this class? */
  if (MULTI_FLAGGED(ch, MULTI_FLAG(flag))) {
    send_to_char("You can not repeat a class already completed.\r\n", ch);
    return FALSE;
  }
  if (GET_LEVEL(ch) < MULTI_LEVEL) {
    sprintf(buf, "You are only level %d, you must be at least Level %d before you can dual.\r\n",
	    GET_LEVEL(ch), MULTI_LEVEL);
    send_to_char(buf, ch);
    return FALSE;
  }
  if (GET_LEVEL(ch) > MULTI_MAX_LEVEL) {
    send_to_char("You are much to deep into your current training to consider changing it now!\r\n", ch);
    return FALSE;
  }
  /* Is the char in the appropriate room? */
  if (MULTI_ROOM >= 0) {
    room = real_room(MULTI_ROOM);
    if (room >= 0 && ch->in_room != room) {
      send_to_char("This is not the place to learn new knowledges!\r\n", ch);
      return FALSE;
    }
  }
  /* Everything else is okay, return TRUE! */
  return TRUE;
}

void reset_char_stats(struct char_data *ch, int flag)
{
  GET_MAX_HIT(ch) = MULTI_HP;
  GET_HIT(ch) = GET_MAX_HIT(ch);

  GET_LEVEL(ch) = 1;
  GET_CLASS(ch) = flag;
  GET_EXP(ch) = 1;
  SET_BIT(MULTI_FLAGS(ch), MULTI_FLAG(flag));
  GET_TOT_LEVEL(ch)++;

  send_to_char(dual_message, ch);
}

ACMD(do_dual)
{
  int flag;

  one_argument(argument, arg);

  if (!*arg) {
    send_to_char("Usage: dual <class name>\r\n", ch);
    return;
  }
  send_to_char("This functionality has not yet been completed.\r\n", ch);
  return;
  if ((flag = find_dual_flag(arg)) < 0) {
    send_to_char("Improper class name, please try again.\r\n", ch);
    return;
  }
  if (!okay_to_dual(ch, flag))
    return;

  reset_char_stats(ch, flag);
}
