
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>

void error(char *message)
{
    fprintf(stderr, "Error: %s", message);
}


void warning(char *message, int linenum, char *fn)
{
    fprintf(stderr, "%s:Line %d - %s", fn, linenum, message);
}


char *str_dup(char *string)
{
    char *ptr;

    ptr = (char *) malloc(sizeof(char) * (strlen(string) + 1));
    strcpy(ptr, string);
    return(ptr);
}


long decipher_flag_text(char *flags)
{
    char *ptr;
    long vector = 0;

    if (isdigit(*flags))
	return(atol(flags));
    ptr = flags;
    while(isalpha(*ptr)) {
	if (*ptr > 'Z')
	    vector |= (1 << (*ptr - 'a'));
	else
	    vector |= (1 << (*ptr - 'A' + 26));
	ptr++;
    }
    if (*ptr)
	return(-1);
    return(vector);
}



#define	m  (unsigned long)2147483647
#define	q  (unsigned long)127773
#define	a (unsigned int)16807
#define	r (unsigned int)2836

static unsigned long seed;

unsigned long circle_random(void)
{
  register int lo, hi, test;

  hi = seed / q;
  lo = seed % q;

  test = a * lo - r * hi;

  if (test > 0)
    seed = test;
  else
    seed = test + m;

  return seed;
}

int
number (int from, int to)
{
  if (to < from) {
    return ((erandom () % (from - to + 1)) + to);
  }
  return ((erandom () % (to - from + 1)) + from);
}

char *strip_color(const char *string)
{
  static char colorless[256];
  int x, y = 0;

  for (x = 0; x <= strlen(string); x++) {
    if (string[x] == '&') {
      if (string[x + 1] == '+') {
	colorless[y++] = string[x + 3];
	x += 3;
      } else {
	colorless[y++] = string[x + 2];
	x += 2;
      }
    } else {
      colorless[y++] = string[x];
    }
  }
  return colorless;
}
