




/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct index_data *obj_index;

extern struct weather_data weather_info;
extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;

void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype, int which, int location);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);
int dice(int number, int size);
extern struct spell_info_type spell_info[];


struct char_data *read_mobile(int, int);

// First Level Cleric Spells

AROUTINE(r_bless)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_BLESS;
  af->level = level;
  af->duration = 6;
  af->modifier = 1;
  af->location = APPLY_HITROLL;

  affect_to_char(vict, af);

  FREE(af);
  return 1;
}

AROUTINE(r_curse)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_CURSE;
  af->level = level;
  af->modifier = -1;
  af->location = APPLY_HITROLL;
  af->duration = 6;

  affect_to_char(vict, af);
  FREE(af);
  return 1;
}

AROUTINE(r_faerie_fire)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_FAERIE_FIRE;
  af->level = level;
  af->bitvector4 = AFF4_FAERIE_FIRE;
  af->duration = 4 * GET_LEVEL(ch);
  affect_to_char(vict, af);
  FREE(af);
  return 1;
}

AROUTINE(r_sanctuary)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_SANCTUARY;
  af->level = level;
  af->bitvector4 = AFF4_SANCTUARY;
  af->duration = 4 + GET_LEVEL(ch);
  affect_to_char(vict, af);

  FREE(af);
  return 1;
}

// Second Level Cleric Spells

AROUTINE(r_aid)
{
  ((*spell_info[SPELL_BLESS].routines) (level, ch, obj, vict, t_obj, t_loc, 0));
  alter_hit(vict, -dice(1, 8), LOCATION_ALL, 1);
  return 1;
}

AROUTINE(r_barkskin)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_BARKSKIN;
  af->level = level;
  af->modifier = -1;
  af->location = APPLY_AC;
  af->bitvector = AFF_BARKSKIN;
  af->duration = 4 + GET_LEVEL(ch);
  affect_to_char(vict, af);

  FREE(af);
  return 1;
}

// Third Level Cleric Spells

AROUTINE(r_cause_blindness)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_CAUSE_BLINDNESS;
  af->level = level;
  af->bitvector = AFF_BLIND;
  af->duration = -1;

  affect_to_char(vict, af);

  FREE(af);
  return 1;
}

AROUTINE(r_cause_deafness)
{
  struct affected_type *af;

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_CAUSE_DEAFNESS;
  af->level = level;
  af->bitvector4 = AFF4_DEAF;
  af->duration = -1;

  affect_to_char(vict, af);

  FREE(af);
  return 1;
}

AROUTINE(r_cure_blindness)
{

  if (IS_AFFECTED(vict, AFF_BLIND)) {
    REMOVE_BIT(AFF_FLAGS(vict), AFF_BLIND);
    affect_from_char(vict, SPELL_CAUSE_BLINDNESS);
    send_to_char("&+WYour vision returns!\r\n", vict);
  }
  return 1;
}

AROUTINE(r_cure_deafness)
{

  if (IS_AFFECTED4(vict, AFF4_DEAF)) {
    REMOVE_BIT(AFF4_FLAGS(vict), AFF4_DEAF);
    affect_from_char(vict, SPELL_CAUSE_DEAFNESS);
    send_to_char("&+WYour hearing returns!\r\n", vict);
  }
  return 1;
}

// Fourth Level Cleric Spells


// Fifth Level Cleric Spells


// Sixth Level Cleric Spells

AROUTINE(r_heal)
{
  ((*spell_info[SPELL_CURE_BLINDNESS].routines) (level, ch, obj, vict, t_obj, t_loc, 0));
  ((*spell_info[SPELL_CURE_DEAFNESS].routines) (level, ch, obj, vict, t_obj, t_loc, 0));
  ((*spell_info[SPELL_CURE_LIGHT].routines) (level, ch, obj, vict, t_obj, t_loc, saved));
  if (affected_by_spell(vict, SPELL_FEEBLEMIND))
    affect_from_char(vict, SPELL_FEEBLEMIND);
  return 1;
}

// Seventh Level Cleric Spells
