
/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"
#include <signal.h>

#include "structs.h"
#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "spells.h"


/*   external vars  */
extern struct room_data *world;
extern struct char_data *character_list;
extern struct descriptor_data *descriptor_list;
extern struct index_data *mob_index;
extern struct index_data *obj_index;
extern struct zone_data *zone_table;
extern struct time_info_data time_info;
extern char *dirs[];
extern int rev_dir[];
extern char *activating_commands[];
extern char *coin_stringv(int amount);
extern void send_to_zone_indoor(int zone_rnum, char *messg);
extern void send_to_zone_outdoor(int zone_rnum, char *messg);
extern void MobCombat(struct char_data *ch, struct char_data *new_vict);
extern void mobaction(struct char_data *ch, char *string, char *action);
extern void teleport_to(struct char_data *ch, int to_room);
extern ACMD(do_wake);

/* some flags for the apprehender, in spec[2] */
#define APPR_PRISONERS  1
#define APPR_RHETORICAL 2
#define APPR_RETURN     4

int apprehender(struct char_data *ch, struct char_data *pl, int cmd, char *arg)
{
  struct char_data *tch, *temp;
  bool action_made = FALSE, pause = FALSE, found_one;
  char Gbuf1[MAX_STRING_LENGTH], Gbuf4[MAX_STRING_LENGTH], name[MAX_INPUT_LENGTH],
   message[MAX_INPUT_LENGTH];
  int to_room, temp_room, i;
  //struct affected_type af;
  const int jail_zones[][2] =
  {
    {5000, 5099},
    {5100, 5132},
    {5200, 5099},
    {5300, 5132},
    {5400, 5099},
    {5500, 5132},
    {5600, 5099},
    {5700, 5132},
    {5800, 5099},
    {5900, 5132},
    {-1, -1}
  };

  if (!AWAKE(ch) || !IS_GUARD(ch) || IS_PC(ch))
    return FALSE;

//  send_to_room("DEBUG: apprehender called\r\n", ch->in_room);
  if (pl) {
    if ((pl->char_specials.saved.arrest_by != ch) || !AWAKE(pl))
      return FALSE;
    if (cmd) {
      if (CMD_IS("tell")) {
	if (GET_MOB_SPEC_VALUE(ch, 2) & APPR_RHETORICAL) {
	  half_chop(arg, name, message);
	  if (ch != get_char_room_vis(pl, name))
	    return FALSE;
	  if (message)
	    strcpy(arg, message);
	  if (strstr(arg, "yes"))
	    mobsay(ch, "That was a rhetorical question, bub.");
	  else if (strstr("no", arg))
	    mobsay(ch, "I hope that is the case.");
	}
      }
      if (CMD_IS("say")) {
	if (GET_MOB_SPEC_VALUE(ch, 2) & APPR_RHETORICAL) {
	  mobsay(pl, arg);
	  if (strstr(arg, "yes"))
	    mobsay(ch, "That was a rhetorical question.");
	  else if (strstr("no", arg))
	    mobsay(ch, "I hope that is the case.");
	}
      }
      // do we prevent players completely? being bound should accomplish that
      if (0 /*IS_AGG_CMD(cmd) */ ) {
	message[0] = 0;
	strcat(message, GET_NAME(pl));
	strcat(message, "None of that while you are in my custody!");
	mobsay(ch, message);
	return TRUE;
      }
    }
  } else if (IS_FIGHTING(ch)) {
    switch (number(0, 10)) {
    case 0:
      mobsay(ch, "Resistance is stupid!");
      break;
    case 1:
      mobsay(ch, "I'm gonna tear you a new asshole, boy*!");
      break;
    case 2:
      mobaction(ch, 0, "cackle");
      mobsay(ch, "Your blood shall paint these streets&!");
      break;
    }
  } else {
    GET_MOB_SPEC_VALUE(ch, 2) &= ~APPR_RHETORICAL;
    send_to_room("DEBUG: apprehender is looking for a battle.\r\n", ch->in_room);
#if 0
    if (IS_SET(ch->only.npc->npcact, NPC_OUTLAW)) {
      /* Release arrested people? */
      switch (number(1, 15)) {
      case 1:
	act("$n fidgets.", TRUE, ch, 0, 0, TO_ROOM);
	break;
      case 2:
	mobsay(ch, "Ack! I dont know what to do with myself.");
	break;
      case 3:
	do_action(ch, 0, CMD_CRY);
	break;
      default:
	break;
      }
      /* Get rid of the arrested people to avoid the */
      /* possibility of strange loops and the like   */
      for (tch = ch->char_specials.saved.arrest_link; tch; tch = ch->char_specials.saved.arrest_link) {
	tch->char_specials.saved.arrest_by = NULL;
	ch->char_specials.saved.arrest_link = tch->char_specials.saved.arrest_link;
	tch->char_specials.saved.arrest_link = NULL;
      }
      return FALSE;
    }
#endif
    if (!FIGHTING(ch))
      for (tch = world[ch->in_room].people; tch; tch = tch->next_in_room)
	if (IS_HUMANOID(tch) && /*CAN_SEE(ch, tch) && */ (tch != ch) &&
	    FIGHTING(tch)) {
//        send_to_room("DEBUG: apprehender found a battle going on!\r\n", ch->in_room);
	  if (IS_HUMANOID(FIGHTING(tch)) && !IS_GUARD(tch) &&
	      !IS_GUARD(FIGHTING(tch))) {
	    stop_fighting(tch);
	    action_made = TRUE;
	  } else if (IS_GUARD(tch) && !action_made) {
//          do_action(ch, 0, CMD_CACKLE);
	    MobCombat(ch, FIGHTING(tch));
	    break;
	  }
	}
    if (action_made) {
      mobsay(ch, "Break it up! Break it up!");
      act("$n stops the fight.", TRUE, ch, 0, 0, TO_ROOM);
      mobsay(ch, "Now, do I have to take you people in?");
      GET_MOB_SPEC_VALUE(ch, 2) |= APPR_RHETORICAL;
      return TRUE;
    }
    if (!(GET_MOB_SPEC_VALUE(ch, 2) & APPR_RETURN)) {
      found_one = FALSE;
      for (tch = world[ch->in_room].people; tch; tch = tch->next_in_room) {
	if ( /*IS_OUTLAW(tch) && */ !tch->char_specials.saved.arrest_by &&
	    (GET_POS(ch) > STAT_INCAP)) {
	  if (!AWAKE(tch)) {
	    strcpy(Gbuf1, GET_NAME(tch));
	    do_wake(ch, Gbuf1, 0, 0);
	    mobsay(ch, "Wake up, Outlaw!");
	  } else if (GET_STAT(tch) > STAT_SLEEPING) {
	    if (!found_one) {
	      if (!(tch && GET_NAME(tch))) {
		log("assert: error in apprehender() proc");
		raise(SIGSEGV);
	      }
	      sprintf(Gbuf4, "You're coming with me, %s!", FirstWord(GET_NAME(tch)));
	      mobsay(ch, Gbuf4);
	      found_one = TRUE;
	    } else {
	      if (!(tch && GET_NAME(tch))) {
		log("assert: error in apprehender() proc");
		raise(SIGSEGV);
	      }
	      sprintf(Gbuf4, "You too, %s!", FirstWord(GET_NAME(tch)));
	      mobsay(ch, Gbuf4);
	    }
	    if (!MIN_POS(tch, POS_STANDING + STAT_RESTING)) {
	      SET_POS(tch, POS_STANDING + STAT_NORMAL);
	      act("$n forces $N on $S feet.", TRUE, ch, 0, tch, TO_NOTVICT);
	      act("$n forces you on your feet.", FALSE, ch, 0, tch, TO_VICT);
	    }
	    tch->char_specials.saved.arrest_by = ch;
	    tch->char_specials.saved.arrest_link = ch->char_specials.saved.arrest_link;
	    ch->char_specials.saved.arrest_link = tch;
	    GET_MOB_SPEC_VALUE(ch, 2) |= APPR_PRISONERS;
	    pause = TRUE;
	  }
	}
      }
    }
    if ((GET_MOB_SPEC_VALUE(ch, 2) & APPR_PRISONERS) && !pause) {
      for (to_room = -1, i = 0; jail_zones[i][1] != NOWHERE; i++)
	if (world[ch->in_room].zone == world[real_room(jail_zones[i][0])].zone)
	  to_room = real_room(jail_zones[i][1]);

      if (to_room == -1) {
	mobsay(ch, "Eek!  Someone has stolen the jail!");
	GET_MOB_SPEC_VALUE(ch, 2) = 0;
	return FALSE;
      }
      mobsay(ch, "Shoot! Im a little lost.");
      act("$n snaps $s fingers.", FALSE, ch, 0, 0, TO_ROOM);
      temp_room = ch->in_room;
      teleport_to(ch, to_room);
      /* To follow the in-room list of chars, we need */
      /* to save the next guy ahead of us before we   */
      /* teleport, so we don't teleport people in the */
      /* place we're teleporting to...                */
      for (temp = ch->char_specials.saved.arrest_link; temp; temp = ch->char_specials.saved.arrest_link) {
#if 0

	/* This partially completed piece is intended to allow outlaws to rent
	   without the game crashing.  rent code and apprehender don't
	   comunicate, so apprehender never knows when a player leaves the
	   game. he then references memory already freed.  and boom!  What
	   needs to be done: create strucure holding renters name,
	   arrested_link, and pointer to next renter.  add any outlaw renters
	   to this list in receptionist code.  and finish up here..:P --TAM */

	if (rented_outlaw_list) {	/* at least one outlaw rented */
	  if (!rented_outlaw_list->next) {	/* only one outlaw rented */
	    if (rented_outlaw_list == temp) {
	      sprintf(Gbuf4, "outlaw (%s) rented before jailed", rented_outlaw_list->name);
	      log(Gbuf4);
	      ch->char_specials.saved.arrest_link = rented_outlaw_list->arrest_link;
	      free((void *) rented_outlaw_list);
	      rented_outlaw_list = NULL;
	      continue;
	    }
	  } else		/* at least two outlaws rented */
	    for (rented = rented_outlaw_list; rented->next; rented = rented->next)
	      if (rented == ch) {
		ch->char_specials.saved.arrest_link = rented->arrest_link;
		sprintf(Gbuf4, "outlaw (%s) rented before jailed", rented->name);
		log(Gbuf4);
		rented->
		    continue;
	      }
	}
#endif
	if (temp->in_room != temp_room) {
	  sprintf(Gbuf4, "%s You cant get away that easily, bub!", GET_NAME(temp));
	  mobsay(ch, Gbuf4);
	}
	teleport_to(temp, to_room);
	temp->char_specials.saved.arrest_by = NULL;
	ch->char_specials.saved.arrest_link = temp->char_specials.saved.arrest_link;
	temp->char_specials.saved.arrest_link = NULL;
	if (temp->char_specials.saved.jail_time) {
	  /* player has escaped from jail, Muhahahah! */
	  mobsay(ch, "An escape artist eh?  Well we have ways to deal with you slippery types!");
	  temp->char_specials.saved.jail_time += 50;
	  /*
	     bzero(&af, sizeof(af));
	     af.type = SPELL_MAJOR_PARALYSIS;
	     af.duration = (temp->char_specials.saved.jail_time / 6) + 1;
	     SET_CBIT(af.sets_affs, AFF_MAJOR_PARALYSIS);
	     affect_join(temp, &af, FALSE, FALSE);
	   */
	  act("$n claps $N in irons, and chains $M to the wall.",
	      FALSE, ch, 0, temp, TO_NOTVICT);
	  act("$n claps you in irons, and chains you to the wall.",
	      FALSE, ch, 0, temp, TO_VICT);
	}
      }
      GET_MOB_SPEC_VALUE(ch, 2) |= APPR_RETURN;
      GET_MOB_SPEC_VALUE(ch, 2) &= ~APPR_PRISONERS;
      GET_MOB_SPEC_VALUE(ch, 3) = temp_room;
    } else if (GET_MOB_SPEC_VALUE(ch, 2) & APPR_RETURN) {
      mobsay(ch, "Sorry I cant stay, but I have work to do!");
      teleport_to(ch, GET_MOB_SPEC_VALUE(ch, 3));
      act("$n smiles inwardly at a job well done.", TRUE, ch, 0, 0, TO_ROOM);
      GET_MOB_SPEC_VALUE(ch, 2) = 0;	/* change for extra flags */
    }
  }
  return FALSE;
}


int witness(struct char_data *ch, struct char_data *pl, int cmd, char *arg)
{
  struct char_data *vict = NULL;
  char Gbuf1[MAX_STRING_LENGTH], Gbuf2[MAX_STRING_LENGTH], Gbuf3[MAX_STRING_LENGTH];

  if (!AWAKE(ch))
    return FALSE;

  if (pl) {
    if (!IS_HUMANOID(pl) || !CAN_SEE(ch, pl))
      return FALSE;
    if (0 /*IS_AGG_CMD(cmd) */ ) {
      one_argument(arg, Gbuf1);
      if (!(vict = get_char_room_vis(pl, Gbuf1)))
	return FALSE;
      if (!IS_HUMANOID(vict))
	return FALSE;
      if (FIGHTING(vict) == pl)
	return FALSE;
      argument_interpreter(arg, Gbuf1, Gbuf2);
      if ((FIGHTING(vict) == ch) || (FIGHTING(ch) == vict)) {
	if (!(pl && GET_NAME(pl))) {
	  log("assert: error in witness() proc");
	  raise(SIGSEGV);
	}
	sprintf(Gbuf3, "%s Hey, thanks!", FirstWord(GET_NAME(pl)));
	mobsay(ch, Gbuf3);
	return FALSE;
      }
      if (!ch->char_specials.saved.witnessing) {
	ch->char_specials.saved.witnessing = pl;
	ch->char_specials.saved.witness_vict = vict;
	ch->char_specials.saved.witness_cmd = cmd;
      }
    }
  } else {
    if (ch->char_specials.saved.witnessing) {
      if (FIGHTING(ch->char_specials.saved.witnessing) ==
	  ch->char_specials.saved.witness_vict) {
	if (ch->char_specials.saved.witness_vict == ch)
	  sprintf(Gbuf3, "%s is an Outlaw! %s %s me!",
		  PERS(ch->char_specials.saved.witnessing, ch, TRUE),
		  HSSH(ch->char_specials.saved.witnessing),
//                (ch->char_specials.saved.witness_cmd == CMD_STEAL) ? "stole from" : "attacked");
		  "victimized");
	else if (!(ch->char_specials.saved.witness_vict && GET_NAME(ch->char_specials.saved.witness_vict))) {
	  log("assert: error in witness() proc");
	  raise(SIGSEGV);
	}
	sprintf(Gbuf3, "shout *Guards! %s is an Outlaw! I saw %s %s %s!",
		PERS(ch->char_specials.saved.witnessing, ch, TRUE),
		HMHR(ch->char_specials.saved.witnessing),
//              (ch->char_specials.saved.witness_cmd == CMD_STEAL) ? "steal from" : "attack",
		"victimize",
	      FirstWord(GET_NAME(ch->char_specials.saved.witness_vict)));
	command_interpreter(ch, Gbuf3);
      }
      ch->char_specials.saved.witnessing = NULL;
      ch->char_specials.saved.witness_vict = NULL;
      ch->char_specials.saved.witness_cmd = 0;
    }
  }
  if (pl) {
    return (0);
  } else if (MIN_POS(ch, POS_STANDING + STAT_NORMAL)) {
    switch (dice(3, 6)) {
    case 3:
      act("$n looks about for signs of trouble.", TRUE, ch, 0, 0, TO_ROOM);
      break;
    case 4:
      act("$n kicks a stone on the ground, as if somewhat bored.", TRUE, ch, 0, 0, TO_ROOM);
      break;
    case 5:
      act("$n smiles at you.", TRUE, ch, 0, 0, TO_ROOM);
      break;
    case 6:
      act("$n stands tall and strong, obviously proud of his position.", TRUE, ch, 0, 0, TO_ROOM);
      break;
    default:
      break;
    }
  } else if (IS_FIGHTING(ch)) {
    switch (dice(1, 4)) {
    case 1:
      act("$n", TRUE, ch, 0, 0, TO_ROOM);
      break;
    case 2:
      mobsay(ch, "I will see to it that you rot in a dark dungeon for this!");
      break;
    case 3:
      act("$n growls, and comes on with even more ferocity.", TRUE, ch, 0, 0, TO_ROOM);
      break;
    case 4:
      strcpy(buf, "Brethren, come help me! This foul outlaw needs a good lesson!");
      mobsay(ch, buf);
      break;
    default:
      break;
    }
  }
  return FALSE;
}

int judge(struct char_data *ch, struct char_data *pl, int cmd, char *arg)
{
  return FALSE;
}

/* This relies on the jail room being one number higher than the */
/* room in which the jailkeeper resides...                       */

/* needs rewrite for new law system. JAB */
int jailkeeper(struct char_data *ch, struct char_data *pl, int cmd, char *arg)
{
#if 0
  struct char_data *k, temp_ch;
  struct obj_data *obj;
  bool change_room, feeding = FALSE;
  char Gbuf1[MAX_STRING_LENGTH], Gbuf4[MAX_STRING_LENGTH];
  int room;
  struct affected_type af;

  if (room == top_of_world - 1 || !IS_SET(world[ch->in_room + 1].room_flags, JAIL)) {
    return FALSE;		/* temporary solution */
  }
  if (IS_FIGHTING(ch))
    return FALSE;

  if (pl) {
    switch (cmd) {
      /* movement commands
         case CMD_NORTH:
         case CMD_EAST:
         case CMD_SOUTH:
         case CMD_WEST:
         case CMD_UP:
         case CMD_DOWN:
         if (
         case ...unlock..:
         case ...open..:
         break;
       */

    case CMD_STEAL:
      argument_interpreter(arg, Gbuf1, Gbuf4);
      if (ch == get_char_room_vis(pl, Gbuf4) && !IS_TRUSTED(pl)) {
	strcpy(Gbuf4, pl->player.name);
	do_action(ch, Gbuf4, CMD_SLAP);
	return TRUE;
      }
      break;
    default:
      break;
    }
  } else {
    if (GET_STAT(ch) == STAT_SLEEPING) {
      do_wake(ch, "", 0, 0);
      return FALSE;
    }
    if (GET_POS(ch) < POS_STANDING) {
      do_stand(ch, 0, 0);
      return FALSE;
    }
    change_room = FALSE;
    /* Check the current room for outlaws */
    for (k = world[ch->in_room].people; k; k = k->next_in_room)
      if ((k != ch) && IS_OUTLAW(k) && !IS_TRUSTED(k)) {
	change_room = TRUE;
	break;
      }
    /* Check the jail room for various things */
    for (k = world[ch->in_room + 1].people; k; k = k->next_in_room) {
      if (IS_NPC(k) && IS_GUARD(k) && (GET_MOB_SPEC_VALUE(k, 2) & APPR_RETURN))
	continue;
      if (IS_OUTLAW(k) && !IS_TRUSTED(k) && !LAW_FREE(k))
	k->char_specials.saved.jail_time--;
      if ((!IS_OUTLAW(k) || !k->char_specials.saved.jail_time || (k->specials.jail_time <= -1)) && !IS_TRUSTED(k))
	change_room = TRUE;
    }

    if (!time_info.hour % 8) {
      if (GET_MOB_SPEC_VALUE(ch, 0)) {
	feeding = TRUE;
	change_room = TRUE;
	GET_MOB_SPEC_VALUE(ch, 0) = 1;
      }
    } else
      GET_MOB_SPEC_VALUE(ch, 0) = 0;

    if (!change_room) {
      do_close(ch, "door", 0);
      do_lock(ch, "door", 0);
      return FALSE;
    }
    room = ch->in_room;
    /* Open a passage, if possible */
    do_unlock(ch, "door", 0);
    do_open(ch, "door", 0);
    /* Throw in any outlaws */
    for (k = world[ch->in_room].people; k; k = temp_ch) {
      temp_ch = k->next_in_room;
      if ((k != ch) && IS_OUTLAW(k) && !IS_TRUSTED(k)) {
	if (k->char_specials.saved.jail_time) {
	  /* player has escaped from jail, Muhahahah! */
	  mobsay(ch, "Laws are laws, buddy.");
	  k->char_specials.saved.jail_time += 50;
	  mobsay(ch, "An escape artist eh?  Well we have ways to deal with you slippery types!");
	  bzero(&af, sizeof(af));
	  af.type = SPELL_MAJOR_PARALYSIS;
	  af.duration = (k->char_specials.saved.jail_time / 6) + 1;
	  SET_CBIT(af.sets_affs, AFF_MAJOR_PARALYSIS);

	  affect_join(k, &af, FALSE, FALSE);

	  act("$n claps $N in irons!", FALSE, ch, 0, k, TO_NOTVICT);
	  act("$n claps you in irons!", FALSE, ch, 0, k, TO_VICT);
	} else {
	  mobsay(ch, "Turning yourelf in, eh?");
	  k->char_specials.saved.jail_time = 120;
	}
	act("$N throws you in the cell.", FALSE, k, 0, ch, TO_CHAR);
	act("$N throws $n in the cell.", FALSE, k, 0, ch, TO_NOTVICT);
	char_from_room(k);
	char_to_room(k, room + 1, 0);
	act("$n is thrown into the room.", FALSE, k, 0, 0, TO_ROOM);
      }
    }
    act("$n enters the cell.", TRUE, ch, 0, 0, TO_ROOM);
    char_from_room(ch);
    char_to_room(ch, room + 1, 0);
    act("$n enters the cell.", TRUE, ch, 0, 0, TO_ROOM);

    for (k = world[ch->in_room].people; k; k = temp_ch) {
      temp_ch = k->next_in_room;
      if (IS_TRUSTED(k) || (ch == k))
	continue;
      if (!IS_OUTLAW(k)) {
	if (IS_NPC(k) && !IS_GUARD(k) && !(GET_MOB_SPEC_VALUE(k, 2) & APPR_RETURN)) {
	  /* in case jailer realizes shapechanger is the outlaw - TAM */
	  if (k->desc && k->desc->original && !k->switched) {
	    /* if they've been caught shapeshifting */
	    if (IS_OUTLAW(k)) {
	      if (number(1, 5) == 1) {
		sprintf(Gbuf4, "point %s", GET_NAME(k));
		command_interpreter(ch, Gbuf4);
		sprintf(Gbuf4, "Bloody shapeshifters think they're SO tricky.");
		mobsay(ch, Gbuf4, 0);
		sprintf(Gbuf4, "%s Hark me advice; that'll do you NO good.", GET_NAME(k));
		mobsay(ch, Gbuf4, 0);
	      }
	      continue;
	    }
	    /* caught in the act of shapeshifting! */
	    if (number(1, 5) == 1) {
	      act(0, FALSE, ch, 0, 0, TO_ROOM);
	      sprintf(Gbuf4, "I know what kinda tricks you shapeshifters pull!");
	      mobsay(ch, Gbuf4, 0);
	      sprintf(Gbuf4, "But, don't EVEN try it in my jail!!");
	      mobsay(ch, Gbuf4, 0);
	      sprintf(Gbuf4, "Oh, and, I'll be keeping a keen eye on YOU.");
	      mobsay(ch, Gbuf4, 0);
	      act(0, FALSE, ch, 0, 0, TO_ROOM);
	      k->desc->character->only.pc->law_flags |= PLR_SHAPECHANGER;
	      k->only.pc->law_flags = (int) k->desc->original->only.pc->law_flags;
	      continue;
	    }
	  } else if (k->only.pc->law_flags & PLR_SHAPECHANGER && IS_OUTLAW(k)) {
	    if (number(1, 5) == 1) {
	      sprintf(Gbuf4, "point %s", GET_NAME(k));
	      command_interpreter(ch, Gbuf4);
	      sprintf(Gbuf4, "Bloody shapeshifters think they're SO tricky.");
	      mobsay(ch, Gbuf4, 0);
	      sprintf(Gbuf4, "%s Hark me advice; that'll do you NO good.", GET_NAME(k));
	      mobsay(ch, Gbuf4, 0);
	    }
	    continue;
	  }
	  if (!(k && GET_NAME(k))) {
	    log("assert: error in jailkeeper() proc");
	    raise(SIGSEGV);
	  }
	  sprintf(Gbuf4, "What are you doing in here, %s?", FirstWord(GET_NAME(k)));
	  mobsay(ch, Gbuf4, 0);
	  act("$n tosses $N out of the cell.", TRUE, ch, 0, k, TO_NOTVICT);
	  act("$n tosses you out of the cell.", FALSE, ch, 0, k, TO_VICT);
	  char_from_room(k);
	  char_to_room(k, room, 0);
	  act("$n is tossed from the cell.", TRUE, k, 0, 0, TO_ROOM);
	  do_look(k, 0, 0);
	}
      } else if (!k->char_specials.saved.jail_time) {
	strcpy(Gbuf4, GET_NAME(k));
	do_action(ch, Gbuf4, CMD_SMILE);
	if (!(k && GET_NAME(k))) {
	  log("assert: error in jailkeeper() proc");
	  raise(SIGSEGV);
	}
	sprintf(Gbuf4, "You are free to go, %s.", FirstWord(GET_NAME(k)));
	mobsay(ch, Gbuf4, 0);
	act("$n lets $N out of the cell.", TRUE, ch, 0, k, TO_NOTVICT);
	act("$n lets you out of the cell.", FALSE, ch, 0, k, TO_VICT);
	char_from_room(k);
	char_to_room(k, room, 0);
	act("$n has arrived.", FALSE, k, 0, 0, TO_ROOM);
	/*    REMOVE_BIT(k->only.npc->npcact, NPC_OUTLAW);  */
	if (IS_PC(k)) {		/* else */
	  REMOVE_BIT(k->only.pc->law_flags, PLR_OUTLAW);

#if 0
	  /* Get rid of "jailer knows captive is shapshifter" flag -- TAM */
	  if (k->desc && k->desc->original && !k->switched)
	    REMOVE_BIT(k->desc->original->only.pc->law_flags, PLR_SHAPECHANGER);
	  else
	    REMOVE_BIT(k->only.pc->law_flags, PLR_SHAPECHANGER);
#endif
	}
      } else if (k->char_specials.saved.jail_time <= -1) {
	k->char_specials.saved.jail_time = 150;		/* ought to #define */
	act("$n points a finger at $N.", TRUE, ch, 0, k, TO_NOTVICT);
	act("$n points a finger at you.", TRUE, ch, 0, k, TO_VICT);
	if (!(k && GET_NAME(k))) {
	  log("assert: error in jailkeeper() proc");
	  raise(SIGSEGV);
	}
	sprintf(Gbuf4, "I hope you enjoy your stay, %s.", FirstWord(GET_NAME(k)));
	mobsay(ch, Gbuf4, 0);
      }
    }

    if (feeding) {
      for (k = world[ch->in_room].people; k; k = k->next_in_room)
	if (!IS_TRUSTED(k) && ch != k) {
	  obj = read_object(3010, VIRTUAL);
	  obj_to_char(obj, ch);
	  if (!(obj && obj->name)) {
	    log("assert: error in jailkeeper() proc");
	    raise(SIGSEGV);
	  }
	  sprintf(Gbuf4, "%s to %s", FirstWord(obj->name), GET_NAME(k));
	  do_give(ch, Gbuf4, 0);

	  obj = read_object(3100, VIRTUAL);
	  obj_to_char(obj, ch);
	  if (!(obj && obj->name)) {
	    log("assert: error in jailkeeper() proc");
	    raise(SIGSEGV);
	  }
	  sprintf(Gbuf4, "%s to %s", FirstWord(obj->name), GET_NAME(k));
	  do_give(ch, Gbuf4, 0);
	}
    }
    act("$n leaves the cell.", TRUE, ch, 0, 0, TO_ROOM);
    char_from_room(ch);
    char_to_room(ch, room, 0);
    act("$n has arrived.", TRUE, ch, 0, 0, TO_ROOM);
    do_close(ch, "door", 0);
    do_lock(ch, "door", 0);
  }
#endif
  return FALSE;
}


int jailtally(struct obj_data *obj, struct char_data *ch, int cmd, char *arg)
{
  struct char_data *k;
  struct obj_data *t_obj;
  char Gbuf1[MAX_STRING_LENGTH];
  int room;

  if (!ch)
    return FALSE;

  if (CMD_IS("read") && ch && MIN_POS(ch, POS_KNEELING + STAT_RESTING)) {
    while (isspace(*arg))
      arg++;
    t_obj = get_obj_in_list_vis(ch, arg, world[ch->in_room].contents);
    if (t_obj == obj) {
      if (IS_SET(world[ch->in_room].room_flags, ROOM_JAIL))
	room = ch->in_room;
      else if (IS_SET(world[ch->in_room + 1].room_flags, ROOM_JAIL))
	room = ch->in_room + 1;
      else
	return FALSE;
      send_to_char("The tally sheet lists the following inmates:\n", ch);
      for (k = world[room].people; k; k = k->next_in_room) {
	if (k->char_specials.saved.jail_time) {
	  sprintf(Gbuf1, "$N - %d hours", (int) (k->char_specials.saved.jail_time / 6) + 1);
	  act(Gbuf1, FALSE, ch, 0, k, TO_CHAR);
	}
      }
      return TRUE;
    }
  }
  return FALSE;
}



#ifdef CONFIG_JAIL

int cell_drunk(struct char_data *ch, struct char_data *pl, int cmd, char *arg)
{
  struct char_data *c_obj = 0;
  char Gbuf1[MAX_STRING_LENGTH], Gbuf2[MAX_STRING_LENGTH];

  if (IS_OUTLAW(ch))
    k->char_specials.saved.jail_time = 120;

  /* Pc-Mobile interaction engine */

  if ((GET_STAT(ch) < STAT_SLEEPING) || (IS_FIGHTING(ch)))
    return FALSE;

  if (!calltype) {
    argument_interpreter(arg, Gbuf1, Gbuf2);
    if (*Gbuf1)
      c_obj = get_char_room(Gbuf1, ch->in_room);
    switch (cmd) {
    case CMD_SMILE:
    case CMD_STRUT:
    case CMD_DREAM:
    case CMD_POSE:
    case CMD_CHEER:
    case CMD_HI5:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N vomits all over $n, giving him something to frown about..", TRUE, ch, 0, 0, TO_ROOM);
      act("$N vomits all over your clothing, giving you something to frown about.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_INSULT:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_insult(pl, arg, 0);
      act("$N humbles you with a greater insult.", FALSE, pl, 0, ch, TO_CHAR);
      act("$N snaps back with a greater insult.", FALSE, pl, 0, ch, TO_ROOM);
      return TRUE;
      break;
    case CMD_POKE:
      /* An exchange of poking */
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, arg, CMD_POKE);
      act("$N pokes you back.", FALSE, pl, 0, ch, TO_CHAR);
      act("$N pokes $n back.", TRUE, pl, 0, ch, TO_ROOM);
      return TRUE;
      break;
    case CMD_KISS:
    case CMD_SNUGGLE:
    case CMD_CUDDLE:
    case CMD_CRY:
    case CMD_FONDLE:
    case CMD_GROPE:
    case CMD_LOVE:
    case CMD_NIBBLE:
    case CMD_SQUEEZE:
    case CMD_FRENCH:
    case CMD_SEDUCE:
    case CMD_UNDRESS:
    case CMD_BATHE:
    case CMD_FLIRT:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, arg, cmd);
      act("$N spits and coughs in disgust saying, 'Bleh!'.", TRUE, pl, 0, ch, TO_ROOM);
      act("$N spits and coughs in disgust saying, 'Bleh!'.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_PUKE:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N sees $n puke, and begins vomiting uncontrollably.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N sees you puke, and begins vomiting uncontrollably.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_CACKLE:
    case CMD_SCREAM:
    case CMD_APPLAUD:
    case CMD_SING:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N says, 'Will ya keep it down, $n? My head hurts!'.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N says, 'Will ya keep it down? My head hurts!'.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_SNIFF:
    case CMD_WHINE:
    case CMD_WINCE:
    case CMD_ACK:
    case CMD_GRUMBLE:
    case CMD_WHATEVER:
    case CMD_HISS:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N says, 'Quit cryin' about it, we're all in this together.'", TRUE, ch, 0, 0, TO_ROOM);
      act("$N says, 'Quit cryin about it, we're all in this together.'", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_BURP:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N applauds and says with great cheer, 'Worthy! Good one!'.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N applauds and says with great cheer, 'Worthy! Good one!", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_FART:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N says, 'Oh, god..  Will ya do that outside?!?'.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N says, 'Oh, god..  Will ya do that outside?!?'.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_SLAP:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N slaps $n back with great cheer, thinking it all a game.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N slaps you back with great cheer, thinking it all a game.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_LAUGH:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N frowns and says, 'What are YOU laughin' about, $n?'.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N frowns and says, 'What are YOU laughin' about, bub?'.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_HUG:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N says, 'Don't hug me, $n, ya smell awful!'.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N says, 'Don't hug me jailbait, ya smell awful!'.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_GRIN:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N grins and whispers something to $n", TRUE, ch, 0, 0, TO_ROOM);
      act("$n grins and whispers to you, 'Got a plan mate?'.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_GASP:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N says with alarm, 'What, WHAT?'.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N says with alarm, 'What, WHAT?'.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    case CMD_POUT:
      if ((c_obj != ch) || (!AWAKE(ch)))
	return FALSE;
      do_action(pl, Gbuf1, cmd);
      act("$N says, 'Quit yer pouting, $n, and think of a way outta here'.", TRUE, ch, 0, 0, TO_ROOM);
      act("$N says, 'Quit yer poutin' and think of a way outta here'.", FALSE, pl, 0, ch, TO_CHAR);
      return TRUE;
      break;
    default:
      return FALSE;
      break;
    }
  }
  if (pl) {
    return (0);
  } else {
    if (MIN_POS(ch, POS_STANDING + STAT_NORMAL)) {
      switch (number(2, 14)) {
      case 2:
	mobsay(ch, "Jailer!! Lemme outta here, you worthless piece of shit!");
	break;
      case 3:
	mobsay(ch, "Ooohhh, my head hurts. I got such a hangover!");
	break;
      case 4:
	mobsay(ch, "Psssst. Hey, lets make a plan and bust outta here..");
	break;
      case 5:
	mobsay(ch, "Aarrrg. Aye, Jailer! I gotta take a dump, man!.");
	break;
      case 6:
	mobsay(ch, "Ammamma immma I'mma I'm thirsty, got any brew, mate?");
	break;
      case 7:
	mobsay(ch, "Wwaaa, whereee where am I?! Take me back to the bar!");
	break;
      case 8:
	mobsay(ch, "Hey, jailer! Gimme some ale, I'm dyin' a thirst in here!");
	break;
      case 9:
	mobsay(ch, "Damn! The cell door keeps moving on me!");
	break;
      case 10:
	mobsay(ch, "A-A-Anyone got some cards?");
	break;
      case 11:
	act("$n turns green.", TRUE, ch, 0, 0, TO_ROOM);
	mobsay(ch, "Maaan, I thhhink I'm gonna puke.");
	break;
      case 12:
	mobsay(ch, "Damn! S-Somebody needs a bath!");
	break;
      case 13:
	mobsay(ch, "You really suck..  You know that?");
	act("$n giggles", TRUE, ch, 0, 0, TO_ROOM);
	break;
      case 14:
	mobsay(ch, "I feel like I live here, maaaan.");
	break;
      default:
	break;
      }
    }
  }
  return FALSE;
}
#endif
