/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

#include "conf.h"
#include "sysdep.h"

#include "structs.h"
#include "dg_scripts.h"
#include "utils.h"
#include "comm.h"
#include "spells.h"
#include "handler.h"
#include "db.h"

extern struct room_data *world;
extern struct obj_data *object_list;
extern struct char_data *character_list;
extern struct index_data *obj_index;

extern struct descriptor_data *descriptor_list;
extern struct zone_data *zone_table;

extern int mini_mud;

extern struct default_mobile_stats *mob_defaults;
extern char weapon_verbs[];
extern int *max_ac_applys;
extern struct apply_mod_defaults *apmd;
void command_interpreter(struct char_data *ch, char *argument);
void clearMemory(struct char_data *ch);
void act(char *str, int i, struct char_data *c, struct obj_data *o,
	 void *vict_obj, int j);

void damage(struct char_data *ch, struct char_data *victim,
	    int damage, int weapontype, int which, int location);

void weight_change_object(struct obj_data *obj, int weight);
void add_follower(struct char_data *ch, struct char_data *leader);
int dice(int number, int size);
extern struct spell_info_type spell_info[];
void raw_kill(struct char_data *ch, struct char_data *killer);

struct char_data *read_mobile(int, int);

/* First Level Magic-User Spells */

ASPELL(spell_armor)
{
  act("The air thickens around $n.", FALSE, victim, NULL, NULL, TO_PROXIMITY2);
  act("The air thickens around you.", FALSE, ch, NULL, victim, TO_VICT);

  ((*spell_info[SPELL_ARMOR].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_burning_hands)
{
  int dam;
  struct char_data *target, *tar_next;

  if (level > 10)
    level = 10;

  dam = dice(1, 3) + (level * 2);

  act("Jets of searing &+Rflame&n shoot from $n's fingertips.", TRUE,
      ch, NULL, victim, TO_PROXIMITY2);
  act("Jets of searing &+Rflame&n shoot from your fingertips.", TRUE,
      ch, NULL, victim, TO_CHAR);
  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_BURNING_HANDS)) {
      act("&+RFlames&n sear your flesh.", TRUE, ch, NULL, target,
	  TO_VICT);
      act("The &+Rflames&n sear $N's flesh.", TRUE, ch, NULL, target,
	  TO_OTHERS);
      act("The &+Rflames&n sear $N's flesh.", TRUE, ch, NULL, target,
	  TO_CHAR);
      damage(ch, target, dam, SPELL_BURNING_HANDS, -1, -1);
    }
  }
}

ASPELL(spell_charm_person)
{
  if (victim == NULL || ch == NULL)
    return;

  if (victim == ch)
    send_to_char("You like yourself even better!\r\n", ch);
  else if (MOB_FLAGGED(victim, MOB_NOCHARM))
    send_to_char("Your victim resists!\r\n", ch);
  else if (IS_AFFECTED(ch, AFF_CHARM))
    send_to_char("You can't have any followers of your own!\r\n", ch);
  else if (IS_AFFECTED(victim, AFF_CHARM))
    send_to_char("You fail.\r\n", ch);
  else if (circle_follow(victim, ch))
    send_to_char("Sorry, following in circles can not be allowed.\r\n", ch);
  else if (!(IS_HUMANOID(victim)))
    send_to_char("This will only work on humanoid creatures.\r\n", ch);
  else if (!makes_save(victim, savetype, 0)) {
    act("Isn't $n just such a nice fellow?", FALSE, ch, 0, victim, TO_VICT);
    ((*spell_info[SPELL_CHARM_PERSON].routines) (level, ch, NULL, victim, obj, loc, SPELL_CHARM_PERSON));
    if (IS_NPC(victim)) {
      REMOVE_BIT(MOB_FLAGS(victim), MOB_AGGRESSIVE);
    }
  }
}

ASPELL(spell_detect_magic)
{
  send_to_char("You are now sensitive to magical aura's.\r\n", ch);
  ((*spell_info[SPELL_DETECT_MAGIC].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_gaze_reflection)
{
  act("The air before $n &+Wsh&+wim&+Wme&+wrs&n a moment.", TRUE, ch, NULL, victim,
      TO_OTHERS);
  act("The air before you &+Wsh&+wim&+Wme&+wrs&n a moment.", TRUE, ch, NULL, victim,
      TO_CHAR);
  ((*spell_info[SPELL_GAZE_REFLECTION].routines) (level, ch, NULL, victim, obj, loc, 0));
}
/*
   ASPELL(spell_identify)
   {
   int i;
   int found;

   struct time_info_data age(struct char_data *ch);

   extern char *spells[];

   extern char *item_types[];
   extern char *extra_bits[];
   extern char *apply_types[];
   extern char *affected_bits[];

   if (obj) {
   send_to_char("You feel informed:\r\n", ch);
   sprintf(buf, "Object '%s', Item type: ", obj->short_description);
   sprinttype(GET_OBJ_TYPE(obj), item_types, buf2);
   strcat(buf, buf2);
   strcat(buf, "\r\n");
   send_to_char(buf, ch);

   if (obj->obj_flags.bitvector) {
   send_to_char("Item will give you following abilities:  ", ch);
   sprintbit(obj->obj_flags.bitvector, affected_bits, buf);
   strcat(buf, "\r\n");
   send_to_char(buf, ch);
   }
   send_to_char("Item is: ", ch);
   sprintbit(GET_OBJ_EXTRA(obj), extra_bits, buf);
   strcat(buf, "\r\n");
   send_to_char(buf, ch);

   sprintf(buf, "Weight: %f, Value: %d, Rent: %d\r\n",
   GET_OBJ_WEIGHT(obj), GET_OBJ_COST(obj), GET_OBJ_ORIG_VNUM(obj));
   send_to_char(buf, ch);

   switch (GET_OBJ_TYPE(obj)) {
   case ITEM_SCROLL:
   case ITEM_POTION:
   sprintf(buf, "This %s casts: ", item_types[(int) GET_OBJ_TYPE(obj)]);

   if (GET_OBJ_VAL(obj, 1) >= 1)
   sprintf(buf, "%s %s", buf, spells[GET_OBJ_VAL(obj, 1)]);
   if (GET_OBJ_VAL(obj, 2) >= 1)
   sprintf(buf, "%s %s", buf, spells[GET_OBJ_VAL(obj, 2)]);
   if (GET_OBJ_VAL(obj, 3) >= 1)
   sprintf(buf, "%s %s", buf, spells[GET_OBJ_VAL(obj, 3)]);
   sprintf(buf, "%s\r\n", buf);
   send_to_char(buf, ch);
   break;
   case ITEM_WAND:
   case ITEM_STAFF:
   sprintf(buf, "This %s casts: ", item_types[(int) GET_OBJ_TYPE(obj)]);
   sprintf(buf, "%s %s\r\n", buf, spells[GET_OBJ_VAL(obj, 3)]);
   sprintf(buf, "%sIt has %d maximum charge%s and %d remaining.\r\n", buf,
   GET_OBJ_VAL(obj, 1), GET_OBJ_VAL(obj, 1) == 1 ? "" : "s",
   GET_OBJ_VAL(obj, 2));
   send_to_char(buf, ch);
   break;
   case ITEM_WEAPON:
   sprintf(buf, "Damage Dice is '%dD%d'", GET_OBJ_VAL(obj, 1),
   GET_OBJ_VAL(obj, 2));
   sprintf(buf, "%s for an average per-round damage of %.1f.\r\n", buf,
   (((GET_OBJ_VAL(obj, 2) + 1) / 2.0) * GET_OBJ_VAL(obj, 1)));
   send_to_char(buf, ch);
   break;
   case ITEM_ARMOR:
   sprintf(buf, "AC-apply is %d\r\n", GET_OBJ_VAL(obj, 0));
   send_to_char(buf, ch);
   break;
   }
   found = FALSE;
   for (i = 0; i < MAX_OBJ_AFFECT; i++) {
   if ((obj->affected[i].location != APPLY_NONE) &&
   (obj->affected[i].modifier != 0)) {
   if (!found) {
   send_to_char("Can affect you as :\r\n", ch);
   found = TRUE;
   }
   sprinttype(obj->affected[i].location, apply_types, buf2);
   sprintf(buf, "   Affects: %s By %d\r\n", buf2, obj->affected[i].modifier);
   send_to_char(buf, ch);
   }
   }
   } else if (victim) {         // victim 
   sprintf(buf, "Name: %s\r\n", GET_NAME(victim));
   send_to_char(buf, ch);
   if (!IS_NPC(victim)) {
   sprintf(buf, "%s is %d years, %d months, %d days and %d hours old.\r\n",
   GET_NAME(victim), age(victim).year, age(victim).month,
   age(victim).day, age(victim).hours);
   send_to_char(buf, ch);
   }
   sprintf(buf, "Height %d cm, Weight %d pounds\r\n",
   GET_HEIGHT(victim), GET_WEIGHT(victim));
   sprintf(buf, "%sLevel: %d, Hits: %d\r\n", buf,
   GET_LEVEL(victim), GET_HIT(victim));
   sprintf(buf, "%sAC: %d, Hitroll: %d, Damroll: %d\r\n", buf,
   GET_AC(victim), GET_HITROLL(victim), GET_DAMROLL(victim));
   sprintf(buf, "%sStr: %d/%d, Int: %d, Wis: %d, Dex: %d, Con: %d, Cha: %d\r\n",
   buf, GET_STR(victim), GET_ADD(victim), GET_INT(victim),
   GET_WIS(victim), GET_DEX(victim), GET_CON(victim), GET_CHA(victim));
   send_to_char(buf, ch);

   }
   }
 */
ASPELL(spell_magic_missile)
{
  struct char_data *target = NULL, *tar_next = NULL;
  int i = 0, num_per = 0, dam = 0, num_spare = 0, num_hit = 0, missile_num = 0;

  missile_num = BOUNDED(1, (level - 1) / 2 + 1, 5);
  sprintf(buf, "A %s missile%s shoot from $n's %s.",
	  (missile_num == 1) ? "single" : (missile_num == 2) ? "couple of"
   : "bunch of", (missile_num > 1) ? "s" : "", (casttype == CAST_SPELL) ?
	  "fingers" : (casttype == CAST_STAFF) ? "staff" : (casttype ==
	    CAST_SCROLL) ? "fingers" : (casttype == CAST_WAND) ? "wand" :
	  "fingers");
  act(buf, TRUE, ch, NULL, victim, TO_PROXIMITY2);
  sprintf(buf, "A %s missile%s shoot from your %s.",
	  (missile_num == 1) ? "single" : (missile_num == 2) ? "couple"
   : "bunch of", (missile_num > 1) ? "s" : "", (casttype == CAST_SPELL) ?
	  "fingers" : (casttype == CAST_STAFF) ? "staff" : (casttype ==
	    CAST_SCROLL) ? "fingers" : (casttype == CAST_WAND) ? "wand" :
	  "fingers");
  act(buf, TRUE, ch, NULL, victim, TO_CHAR);
  if (loc) {
    for (target = world[loc->real_room].people; target; target = tar_next) {
      tar_next = target->next_in_room;
      if (!CAN_SEE(ch, target))
	continue;
      if (affectarea(ch, victim, loc, target, SPELL_MAGIC_MISSILE)) {
	num_hit++;
      }
    }
    num_per = missile_num / ((num_hit) ? num_hit : 1);
    num_spare = missile_num - num_per * num_hit;
    for (target = world[loc->real_room].people; target; target = tar_next) {
      tar_next = target->next_in_room;
      if (!CAN_SEE(ch, target) || (ch == target))
	continue;
      if (affectarea(ch, victim, loc, target, SPELL_MAGIC_MISSILE)) {
	for (i = 0; i < num_per; i++) {
	  dam = dice(1, 4) + 1;
	  if (IS_AFFECTED2(target, AFF2_SHIELD)) {
	    act("A missile dissapates before it can hit $n.", TRUE, target,
		NULL, NULL, TO_PROXIMITY2);
	    act("A missile dissapates before it can hit you.", TRUE, target,
		NULL, NULL, TO_CHAR);
	  } else {
	    act("A missile slams into $n.", TRUE, target, NULL, NULL, TO_PROXIMITY2);
	    act("A missile slams into you.", TRUE, target, NULL, NULL, TO_CHAR);
	    damage(ch, target, dam, SPELL_MAGIC_MISSILE, -1, -1);
	  }
	}
	if (num_spare) {
	  dam = dice(1, 4) + 1;
	  if (IS_AFFECTED2(target, AFF2_SHIELD))
	    act("A missile dissapates before it can hit $n.", TRUE, target,
		NULL, NULL, TO_PROXIMITY2);
	  else {
	    act("A missile slams into $n.", TRUE, target, NULL, NULL, TO_PROXIMITY2);
	    damage(ch, target, dam, SPELL_MAGIC_MISSILE, -1, -1);
	  }
	  num_spare--;
	}
      }
    }
  } else {
    if (affectarea(ch, victim, loc, victim, SPELL_MAGIC_MISSILE)) {
      for (; missile_num > 0; missile_num--) {
	dam = dice(1, 4) + 1;
	if (IS_AFFECTED2(victim, AFF2_SHIELD)) {
	  act("A missile dissapates before it can hit $n.", TRUE, victim,
	      NULL, NULL, TO_PROXIMITY2);
	  act("A missile dissapates before it can hit you.", TRUE, victim,
	      NULL, NULL, TO_CHAR);
	} else {
	  act("A missile slams into $n.", TRUE, victim, NULL, NULL, TO_PROXIMITY2);
	  act("A missile slams into you.", TRUE, victim, NULL, NULL, TO_CHAR);
	  damage(ch, victim, dam, SPELL_MAGIC_MISSILE, -1, -1);
	}
      }
    }
  }
}

ASPELL(spell_prot_from_evil)
{
  if (IS_AFFECTED(ch, AFF_CHARM))
    send_to_char("You dont really want to do that.\r\n", ch);
  else {
    act("You feel protected from evil.", TRUE, ch, NULL, victim, TO_VICT);
    ((*spell_info[SPELL_PROT_FROM_EVIL].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}

ASPELL(spell_prot_from_good)
{
  if (IS_AFFECTED(ch, AFF_CHARM))
    send_to_char("You dont really want to do that.\r\n", ch);
  else {
    act("You feel protected from good.", TRUE, ch, NULL, victim, TO_VICT);
    ((*spell_info[SPELL_PROT_FROM_GOOD].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}

ASPELL(spell_shield)
{
  ((*spell_info[SPELL_SHIELD].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_shocking_grasp)
{
  act("Electricity crackles around $n's hands.", FALSE, ch, NULL, victim, TO_PROXIMITY2);
  act("Electricity crackles around your hands.", FALSE, ch, NULL, victim, TO_CHAR);

  ((*spell_info[SPELL_SHOCKING_GRASP].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_sleep)
{
  byte makes = 0, total = number(1, 5);
  struct char_data *target, *tar_next;

  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    makes = makes_save(target, savetype, 0);
    act("A slight fog appears around $N.", FALSE, ch, NULL, target, TO_PROXIMITY2);
    act("A slight fog appears around $N.", FALSE, ch, NULL, target, TO_CHAR);
    if (!makes && (GET_LEVEL(target) < total) && affectarea(ch, victim, loc, target, SPELL_SLEEP)) {
      total -= GET_LEVEL(target);
      ((*spell_info[SPELL_SLEEP].routines) (level, ch, NULL, target, obj, loc, 0));
    } else {
      command_interpreter(target, "sneeze");
    }

  }
}


ASPELL(spell_stinking_cloud)
{
  byte makes = 0;
  struct char_data *target, *tar_next;

  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    makes = makes_save(target, savetype, 0);
    act("&+yA large, noxious fog appears in the area.&n", FALSE, ch, NULL, target, TO_PROXIMITY2);
    act("&+yA slight fog appears in the area.&n", FALSE, ch, NULL, target, TO_CHAR);
    if (!makes && affectarea(ch, victim, loc, target, SPELL_SLEEP)) {
      ((*spell_info[SPELL_SLEEP].routines) (level, ch, NULL, target, obj, loc, 0));
    } else {
      command_interpreter(target, "sneeze");
    }

  }
  /* needs to add a timed cloud to the room */
}

ASPELL(spell_spider_climb)
{
  act("You feel as quick and nimble as a &+Lspider&n.", TRUE, ch, NULL, victim,
      TO_VICT);
  ((*spell_info[SPELL_SPIDER_CLIMB].routines) (level, ch, NULL, victim, obj, loc, 0));
}

/* Second Level Magic-User Spells */

ASPELL(spell_blindness)
{
  byte makes = makes_save(victim, savetype, 0);

  if (!makes) {
    act("$N's eye's fill with a dull haze.", TRUE, ch, NULL, victim,
	TO_OTHERS);
    act("$N's eye's fill with a dull haze.", TRUE, ch, NULL, victim,
	TO_CHAR);
    act("Your vision begins to &+wfa&+Lde&n.", TRUE, ch, NULL, victim, TO_VICT);
    ((*spell_info[SPELL_BLINDNESS].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}

ASPELL(spell_blur)
{
  act("$n's body begins to shift and waver becoming blurred.", TRUE, ch, NULL,
      victim, TO_OTHERS);
  act("Your body begins to shift and waver becoming blurred.", TRUE, ch, NULL,
      victim, TO_CHAR);
  ((*spell_info[SPELL_BLUR].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_detect_evil)
{
  send_to_char("You become more sensitive to the precense of evil.\r\n", ch);
  ((*spell_info[SPELL_DETECT_EVIL].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_detect_good)
{
  send_to_char("You become more sensitive to the precense of good.\r\n", ch);
  ((*spell_info[SPELL_DETECT_GOOD].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_detect_invisibility)
{
  send_to_char("You become more sensitive to the precense of the unseen.\r\n", ch);
  ((*spell_info[SPELL_DETECT_INVISIBILITY].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_invisibility)
{
  act("$N &+Lvanishes&n from your sight.", TRUE, ch, NULL, victim, TO_OTHERS);
  act("Your touch cause's $N to &+Lvanish&n.", TRUE, ch, NULL, victim, TO_CHAR);
  act("You &+Lvanish&n.", TRUE, ch, NULL, victim, TO_VICT);
  ((*spell_info[SPELL_INVISIBILITY].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_levitate)
{
  byte makes = 0;

  if (ch != victim)
    makes = makes_save(victim, savetype, 0);
  if (!makes) {
    act("$N begins to rise slowly into the air.", TRUE, ch, NULL, victim, TO_OTHERS);
    act("$N begins to rise slowly into the air.", TRUE, ch, NULL, victim, TO_CHAR);
    act("You begin to rise slowly into the air.", TRUE, ch, NULL, victim, TO_VICT);
    ((*spell_info[SPELL_LEVITATE].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}
/*
   ASPELL(spell_locate_object)
   {
   struct obj_data *i;
   char name[MAX_INPUT_LENGTH];
   int j;

   strcpy(name, fname(obj->name));
   j = level >> 1;

   for (i = object_list; i && (j > 0); i = i->next) {
   if (!isname(name, i->name))
   continue;

   if (i->carried_by)
   sprintf(buf, "%s is being carried by %s.\n\r",
   i->short_description, PERS(i->carried_by, ch, TRUE));
   else if (i->in_room != NOWHERE)
   sprintf(buf, "%s is in %s.\n\r", i->short_description,
   world[i->in_room].name);
   else if (i->in_obj)
   sprintf(buf, "%s is in %s.\n\r", i->short_description,
   i->in_obj->short_description);
   else if (i->worn_by)
   sprintf(buf, "%s is being worn by %s.\n\r",
   i->short_description, PERS(i->worn_by, ch, TRUE));
   else
   sprintf(buf, "%s's location is uncertain.\n\r",
   i->short_description);

   CAP(buf);
   send_to_char(buf, ch);
   j--;
   }

   if (j == level >> 1)
   send_to_char("You sense nothing.\n\r", ch);
   }
 */
#if 0
ASPELL(spell_mirror_image)
{
  P_char image, tmpch;
/*  int numbp = 0, newslot; */
/*
   P_char oldchnext, oldtchnext, prev = NULL, prevtch = NULL, tch, prevch = NULL;
 */
  struct affected_type af;
  char Gbuf1[512];
  int numb, i;
  struct follow_type *k;

  for (k = ch->followers; k; k = k->next) {
    victim = k->follower;
    if (victim->nr == real_mobile(250)) {
      send_to_char("You can only have one set of mirror images at a time.\r\n", ch);
      return;
    }
  }
  numb = MIN(4, level / 6);
  if (!numb)
    numb = 1;

  for (i = 0; i < numb; i++) {
    image = read_mobile(real_mobile(250), REAL);
    if (!image) {
      send_to_char("your mirror ain't imaging tonight bubba.  let a god know.\r\n", ch);
      return;
    }
    char_to_room(image, ch->in_room, 0);

    act("A spitting image of $n suddenly rises from the ground!", TRUE,
	ch, 0, image, TO_OTHERS);
    send_to_char("A spitting image of you suddenly rises from the ground!\r\n", ch);

    while (image->affected)
      affect_remove(image, image->affected);

    if (!IS_SET(image->specials.act, ACT_MEMORY))
      image->only.npc->memory = NULL;

    bzero(&af, sizeof(af));
    af.type = SPELL_CHARM_PERSON;
    af.duration = modify_by_specialization(ch, current_spell_being_cast, 30);
    af.bitvector = AFF_CHARM;
    affect_to_char(image, &af);
    add_follower(image, ch);

    /* string it */

    image->only.npc->str_mask = (STRUNG_KEYS | STRUNG_DESC1 | STRUNG_DESC2);

    image->player.name = str_dup("image" /*ch->player.name */ );
    image->player.short_descr = str_dup(ch->player.name);

    sprintf(Gbuf1, "%s stands here.\r\n", ch->player.name);
    image->player.long_descr = str_dup(Gbuf1);

    if (GET_TITLE(ch))
      image->player.title = str_dup(GET_TITLE(ch));

    GET_RACE(image) = GET_RACE(ch);
    GET_SEX(image) = GET_SEX(ch);
    GET_ALIGNMENT(image) = GET_ALIGNMENT(ch);
    GET_ORIG_ALIGN(image) = GET_ORIG_ALIGN(ch);
    GET_SIZE(image) = GET_SIZE(ch);

    remove_plushit_bits(image);
  }

  /* now we get to scramble up the room list so that the caster isn't
     always the last in the list or whtaever */

#if 0
  i = 0;

  for (tch = world[ch->in_room].people; tch; tch = tch->next_in_room) {
    numbp++;
  }

  /* mirror image should always create at least one image */

  if (!numbp || (numbp == 1))
    return;

  newslot = number(0, numbp - 1);

  /* move ch to head of list */

  if (newslot == 0) {
    /* might already be at head of list, what luck */

    if (ch != world[ch->in_room].people) {
      /* find previous pointer to ch */

      prev = world[ch->in_room].people;
      while (prev && (prev->next_in_room != ch)) {
	prev = prev->next_in_room;
      }

      if (!prev)
	return;			/* error */

      prev->next_in_room = ch->next_in_room;
      ch->next_in_room = world[ch->in_room].people;
      world[ch->in_room].people = ch;
    }
  }
  /* move ch to somewhere in middle of list */

  else {
    tch = world[ch->in_room].people;

    /* find slot to add at */

    while (tch) {
      if (newslot == i)
	break;
      else
	i++;

      if (tch->next_in_room == ch)
	prevch = tch;
      prevtch = tch;
      tch = tch->next_in_room;
    }

    if (!tch || !prevch || !prevtch || !i)
      return;			/* error - whoops */

    /* we may end up not having to move it at all */

    if (tch != ch) {
      oldtchnext = tch->next_in_room;

      /* code required for each special case.. */

      if (ch->next_in_room == tch) {
	prevch->next_in_room = tch;
	ch->next_in_room = tch->next_in_room;
	tch->next_in_room = ch;
      } else if (tch->next_in_room == ch) {
	prevtch->next_in_room = ch;
	tch->next_in_room = ch->next_in_room;
	ch->next_in_room = tch;
      } else {
	prevch->next_in_room = tch;
	tch->next_in_room = ch->next_in_room;
	prevtch->next_in_room = ch;
	ch->next_in_room = oldtchnext;
      }
    }
  }
#endif
}
#endif

ASPELL(spell_ray_of_enfeeblement)
{
  byte makes = 0;

  if (ch != victim)
    makes = makes_save(victim, savetype, 0);
  if (!makes) {
    act("A &+Lblack ray&N shoots from your hands, striking $N.", TRUE,
	ch, NULL, victim, TO_CHAR);
    act("A &+Lblack ray&N shoots from $n's hands, striking $N.", TRUE,
	ch, NULL, victim, TO_OTHERS);
    act("You feel weak as a &+Lblack ray&N from $n's hands strikes you.",
	TRUE, ch, NULL, victim, TO_VICT);
    ((*spell_info[SPELL_RAY_OF_ENFEEBLEMENT].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}

ASPELL(spell_strength)
{
  act("$N visibly strengthens from $n's touch.", TRUE, ch, NULL, victim, TO_OTHERS);
  act("$N visibly strengthens at your touch.", TRUE, ch, NULL, victim, TO_CHAR);
  act("Your muscles begin to ripple with new found strength.", TRUE, ch, NULL,
      victim, TO_VICT);
  ((*spell_info[SPELL_STRENGTH].routines) (level, ch, NULL, victim, obj, loc, 0));
}


/* Third Level Magic-User Spells */

ASPELL(spell_blink)
{
  ((*spell_info[SPELL_BLINK].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_clairvoyance)
{
  struct affected_type *af;
  int room = 0;

  if ((loc->real_room <= GET_INT(ch)) && (loc->real_room > 0))
    room = ch->player_specials->saved.known_rooms[loc->real_room - 1];
  else
    room = ch->in_room;

  send_to_char("You expand your senses across the intervening space.\r\n", ch);

  CREATE(af, struct affected_type, 1);
  af->type = SPELL_CLAIRVOYANCE;
  af->modifier = room;
  af->duration = level;
  affect_to_char(ch, af);
}

ASPELL(spell_fireball)
{
  int dam = dice(MIN(level, 10), 6);
  struct char_data *target, *tar_next;

  act("A large &+Rball of fire&N streaks out of $n's hands.", TRUE,
      ch, NULL, victim, TO_PROXIMITY2);
  act("A large &+Rball of fire&N streaks out of your hands.", TRUE,
      ch, NULL, victim, TO_CHAR);
  act("The &+Rball of fire&N erupts in a massive &+rexplosion&N.", TRUE,
      ch, NULL, victim, TO_PROXIMITY2);
  act("The &+Rball of fire&N erupts in a massive &+rexplosion&N.", TRUE,
      ch, NULL, victim, TO_CHAR);
  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_FIREBALL)) {
      act("Flames from the explosion engulf your body.", TRUE,
	  ch, NULL, target, TO_VICT);
      act("Flames from the explosion engulf $n's body.", TRUE,
	  target, NULL, ch, TO_PROXIMITY2);
      damage(ch, target, dam, SPELL_FIREBALL, -1, -1);
    }
  }
}

ASPELL(spell_fly)
{
  act("$n's touch causes $N to rise into the air.", TRUE, ch, NULL, victim,
      TO_OTHERS);
  act("Your touch causes $N to rise into the air.", TRUE, ch, NULL, victim,
      TO_CHAR);
  act("$n's touch causes you to rise into the air.", TRUE, ch, NULL, victim,
      TO_VICT);
  ((*spell_info[SPELL_FLY].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_haste)
{
  byte total = 0, max = GET_LEVEL(ch);
  struct char_data *target, *tar_next;

  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_HASTE) &&
	(total < max)) {
      total++;
      act("The world seems to slow down around you.", TRUE, ch, NULL, target,
	  TO_VICT);
      ((*spell_info[SPELL_HASTE].routines) (level, ch, NULL, target, obj, loc, 0));
    }
  }
}

ASPELL(spell_infravision)
{
  act("$n's eyes begin to glow &+Rred&n.", TRUE, ch, NULL, victim, TO_OTHERS);
  act("$n's eyes begin to glow &+Rred&n from your touch.", TRUE, ch, NULL, victim,
      TO_CHAR);
  act("The night suddenly seems less dark to you.", TRUE, ch, NULL, victim,
      TO_VICT);
  ((*spell_info[SPELL_INFRAVISION].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_invisibility_10)
{
  struct char_data *target = NULL, *tar_next = NULL;

  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_INVISIBILITY_10)) {
      act("$N &+Lvanishes&n before your eye's.", TRUE, ch, NULL, target, TO_CHAR);
      act("$N &+Lvanishes&n before your eye's.", TRUE, ch, NULL, target, TO_OTHERS);
      act("You &+Lvanish&n.", TRUE, ch, NULL, target, TO_VICT);
      ((*spell_info[SPELL_INVISIBILITY_10].routines) (level, ch, NULL, target, obj, loc, 0));
    }
  }
}

ASPELL(spell_slow)
{
  byte total = 0, max = GET_LEVEL(ch);
  struct char_data *target, *tar_next;

  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_SLOW) &&
	(total < max)) {
      total++;
      act("The world seems to speed up around you.", TRUE, ch, NULL, target,
	  TO_VICT);
      ((*spell_info[SPELL_SLOW].routines) (level, ch, NULL, target, obj, loc, 0));
    }
  }
}

ASPELL(spell_water_breathing)
{
  act("You feel more at home in the water.", TRUE, ch, NULL, victim, TO_VICT);
  ((*spell_info[SPELL_WATER_BREATHING].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_wraithform)
{
  act("Your body begins to fade becoming less corporal.", TRUE, ch, NULL,
      victim, TO_CHAR);
  act("$n's body begins to fade becoming less corporal.", TRUE, ch, NULL,
      victim, TO_OTHERS);
  ((*spell_info[SPELL_WRAITHFORM].routines) (level, ch, NULL, victim, obj, loc, 0));
}

/* Fourth Level Magic-User Spells */

ASPELL(spell_cold_shield)
{
  if (IS_AFFECTED2(victim, AFF2_FIRESHIELD)) {
    send_to_char("You cannot combine fireshield and coldshield.\r\n", victim);
  } else {
    act("A cold gust of air surrounds $n and begins to form wispy &+Bblue&n flames.",
	TRUE, ch, NULL, victim, TO_OTHERS);
    act("You are slightly chilled as a burst of wispy &+Bblue&n flames surround \
your body.", TRUE, ch, NULL, victim, TO_CHAR);
    ((*spell_info[SPELL_COLD_SHIELD].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}
/*
   ASPELL(spell_enchant_weapon)
   {
   int i;

   if (ch == NULL || obj == NULL)
   return;

   if ((GET_OBJ_TYPE(obj) == ITEM_WEAPON) &&
   !IS_SET(GET_OBJ_EXTRA(obj), ITEM_MAGIC)) {

   for (i = 0; i < MAX_OBJ_AFFECT; i++)
   if (obj->affected[i].location != APPLY_NONE)
   return;

   SET_BIT(GET_OBJ_EXTRA(obj), ITEM_MAGIC);

   obj->affected[0].location = APPLY_HITROLL;
   obj->affected[0].modifier = 1 + (level >= 18);

   obj->affected[1].location = APPLY_DAMROLL;
   obj->affected[1].modifier = 1 + (level >= 20);

   if (IS_GOOD(ch)) {
   SET_BIT(GET_OBJ_EXTRA(obj), ITEM_ANTI_EVIL);
   act("$p glows blue.", FALSE, ch, obj, 0, TO_CHAR);
   } else if (IS_EVIL(ch)) {
   SET_BIT(GET_OBJ_EXTRA(obj), ITEM_ANTI_GOOD);
   act("$p glows red.", FALSE, ch, obj, 0, TO_CHAR);
   } else {
   act("$p glows yellow.", FALSE, ch, obj, 0, TO_CHAR);
   }
   }
   }
 */
ASPELL(spell_fire_shield)
{
  if (IS_AFFECTED3(victim, AFF3_COLDSHIELD)) {
    send_to_char("You cannot combine fireshield and coldshield.\r\n", victim);
  } else {
    act("A warm burst of air surrounds $n and begins to form wispy &+mviolet&n flames.",
	TRUE, ch, NULL, victim, TO_OTHERS);
    act("A warm burst of air surrounds you and begins to form wispy &+mviolet&n flames around \
your body.", TRUE, ch, NULL, victim, TO_CHAR);
    ((*spell_info[SPELL_FIRE_SHIELD].routines) (level, ch, NULL, victim, obj, loc, 0));
  }
}
/*
   ASPELL(spell_ice_storm)
   {
   int dam;
   struct char_data *target, *tar_next;

   dam = dice(3, 10);
   for (target = world[ch->in_room].people; target; target = tar_next) {
   tar_next = target->next_in_room;
   if (affectarea(ch, victim, loc, target, SPELL_ICE_STORM))
   damage(ch, target, dam, SPELL_ICE_STORM, -1, -1);
   }
   }
 */

ASPELL(spell_minor_globe_of_invulnerability)
{
  ((*spell_info[SPELL_MINOR_GLOBE_OF_INVULNERABILITY].routines) (level, ch, NULL, victim, obj, loc, 0));
}

/* Fifth Level Magic-User Spells */

ASPELL(spell_cone_of_cold)
{
  struct char_data *target, *tar_next;
  int dam = dice(level, 4) + level;

  act("A burst of deadly &+Bcold&n air shoots from $n's hands.", TRUE, ch, NULL,
      NULL, TO_PROXIMITY2);
  act("A burst of deadly &+Bcold&n air shoots from your hands.", TRUE, ch, NULL,
      NULL, TO_CHAR);
  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (target == ch)
      continue;
    if (affectarea(ch, victim, loc, target, SPELL_CONE_OF_COLD)) {
      act("You are blasted by the burst of &+Bcold&n air from $n's hands.", TRUE,
	  ch, NULL, target, TO_VICT);
      act("$n is blasted by the burst of &+Bcold&n air from $N's hands.", TRUE,
	  target, NULL, ch, TO_PROXIMITY2);
      damage(ch, target, dam, SPELL_CONE_OF_COLD, -1, -1);
    }
  }
}

ASPELL(spell_feeblemind)
{
  int mod;

  if (IS_MAGE(victim))
    mod = -4;
  else
    mod = -1;

  if (!makes_save(victim, savetype, mod))
    ((*spell_info[SPELL_FEEBLEMIND].routines) (level, ch, NULL, victim, obj, loc, 0));
}

ASPELL(spell_teleport)
{
  int room, weight = 0;
  struct obj_data *obj2;

  weight = 250 + (150 * MAX(0, GET_LEVEL(ch) - 10));

  while (IS_CARRYING_W(ch) > weight) {
    obj2 = ch->carrying;
    obj_from_char(obj2);
    put_obj_to_room(obj2, ch->in_room, GET_X_CORD(ch), GET_Y_CORD(ch), 0);
  }

  if ((loc->real_room <= GET_INT(ch)) && (loc->real_room > 0))
    room = ch->player_specials->saved.known_rooms[loc->real_room - 1];
  else
    room = ch->in_room;

  if (ROOM_FLAGGED(room, ROOM_PRIVATE | ROOM_DEATH)) {
    room = ch->in_room;
  }
  act("$n slowly fades out of existence and is gone.",
      FALSE, ch, 0, 0, TO_PROXIMITY2);
  char_from_room(victim);
  char_to_room(victim, room, -1);
  act("$n slowly fades into existence.", FALSE, ch, 0, 0, TO_PROXIMITY2);
  look_at_room(ch, 0);
  entry_memory_mtrigger(ch);
  greet_mtrigger(ch, -1);
  greet_memory_mtrigger(ch);
}

/* Sixth Level Magic-User Spells */
/*
   ASPELL(spell_globe_of_invulnerability)
   {
   ((*spell_info[SPELL_GLOBE_OF_INVULNERABILITY].routines) (level, ch, NULL, victim, obj, loc, 0));
   }
 */

/* Eighth Level Magic-User Spells */

ASPELL(spell_power_word_blind)
{
  int total = 0, makes = 0;
  struct char_data *target, *tar_next;

  total += GET_HIT(victim);
  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_POWER_WORD_BLIND))
      total += GET_HIT(target);
  }

  if (total > 50)
    makes = 1;

  total = 0;

  ((*spell_info[SPELL_POWER_WORD_BLIND].routines) (level, ch, NULL, victim, obj, loc, 0));
  total += GET_HIT(victim);

  for (target = world[ch->in_room].people; target; target = tar_next) {
    tar_next = target->next_in_room;
    if (affectarea(ch, victim, loc, target, SPELL_POWER_WORD_BLIND) &&
	(total < 100)) {
      total += GET_HIT(victim);
      ((*spell_info[SPELL_POWER_WORD_BLIND].routines) (level, ch, NULL, target, obj, loc, makes));
    }
  }
}

/* Ninth Level Magic-User Spells */

ASPELL(spell_power_word_kill)
{
  struct char_data *target, *tar_next;
  int total = 120;

  act("You utter a word of incredible power.", TRUE, ch, NULL, NULL, TO_CHAR);
  act("$n utters a word of incredible power.", TRUE, ch, NULL, NULL, TO_PROXIMITY2);

  if (victim && (GET_HIT(victim) <= 60)) {
    act("Your word destroys $N.", TRUE, ch, NULL, victim, TO_CHAR);
    act("The power of $n's word obliterates $N.", TRUE, ch, NULL, victim,
	TO_OTHERS);
    act("The power of $n's word rips you apart.", TRUE, ch, NULL, victim,
	TO_VICT);
    raw_kill(victim, ch);
  } else {
    for (target = world[ch->in_room].people; target; target = tar_next) {
      tar_next = target->next_in_room;
      if ((GET_HIT(target) <= 10) && affectarea(ch, NULL, loc, target,
						SPELL_POWER_WORD_KILL) && (total -= GET_HIT(target)) && (total > 0)) {
	act("Your word destroys $N.", TRUE, ch, NULL, target, TO_CHAR);
	act("The power of $n's word obliterates $N.", TRUE, ch, NULL, target,
	    TO_OTHERS);
	act("The power of $n's word rips you apart.", TRUE, ch, NULL, target,
	    TO_VICT);
	raw_kill(target, ch);
      }
    }
  }
}
