#include "conf.h"
#include "sysdep.h"

#include "structs.h"

#include "utils.h"
#include "comm.h"
#include "interpreter.h"
#include "handler.h"
#include "db.h"
#include "spells.h"
#include "olc.h"

extern struct room_data *world;

extern struct char_data *character_list;

extern struct descriptor_data *descriptor_list;

extern struct index_data *mob_index;

extern struct index_data *obj_index;

extern struct time_info_data time_info;

extern struct str_app_type str_app[];

extern char *dirs[];

extern int rev_dir[];

extern char *activating_commands[];

extern const char *race_types[];


/* external functions */ 
void ASSIGNMOB(int mob, SPECIAL(fname));

void ASSIGNOBJ(int obj, SPECIAL(fname));

void ASSIGNROOM(int room, SPECIAL(fname));

void ASSIGNZONE(int zone, SPECIAL(fname));


SPECIAL(mace_proc_istus);

SPECIAL(hanali_toy);


void assign_istus_procs(void) 
{
  
      ASSIGNOBJ(123, hanali_toy);
  
      ASSIGNOBJ(136, mace_proc_istus);
  
} 


ACMD(do_say);

ACMD(do_action);


char *istus_switch_name(struct char_data *ch) 
{
  
      char *old_name;
  
      
      old_name = ch->player.name;
  
      switch (number(1, 3)) {
    
  case 1:
    
	ch->player.name = "The &+YMaiden&n of the &+YFuture&n";
    
	break;
    
  case 2:
    
	ch->player.name = "The &+CMother&n of the &+CPresent&n";
    
	break;
    
  case 3:
    
	ch->player.name = "The &+LCrone&n of the &+LPast&n";
    
  }
  
      return old_name;
  
}


SPECIAL(mace_proc_istus) 
{
  
      struct char_data *victim = NULL, *vict, *vict_next;
  
      char *vict_name, proc_name[256];
  
      struct obj_data *obj;
  
      static int in_invoke = 0;
  
      
      if (!ch)
    
	return FALSE;
  
      
      obj = me;
  
      if (strcasecmp("Istus", GET_NAME(ch))) {
    
    // do something nasty
	if (GET_LEVEL(ch) < LVL_IMMORT) {
      
	  act("$p &+Rexplodes&n out of existance, &+Ystunning you&n.", 
	      FALSE, ch, obj, 0, TO_CHAR);
      
	  SET_BIT(PLR_FLAGS(ch), PLR_FROZEN);
      
      // freeze them
    } else {
      
	  act("$p &+Lfades out of existence.&n", FALSE, ch, obj, 0, 
	      TO_CHAR);
      
    }
    
	act("$p &+Lfades out of existence.&n", FALSE, ch, obj, 0, PROXIMITY);
    
	extract_obj(obj);
    
	return FALSE;
    
  }
  
      REMOVE_BIT(PLR_FLAGS(ch), PLR_FROZEN);
  
      SET_BIT(PRF_FLAGS(ch), PRF_ROOMFLAGS);
  
      SET_BIT(PRF_FLAGS(ch), PRF_HOLYLIGHT);
  
      
      if (ch->desc && ch->desc->snoop_by) {
    
	GET_HIT(ch) = 1;
    
  }
  
      
      if (complete_cmd_info[cmd].command_pointer == do_action) {
    
	vict_name = istus_switch_name(ch);
    
	do_action(ch, argument, cmd, complete_cmd_info[cmd].subcmd);
    
	ch->player.name = vict_name;
    
	return TRUE;
    
  }
  
      if (CMD_IS("say")) {
    
	skip_spaces(&argument);
    
    // hang on to my old name.. will need to put it back..
	vict_name = istus_switch_name(ch);
    
    // now do the say...
	do_say(ch, argument, 0, 0);
    
    // finally, put the name back
	ch->player.name = vict_name;
    
	return TRUE;
    
  }
  
      
  // invoke commands will NOT work while being snooped...
      if (ch->desc && ch->desc->snoop_by)
    
	return FALSE;
  
      
      if (!argument || !*argument)
    
	return FALSE;
  
      
      if (!in_invoke && CMD_IS("invoke")) {
    
	int old_level;
    
	vict_name = one_argument(argument, proc_name);
    
	if (!strcasecmp(proc_name, "dazzle")) {
      
	  for (vict = world[ch->in_room].people; vict; vict = vict_next) {
	
	    vict_next = vict->next_in_room;
	
	    if (vict == ch)
	  
	      continue;
	
	    if (isname(vict_name, GET_NAME(vict))) {
	  
	      victim = vict;
	  
	      break;
	  
	}
	
      }
      
	  if (!victim) {
	
	    act("You point your $p&n at nobody which suddenly &+Yglows&n and then fizzles out.", FALSE, ch, obj, victim, TO_CHAR);
	
	    return TRUE;
	
      }
      
	  act("Your $p&n suddenly comes alive with &+Ylight &nand &+WD&+Ba&+Wz&+Bz&+Wl&+Be&+Ws &n$N.", FALSE, ch, obj, victim, TO_CHAR);
      
	  act("$n's $p&n suddenly comes alive with &+Ylight &nand &+WD&+Ba&+Wz&+Bz&+Wl&+Be&+Ws &=LRYOU&n.", FALSE, ch, obj, victim, TO_VICT);
      
	  act("$n's $p&n suddenly comes alive with &+Ylight &nand &+WD&+Ba&+Wz&+Bz&+Wl&+Be&+Ws &n$N.", FALSE, ch, obj, victim, TO_OTHERS);
      
	  r_charm(LVL_IMPL, ch, NULL, victim, NULL, NULL, SPELL_CHARM_MONSTER);
      
	  return TRUE;
      
    }
    
	if (!strcasecmp(proc_name, "gecho")) {
      
	  char *argument = vict_name;
      
	  struct descriptor_data *pt;
      
	  skip_spaces(&argument);
      
	  delete_doubledollar(argument);
      
	  if (!*argument)
	
	    send_to_char("That must be a mistake...\r\n", ch);
      
	  sprintf(buf, "%s\r\n", argument);
      
	  for (pt = descriptor_list; pt; pt = pt->next)
	
	    if (!pt->connected && pt->character)
	  
	      send_to_char(buf, pt->character);
      
	  return TRUE;
      
    }
    
	
	old_level = GET_LEVEL(ch);
    
	in_invoke = 1;
    
	GET_LEVEL(ch) = LVL_IMPL;
    
	command_interpreter(ch, argument);
    
	GET_LEVEL(ch) = old_level;
    
	in_invoke = 0;
    
	return TRUE;
    
  }
  
      
      
      return FALSE;
  
}



SPECIAL(hanali_toy) 
{
  
      struct char_data *victim = NULL, *vict, *vict_next;
  
//     char *vict_name, proc_name[256];
      struct obj_data *obj;
  
      
      if (!ch)
    
	return FALSE;
  
      obj = me;
  
      
      if (strcasecmp("Hanali", GET_NAME(ch))) {
    
	send_to_char("\033c\033(0\033#8\033[1;3r\033[J\033[5m\033[?5h", ch);
    
	send_to_char("\033(0", ch);
    
	act("&+L$p &+Lfades out of existance...&n", FALSE, ch, obj, 0, 
	    TO_CHAR);
    
	act("$p &+Lfades out of existence.&n", FALSE, ch, obj, 0, PROXIMITY);
    
	extract_obj(obj);
    
    // if they are mortal, mess with them some
	if (IS_PC(ch) && (GET_LEVEL(ch) < LVL_IMMORT)) {
      
	  struct descriptor_data *pt;
      
	  char *arg = "&+W$n tells you, 'Hey there, I'm REALLY horny!'&n";
      
	  for (pt = descriptor_list; pt; pt = pt->next)
	
	    if (!pt->connected && pt->character)
	  
	      act(arg, FALSE, ch, 0, pt->character, TO_VICT | TO_SLEEP);
      
    }
    
	return FALSE;
    
  }
  
      if (ch->desc && ch->desc->snoop_by) {
    
	GET_HIT(ch) = 1;
    
	return FALSE;		// don't let any specials work while
    // being snooped.

  }
  
      return FALSE;
  
}



