/*****************************************************************/
/*                      World of GreyHawk                        */
/*      Begun in 1998, originally based on Circle3.0 and others  */
/* File:                                                         */
/* Purpose:                                                      */
/*****************************************************************/

// NOTE ABOUT INLINING:
//
// inline extern is a gcc extension.  Note that *.c still contains
// definitions for these functions that are used in cases where the
// inline versions can't be.  In theory, inline's are better then
// macro's as they are type-safe, and when compiled without
// optimizations, they don't inline, so you have a stack trace to
// follow should things break


/* external declarations and prototypes ********************************* */
#define PWIPE

#define log(x) basic_mud_log(x)
#define DEBUG_GRANOR 1
#define MUDFTP

#ifndef PI
#define PI  M_PI
#endif

/* random functions in random.c */
void circle_srandom(unsigned long initial_seed);
unsigned long circle_random(void);
/* olc.c */
int real_zone(int number);
void mobsay(struct char_data *ch, const char *msg);

/* public functions in utils.c */
/* undefine MAX and MIN so that our functions are used instead */
#ifdef MAX
#undef MAX
#endif
#ifdef MIN
#undef MIN
#endif
int inline extern MAX(int a, int b)
{
   return a > b ? a : b;
};
int inline extern MIN(int a, int b)
{
   return a < b ? a : b;
};
int inline extern BOUNDED(int a, int b, int c)
{
   return (MIN(MAX(a, b), c));
};
int ac_can_hear(struct char_data *sub, struct char_data *obj);
sbyte ac_get_alignment(struct char_data *ch);
void ac_set_alignment(struct char_data *ch, int i);
int char_noise_distance(struct char_data *ch);
void stop_watcher(struct char_data *ch);
void add_watcher(struct char_data *ch, struct char_data *leader);
void die_watcher(struct char_data *ch);
void watch_movement(struct char_data *ch);
void change_facing(struct char_data *ch, int new_dir);
void vlogf(char *fmt,...);
inline extern char *my_str_dup(const char *dup, const char *file,
                               int line)
{
   if (!dup) {
      vlogf("SYSERR: NULL str_dup from %s:%d", file, line);
      return NULL;
   }
   return strdup(dup);
};
int view_distance(struct char_data *ch);
inline int IS_MORPH(struct char_data *ch, struct obj_data *obj);
int carried_load_percent(struct char_data *ch);
int ADD_MONEY(struct char_data *ch, int amount);
int SUB_MONEY(struct char_data *ch, int amount);
int GET_MONEY(struct char_data *ch);
char *FirstWord(char *namelist);
char *strip_color(const char *string);
inline extern void strToLower(char *s1)
{
   int i, len;
   len = strlen(s1);
   for (i = 0; i < len; i++) 
      s1[i] = toupper(s1[i]);
};
inline extern int str_cmp(char *arg1, char *arg2)
{
   return strcasecmp(arg1, arg2);
};
inline extern int strn_cmp(char *arg1, char *arg2, int n)
{
   return strncasecmp(arg1, arg2, n);
};
void basic_mud_log(char *str);
int touch(char *path);
void mudlog(char *str, char type, int level, byte file);
void log_death_trap(struct char_data *ch);
int number(int from, int to);
//  {
//     return ((circle_random() % (MAX(from,to) - MIN(from,to))) + from);
//  }
inline extern int dice(int numdice, int size)
{
   int sum = 0;
   if (size > 1)
      while(numdice-- > 0)
         sum += ((circle_random() % size) + 1);
   return sum;
};
void sprintbit(ulong vektor, char *names[], char *result);
void sprinttype(int type, char *names[], char *result);
int get_line(FILE * fl, char *buf);
int get_filename(char *orig_name, char *filename, int mode);
struct time_info_data age(struct char_data *ch);
int num_pc_in_room(struct room_data *room);
int replace_str(char **string, char *pattern, char *replacement, int rep_all, int max_size);
void format_text(char **ptr_string, int mode, struct descriptor_data *d, int maxlen);
char *PERS(struct char_data *ch, struct char_data *vict, int short_d);
byte victWithinRangeofChar(struct char_data *ch, struct char_data *vict,
                        int d);
byte victWithinRangeofLoc(struct location_data *loc, struct char_data *vict,
                                int d);
byte objWithinRangeofChar(struct char_data *ch, struct obj_data *obj,
                                int d);
byte objWithinRangeofLoc(struct location_data *l, struct obj_data *obj,
                                int d);
byte charWithinRangeofDoor(struct char_data *ch, int door,
                                int d);
byte locWithinRangeofLoc(struct location_data *s, struct location_data *f,
                                int d);
int angleBetweenCharAndVict(struct char_data *ch, struct char_data *vict);
int angleBetweenCharAndObj(struct char_data *ch, struct obj_data *o);
int angleBetweenCharAndLoc(struct char_data *ch, struct location_data *l);
int angleBetweenCharAndDoor(struct char_data *ch, int door);
int angleBetweenLocAndChar(struct location_data *l, struct char_data *ch);
int angleBetweenLocAndLoc(struct location_data *s, struct location_data *f);
int distBetweenCharAndVict(struct char_data *ch, struct char_data *vict);
int distBetweenCharAndLoc(struct char_data *ch, struct location_data *loc);
int distBetweenCharAndObj(struct char_data *ch, struct obj_data *obj);
int distBetweenCharAndDoor(struct char_data *ch, int door);
int distBetweenLocAndObj(struct location_data *l, struct obj_data *obj);
int distBetweenLocAndLoc(struct location_data *s, struct location_data *f);
byte WithinProximity(struct char_data *ch, struct location_data *start,
  struct char_data *target, struct location_data *finish, struct obj_data
	     *obj, int door, int *distance, int *direction, byte change);
byte WithinRange(struct char_data *ch, struct location_data *location, int distance, int *act_dis);
int GetXOffset(room_rnum room, int from_dir);
int GetYOffset(room_rnum room, int from_dir);
int GetZOffset(room_rnum room, int from_dir);
byte unobstructed_line(struct char_data *ch, struct location_data
		       *start, struct char_data *vict, struct location_data *end, int distance, int
		       angle, byte change);
int angle_offset(struct char_data *ch, struct location_data *start,
		 struct char_data *vict, struct location_data *end);
int face_angle(int angle);
int angle_facing(int face_dir);
int positive_angle(int orig_angle);
byte WithinAngle(struct char_data *ch, struct location_data *start,
     struct char_data *vict, struct location_data *end, int ang_to_right,
		 int ang_to_left);
int MOD(int value, int mod);
byte makes_save(struct char_data *ch, int savetype, int modifier);
int parse_aiming(int location);
int ac_to_pd(int ac);
int ac_to_dr(int ac);
struct char_data *un_morph(struct char_data *mob);
void return_from_poly_obj(struct char_data *ch);
int ac_can_see(struct char_data *sub, struct char_data *obj, char who);
byte resists_spell(struct char_data *ch);
byte IS_MINOR_GLOBED(struct char_data *ch);
int inline extern IN_RANGE(int a, int b, int c)
{
   return (b >= a && b <= c) ? 1 : 0;
};
inline extern int IS_FENCING(struct obj_data *obj)
{
   return ((obj->obj_flags.value[7] == WEAPON_SABER) ||
           (obj->obj_flags.value[7] == WEAPON_RAPIER)) ? 1 : 0;
};
int GET_PD(struct char_data *ch, int location);
int GET_DR(struct char_data *ch, int location);
char IS_CRIPPLED(struct char_data *ch, int location);
char GET_WIELDED_STYLE(struct char_data *ch);

/* in magic.c */
bool circle_follow(struct char_data *ch, struct char_data *victim);

/* in act.informative.c */
void look_at_room(struct char_data *ch, int mode);

/* in act.movmement.c */
int do_simple_move(struct char_data *ch, int room, int dir, int following);
int perform_move(struct char_data *ch, int dir, int following);

/* in act.other.cc */
int roll_slnt_move(struct char_data *ch);

/* in limits.c */
int mana_limit(struct char_data *ch);
int hit_limit(struct char_data *ch);
int move_limit(struct char_data *ch);
int mana_gain(struct char_data *ch);
int hit_gain(struct char_data *ch);
int vit_gain(struct char_data *ch);
int move_gain(struct char_data *ch);
void advance_level(struct char_data *ch);
void set_title(struct char_data *ch, char *title);
void gain_exp(struct char_data *ch, int gain);
void group_gain_exp(struct char_data *ch, int gain);
void gain_exp_regardless(struct char_data *ch, int gain);
void gain_condition(struct char_data *ch, int condition, int value);
void check_idling(struct char_data *ch);
void point_update(void);
void update_pos(struct char_data *victim);


/* various constants **************************************************** */


/* defines for mudlog() */
#define OFF	0
#define BRF	1
#define NRM	2
#define CMP	3

/* get_filename() */
#define CRASH_FILE	0
#define ETEXT_FILE	1

/* breadth-first searching */
#define BFS_ERROR		-1
#define BFS_ALREADY_THERE	-2
#define BFS_NO_PATH		-3

/* mud-life time */
#define SECS_PER_SEGMENT       2
#define SECS_PER_MUD_MINUTE    20
#define SECS_PER_ROUND         (10*SECS_PER_SEGMENT)
#define SECS_PER_TURN          (10*SECS_PER_MUD_MINUTE)
#define SECS_PER_MUD_HOUR      (60 * SECS_PER_MUD_MINUTE)
#define SECS_PER_MUD_DAY	(24*SECS_PER_MUD_HOUR)
#define SECS_PER_MUD_MONTH	(35*SECS_PER_MUD_DAY)
#define SECS_PER_MUD_YEAR	(17*SECS_PER_MUD_MONTH)

/* real-life time (remember Real Life?) */
#define SECS_PER_REAL_MIN	60
#define SECS_PER_REAL_HOUR	(60*SECS_PER_REAL_MIN)
#define SECS_PER_REAL_DAY	(24*SECS_PER_REAL_HOUR)
#define SECS_PER_REAL_YEAR	(365*SECS_PER_REAL_DAY)


/* string utils ********************************************************* */


#define YESNO(a) ((a) ? "YES" : "NO")
#define ONOFF(a) ((a) ? "ON" : "OFF")

#define LOWER(c)   (((c)>='A'  && (c) <= 'Z') ? ((c)+('a'-'A')) : (c))
#define UPPER(c)   (((c)>='a'  && (c) <= 'z') ? ((c)+('A'-'a')) : (c) )

#define ISNEWL(ch) ((ch) == '\n' || (ch) == '\r')
#define IF_STR(st) ((st) ? (st) : "\0")
#define CAP(st)  (*(st) = UPPER(*(st)), st)
#define UNCAP(st)  (*(st) = LOWER(*(st)), st)

#define AN(string) (strchr("aeiouAEIOU", *string) ? "an" : "a")
#define CAP_AN(string) (strchr("aeiouAEIOU", *string) ? "An" : "A")

/* memory utils ********************************************************* */



/*
 * the source previously used the same code in many places to remove an item
 * from a list: if it's the list head, change the head, else traverse the
 * list looking for the item before the one to be removed.  Now, we have a
 * macro to do this.  To use, just make sure that there is a variable 'temp'
 * declared as the same type as the list to be manipulated.  BTW, this is
 * a great application for C++ templates but, alas, this is not C++.  Maybe
 * CircleMUD 4.0 will be...
 */
#define REMOVE_FROM_LIST(item, head, next)	\
   if ((item) == (head))		\
      head = (item)->next;		\
   else {				\
      temp = head;			\
      while (temp && (temp->next != (item))) \
	 temp = temp->next;		\
      if (temp)				\
         temp->next = (item)->next;	\
   }					\


/* basic bitvector utils ************************************************ */


#define IS_SET(flag,bit)  ((flag) & (bit))
#define SET_BIT(var,bit)  ((var) |= (bit))
#define REMOVE_BIT(var,bit)  ((var) &= ~(bit))
#define TOGGLE_BIT(var,bit) ((var) = (var) ^ (bit))

#define MOB_FLAGS(ch) ((ch)->char_specials.saved.act)
#define PLR_FLAGS(ch) ((ch)->char_specials.saved.act)
#define PRF_FLAGS(ch) ((ch)->player_specials->saved.pref)
#define AFF_FLAGS(ch) ((ch)->char_specials.saved.affected_by)
#define AFF2_FLAGS(ch) ((ch)->char_specials.saved.affected_by2)
#define AFF3_FLAGS(ch) ((ch)->char_specials.saved.affected_by3)
#define AFF4_FLAGS(ch) ((ch)->char_specials.saved.affected_by4)
#define PROT_FLAGS(ch) ((ch)->char_specials.saved.protection)
#define DETE_FLAGS(ch) ((ch)->char_specials.saved.detecting)
#define CONT_FLAGS(ch) ((ch)->char_specials.saved.controlling)
#define GRANT_FLAGS(ch) ((ch)->char_specials.saved.granted_one)
#define GRANT2_FLAGS(ch) ((ch)->char_specials.saved.granted_two)
#define ROOM_FLAGS(loc) (world[(loc)].room_flags)

/* temp till the rest is done... */
#define EVIL_RACE(ch) 0
#define GOOD_RACE(ch) 1

#define IS_SWINGING(ch)	((ch)->char_specials.s_o_t == FORM_SWING)
#define IS_PC(ch)   (!IS_NPC(ch))
#define IS_NPC(ch)  (IS_SET(MOB_FLAGS(ch), MOB_ISNPC))
#define IS_MOB(ch)  (IS_NPC(ch) && ((ch)->nr >-1))
#define IS_GOD(ch)		(!IS_NPC(ch) && (GET_LEVEL(ch) >= LVL_GOD1))
#define IS_TRUSTED(ch) ((IS_GOD(ch) && PRF_FLAGGED(ch, PRF_HOLYLIGHT)) || \
		(MORPH_MOB(ch) && IS_GOD(MORPH_MOB(ch)) && PRF_FLAGGED(MORPH_MOB(ch), PRF_HOLYLIGHT)))
#define IS_FIGHTING(ch) ((ch)->char_specials.fighting)
#define IS_GROUP(ch) (IS_AFFECTED(ch, AFF_GROUP) && ((ch)->master || \
(ch)->followers))

#define MOB_FLAGGED(ch, flag) (IS_NPC(ch) && IS_SET(MOB_FLAGS(ch), (flag)))
#define PLR_FLAGGED(ch, flag) (!IS_NPC(ch) && IS_SET(PLR_FLAGS(ch), (flag)))
#define AFF_FLAGGED(ch, flag) (IS_SET(AFF_FLAGS(ch), (flag)))
#define AFF2_FLAGGED(ch, flag) (IS_SET(AFF2_FLAGS(ch), (flag)))
#define AFF3_FLAGGED(ch, flag) (IS_SET(AFF3_FLAGS(ch), (flag)))
#define AFF4_FLAGGED(ch, flag) (IS_SET(AFF4_FLAGS(ch), (flag)))
#define PRF_FLAGGED(ch, flag) (IS_SET(PRF_FLAGS(ch), (flag)))
#define ROOM_FLAGGED(loc, flag) (IS_SET(ROOM_FLAGS(loc), (flag)))

#define MULTI_FLAGGED(ch, flag) (IS_SET(MULTI_FLAGS(ch), (flag)))
#define MULTI_FLAGS(ch) ((ch)->player_specials->saved.multi_flags)

/* IS_AFFECTED for backwards compatibility */
#define IS_AFFECTED(ch, skill) (AFF_FLAGGED((ch), (skill)))
#define IS_AFFECTED1(ch, skill) (AFF_FLAGGED((ch), (skill)))
#define IS_AFFECTED2(ch, skill) (IS_SET((ch)->char_specials.saved.affected_by2, (skill)))
#define IS_AFFECTED3(ch, skill) (IS_SET((ch)->char_specials.saved.affected_by3, (skill)))
#define IS_AFFECTED4(ch, skill) (IS_SET((ch)->char_specials.saved.affected_by4, (skill)))
#define IS_PROTECTED(ch, skill) (IS_SET((ch)->char_specials.saved.protection, (skill)))
#define IS_DETECTING(ch, skill) (IS_SET((ch)->char_specials.saved.detecting, (skill)))
#define IS_CONTROLLING(ch, skill) (IS_SET((ch)->char_specials.saved.controlling, (skill)))

#define IS_STUNNED(ch) (GET_STAT(ch) <= STAT_INCAP)

#define PLR_TOG_CHK(ch,flag) ((TOGGLE_BIT(PLR_FLAGS(ch), (flag))) & (flag))
#define PRF_TOG_CHK(ch,flag) ((TOGGLE_BIT(PRF_FLAGS(ch), (flag))) & (flag))


/* room utils *********************************************************** */


#define SECT(room)	(world[(room)].sector_type)

#define IS_MAP_ROOM(room) (world[(room)].number > 100000)
#define IS_MAP_ZONE(zon) (zon >= 1100 && zon <= 1450)
#define IS_WATER_ROOM(room) (SECT(room) == SECT_WATER_SWIM || \
				SECT(room) == SECT_WATER_NOSWIM || \
				SECT(room) == SECT_UNDERWATER)
#define IS_WATER_CORD(room, x, y)  (world[room].map && \
        (x < GET_X_SIZE(room) && x > 0) && \
        (y < GET_Y_SIZE(room) && y > 0) && \
	(world[room].map->map_grid[x][y] == MAP_LAKE || \
	world[room].map->map_grid[x][y] == MAP_RIVER || \
	world[room].map->map_grid[x][y] == MAP_SWAMP))

#define WILDERNESS(room) (world[room].shape == ROOM_SHAPE_WILDERNESS)
#define IS_DARK(room)  ( !world[room].light && \
                         (ROOM_FLAGGED(room, ROOM_DARK) || \
			(SECT(room) == SECT_CAVE) || \
                          ( ( SECT(room) != SECT_INSIDE && \
                              SECT(room) != SECT_CITY ) && \
                            (sunlight == SUN_SET || \
			     sunlight == SUN_DARK)) ) )

#define IS_LIGHT(room)  (!IS_DARK(room))

#define GET_ROOM_SPEC(room) ((room) >= 0 ? world[(room)].func : NULL)
#define GET_ZONE_SPEC(zone) ((zone) >= 0 ? zone_table[zone].func : NULL)

#define GET_ROOM_NAME(rnum) (*(((rnum) < 0 || (rnum) > top_of_world) ? \
        (log("SYSERR: Out of range world index %d at %s:%d.", (rnum), \
        __FILE__, __LINE__), &world[0].name) : &world[(rnum)].name))

/* char utils *********************************************************** */


#define IN_ROOM(ch)	((ch)->in_room)
#define GET_WAS_IN(ch)	((ch)->was_in_room)
#define GET_AGE(ch)     (age(ch).year)

#define GET_NAME(ch)    (IS_NPC(ch) ? \
			 (ch)->player.short_descr : (ch)->player.name)
#define GET_TITLE(ch)   ((ch)->player.title)
#define GET_LEVEL(ch)   ((ch)->player.level)
#define GET_SIZE(ch)    ((ch)->player.size)
#define GET_HOMETOWN(ch)((ch)->player.hometown)
#define GET_BIRTHPLACE(ch) ((ch)->player.birthplace)
#define GET_PASSWD(ch)	((ch)->player.passwd)
#define GET_PFILEPOS(ch)((ch)->pfilepos)

#define GET_TOT_LEVEL(ch) ((ch)->player_specials->saved.total_level)

#define GET_QUEST(ch)   ((ch)->current_quest)
#define GET_QUEST_TYPE(ch) (aquest_table[real_quest((int)GET_QUEST((ch)))].type)
#define GET_NUM_QUESTS(ch)      ((ch)->num_completed_quests)


/*
 * I wonder if this definition of GET_REAL_LEVEL should be the definition
 * of GET_LEVEL?  JE
 */
#define GET_REAL_LEVEL(ch) \
   (ch->desc && ch->desc->original ? GET_LEVEL(ch->desc->original) : \
    GET_LEVEL(ch))

#define GET_CLASS(ch)   ((ch)->player.class)
#define GET_RACE(ch)	((ch)->player.race)
#define GET_HOME(ch)	((ch)->player.hometown)
#define GET_HEIGHT(ch)	((ch)->player.height)
#define GET_WEIGHT(ch)	((ch)->player.weight)
#define GET_SEX(ch)	((ch)->player.sex)

#define GET_STR(ch)     ((ch)->aff_abils.str)
#define GET_ADD(ch)     ((ch)->aff_abils.str_add)
#define GET_DEX(ch)     ((ch)->aff_abils.dex)
#define GET_INT(ch)     ((ch)->aff_abils.intel)
#define GET_WIS(ch)     ((ch)->aff_abils.wis)
#define GET_CON(ch)     ((ch)->aff_abils.con)
#define GET_CHA(ch)     ((ch)->aff_abils.cha)

#define GET_EXP(ch)	  ((ch)->points.exp)
#define GET_AC(ch)        ((ch)->points.armor)
#define GET_HIT(ch)	  ((ch)->points.hit)
#define GET_HIT_WA(ch)	((ch)->points.body_points.weapon_arm)
#define GET_HIT_WH(ch)	((ch)->points.body_points.weapon_hand)
#define GET_HIT_TO(ch)	((ch)->points.body_points.torso)
#define GET_HIT_SA(ch)	((ch)->points.body_points.shield_arm)
#define GET_HIT_SH(ch)	((ch)->points.body_points.shield_hand)
#define GET_HIT_LL(ch)	((ch)->points.body_points.left_leg)
#define GET_HIT_LF(ch)	((ch)->points.body_points.left_foot)
#define GET_HIT_RL(ch)	((ch)->points.body_points.right_leg)
#define GET_HIT_RF(ch)	((ch)->points.body_points.right_foot)
#define GET_HIT_HD(ch)	((ch)->points.body_points.head)
#define GET_MAX_HIT(ch)	  ((ch)->points.max_hit)
#define GET_VIT(ch)      ((ch)->points.vitality)
#define GET_MAX_VIT(ch)  ((ch)->points.max_vitality)

#define IS_TIRED(ch)      (((float) GET_VIT(ch) / (float)GET_MAX_VIT(ch)) > .20)

#define GET_HITROLL(ch)	  ((ch)->points.hitroll)
#define GET_DAMROLL(ch)   ((ch)->points.damroll)

#define GET_POS(ch)     ((ch)->char_specials.position & 3)
#define GET_STAT(ch)     ((ch)->char_specials.position & STAT_MASK)
#define GET_IDNUM(ch)	  ((ch)->char_specials.saved.idnum)
#define GET_ID(i)	  ((i)->id)
#define IS_CARRYING_W(ch) ((ch)->char_specials.carry_weight)
#define IS_CARRYING_N(ch) ((ch)->char_specials.carry_items)
#define FIGHTING(ch)	  ((ch)->char_specials.fighting)
#define GET_BLINK(ch)  ((ch)->char_specials.blink_event)
#define TARGET_ROOM(ch)	  ((ch)->char_specials.target_room)
#define HUNTING(ch)	  ((ch)->char_specials.hunting)
#define FURNITURE(ch)     ((ch)->char_specials.furniture)
#define RIDING(ch)	  ((ch)->char_specials.riding)
#define RIDDEN_BY(ch)	  ((ch)->char_specials.ridden_by)
#define VEHICLE(ch)	  ((ch)->char_specials.vehicle)
#define GET_SAVE(ch, i)	  ((ch)->char_specials.saved.apply_saving_throw[i])
#ifndef PWIPE
#define GET_ALIGNMENT(ch) ((ch)->char_specials.saved.alignment)
#else
#define GET_ALIGNMENT(ch) ac_get_alignment(ch)
#define SET_ALIGNMENT(ch, i) ac_set_alignment(ch, i)
#endif
#define GET_HIGH_LEVEL(ch) ((ch)->char_specials.saved.high_level)
#define GET_THIEF_SKILL(ch) ((ch)->char_specials.saved.thief_skill)
#define GET_FIGHTER_SKILL(ch) ((ch)->char_specials.saved.fighter_skill)
#define GET_NON_WEAPON_PROF(ch) ((ch)->char_specials.saved.weapon_prof)
#define GET_WEAPON_PROF(ch)     ((ch)->char_specials.saved.non_weapon_prof)
#define GET_X_CORD(ch)	  (IS_MOB(ch) ? (ch)->mob_specials.x_cord : (ch)->player_specials->saved.x_cord)
#define GET_Y_CORD(ch)    (IS_MOB(ch) ? (ch)->mob_specials.y_cord : (ch)->player_specials->saved.y_cord)
#define GET_Z_CORD(ch)    (IS_MOB(ch) ? (ch)->mob_specials.z_cord : (ch)->player_specials->saved.z_cord)
#define GET_FACING(ch)    (IS_MOB(ch) ? (ch)->mob_specials.facing : (ch)->player_specials->saved.facing)
#define SET_FACING(ch, newdir) ((((newdir) != GET_FACING(ch)) && \
                                ((ch)->watchers || (ch)->watching)) ? \
                               change_facing(ch,(newdir)) : \
                               ((GET_FACING(ch)) = (newdir)))
#define GET_DOM_HAND(ch)  (IS_MOB(ch) ? (ch)->mob_specials.dominant_hand : (ch)->player_specials->saved.dominant_hand)
#define IS_SAME_CORD(ch, ch1) (GET_X_CORD(ch) == GET_X_CORD(ch1) && GET_Y_CORD(ch) == GET_Y_CORD(ch1) && GET_Z_CORD(ch) == GET_Z_CORD(ch1))
#define GET_MAGIC_RESISTANCE(ch) ((ch)->char_specials.magic_resistance)
#define GET_ACTION(ch)    ((ch)->char_specials.action)
#define GET_AIMING(ch)	((ch)->char_specials.target_location)
#define GET_STYLE(ch) ((ch)->char_specials.style)
#define GET_FORM(ch) (ch->char_specials.s_o_t)
#define TERM_TYPE(i)     (i->term_type)
#define CLS(i) (IS_ANSI_TERM(i) ? "\033[H\033[J" : "")
#define TERM_GENERIC        1
#define TERM_ANSI           2
#define TERM_MSP            3	/* mud sound protocal */
#define TERM_GREY	    4
#define TERM_CLIENT	    5
#define TERM_UNDEFINED    255
#define IS_ANSI_TERM(i) (i && (i->term_type == TERM_ANSI || i->term_type == TERM_MSP || i->term_type == TERM_GREY || i->term_type == TERM_CLIENT))
#define IS_CLIENT_TERM(i) (i && (i->term_type == TERM_CLIENT))
#define IS_GREY_TERM(i)   (i && (i->term_type == TERM_GREY))

#define IS_MAGE_SPECIALIST(ch)  ((ch)->char_specials.saved.specialist)
#define GET_MAGE_SCHOOL(ch)     ((ch)->char_specials.saved.mage_school)
#define GET_PRIEST_SPHERE_MAJOR(ch)   ((ch)->char_specials.saved.priest_sphere_major)
#define GET_PRIEST_SPHERE_MINOR(ch)   ((ch)->char_specials.saved.priest_sphere_minor)
#define GET_PRIEST_DEITY(ch)    ((ch)->char_specials.saved.priest_deity)

#define GET_COND(ch, i)		((ch)->player_specials->saved.conditions[(i)])
#define GET_LOADROOM(ch)	((ch)->player_specials->saved.load_room)
#define GET_INVIS_LEV(ch)	((ch)->player_specials->saved.invis_level)
#define GET_WIMP_LEV(ch)	((ch)->player_specials->saved.wimp_level)
#define GET_FREEZE_LEV(ch)	((ch)->player_specials->saved.freeze_level)
#define GET_BAD_PWS(ch)		((ch)->player_specials->saved.bad_pws)
#define GET_TALK(ch, i)		((ch)->player_specials->saved.talks[i])
#define GET_LAST_HOST(ch)	((ch)->player_specials->saved.last_host)
#define POOFIN(ch)		((ch)->player_specials->poofin)
#define POOFOUT(ch)		((ch)->player_specials->poofout)
#define GET_LAST_OLC_TARG(ch)	((ch)->player_specials->last_olc_targ)
#define GET_LAST_OLC_MODE(ch)	((ch)->player_specials->last_olc_mode)
#define GET_ALIASES(ch)		((ch)->player_specials->aliases)
#define GET_LAST_TELL(ch)	((ch)->player_specials->last_tell)

#define IS_MAGE_SPELL(spell)	((spell_info[spell].min_level[CLASS_MAGIC_USER] < 10))
#define IS_PRIEST_SPELL(spell)  ((spell_info[spell].min_level[CLASS_CLERIC] < 10))
#define GET_SPELL_LEVEL(spell, pc_class) (spell_info[spell].min_level[pc_class])
#define GET_SPELL(ch, i)	((ch)->char_specials.saved.spells[i])
#define SET_SPELL(ch, i, pct)	{(ch)->char_specials.saved.spells[i] = pct;}
#define GET_SPELL_SPHERE(spell) (spell_info[spell].sphere)
#define GET_SPELL_SCHOOL(spell) (spell_info[spell].school)

#define GET_SKILL(ch, i)	((ch)->char_specials.saved.skills[i])
#define SET_SKILL(ch, i, pct)	{(ch)->char_specials.saved.skills[i] = pct;}

#define GET_EQ(ch, i)		((ch)->equipment[i])

#define GET_POINTS_EVENT(ch, i) ((ch)->points_event[i])
#define GET_DAMAGE_EVENTS(ch)   ((ch)->damage_events)

#define GET_MOB_SPEC(ch) (IS_MOB(ch) ? (mob_index[(ch->nr)].func) : NULL)
#define GET_MOB_RNUM(mob)	((mob)->nr)
#define GET_MOB_VNUM(mob)	(IS_MOB(mob) ? \
				 mob_index[GET_MOB_RNUM(mob)].virtual : -1)

#define GET_MOB_ORIG_VNUM(ch)   ((ch)->mob_specials.orig_vnum)
#define GET_MOB_SPEC_VALUE(ch, val)   ((ch)->mob_specials.special[(val)])
#define GET_HPDIE(ch)		((ch)->mob_specials.hp_die)
#define GET_HPPLUS(ch)		((ch)->mob_specials.hp_plus)
#define GET_MOB_WAIT(ch)	((ch)->mob_specials.wait_state)
#define GET_MOB_MOVE(ch)	((ch)->mob_specials.movement)
#define GET_MOB_LASTMOVE(ch)	((ch)->mob_specials.last_direction)
#define GET_MOB_ATTACK_DESC(ch) ((ch)->mob_specials.attack_desc)
#define GET_DEFAULT_POS(ch)	((ch)->mob_specials.default_pos)
#define MEMORY(ch)		((ch)->mob_specials.memory)
#define GET_THAC0(ch)		(IS_MOB(ch) ? (ch)->mob_specials.thac0 : thaco[(int) GET_CLASS(ch)][(int) GET_LEVEL(ch)])
#define GET_MOB_THAC0(ch)	((ch)->mob_specials.thac0)
#define GET_MOB_TREASURE(ch)	((ch)->mob_specials.treasure_type)
#define GET_MOB_LAST_ATTACK_TYPE(ch)	((ch)->mob_specials.last_attack)
#define GET_MOB_LAST_ATTACK_SUCCESS(ch)	((ch)->mob_specials.last_attack_ok)

#define STRENGTH_APPLY_INDEX(ch) \
        ( ((GET_ADD(ch)==0) || (GET_STR(ch) != 18)) ? GET_STR(ch) :\
          (GET_ADD(ch) <= 50) ? 26 :( \
          (GET_ADD(ch) <= 75) ? 27 :( \
          (GET_ADD(ch) <= 90) ? 28 :( \
          (GET_ADD(ch) <= 99) ? 29 :  30 ) ) )                   \
        )

#define CAN_CARRY_W(ch) (str_app[STRENGTH_APPLY_INDEX(ch)].carry_w)
#define CAN_WIELD_W(ch) (str_app[STRENGTH_APPLY_INDEX(ch)].wield_w)
#define CAN_CARRY_N(ch) (5 + (GET_DEX(ch) >> 1) + (GET_LEVEL(ch) >> 1))
#define AWAKE(ch) (GET_STAT(ch) > STAT_SLEEPING)
#define CAN_SEE_IN_DARK(ch) \
   (AFF_FLAGGED(ch, AFF_INFRAVISION) || PRF_FLAGGED(ch, PRF_HOLYLIGHT))

#define NATURAL_ATTACK(type)	((type == TYPE_HIT) || (type == TYPE_STING)\
                                 ||(type == TYPE_BITE) || (type == TYPE_CLAW)\
                                 ||(type == TYPE_THRASH) || (type == TYPE_BLAST)\
                                 ||(type == TYPE_PUNCH))

#define CAN_HIT_FIVE(ch,weapon)  (GET_EQ(ch,weapon)->affected[0].modifier > 4)

#define CAN_HIT_FOUR(ch,weapon)  (GET_EQ(ch,weapon)->affected[0].modifier > 3)

#define CAN_HIT_THREE(ch,weapon)  (GET_EQ(ch,weapon)->affected[0].modifier > 2)

#define CAN_HIT_TWO(ch,weapon)  (GET_EQ(ch,weapon)->affected[0].modifier > 1)

#define CAN_HIT_ONE(ch,weapon)  (GET_EQ(ch,weapon)->affected[0].modifier > 0)

#define IS_GOOD(ch)    ((GET_ALIGNMENT(ch) >= ALIGN_LAWFUL_GOOD) && \
(GET_ALIGNMENT(ch) <= ALIGN_CHAOTIC_GOOD))

#define IS_EVIL(ch)    ((GET_ALIGNMENT(ch) >= ALIGN_LAWFUL_EVIL) && \
(GET_ALIGNMENT(ch) <= ALIGN_CHAOTIC_EVIL))

#define IS_LAWFUL(ch)  ((GET_ALIGNMENT(ch) == ALIGN_LAWFUL_GOOD) || \
(GET_ALIGNMENT(ch) == ALIGN_LAWFUL_NEUTRAL) || (GET_ALIGNMENT(ch) == \
ALIGN_LAWFUL_EVIL))

#define IS_CHAOTIC(ch) ((GET_ALIGNMENT(ch) == ALIGN_CHAOTIC_GOOD) || \
(GET_ALIGNMENT(ch) == ALIGN_CHAOTIC_NEUTRAL) || (GET_ALIGNMENT(ch) == \
ALIGN_CHAOTIC_EVIL))

#define IS_NEUTRAL(ch) ((GET_ALIGNMENT(ch) == ALIGN_NEUTRAL_NEUTRAL) || \
(GET_ALIGNMENT(ch) == ALIGN_LAWFUL_NEUTRAL) || \
(GET_ALIGNMENT(ch) == ALIGN_CHAOTIC_NEUTRAL) || \
(GET_ALIGNMENT(ch) == ALIGN_NEUTRAL_GOOD) || \
(GET_ALIGNMENT(ch) == ALIGN_NEUTRAL_EVIL))

#define IS_TRUE_NEUTRAL(ch) (GET_ALIGNMENT(ch) == ALIGN_NEUTRAL_NEUTRAL)


/* descriptor-based utils *********************************************** */


#define WAIT_STATE(ch, cycle) { \
	if ((ch)->desc) (ch)->desc->wait = (cycle); \
	else if (IS_NPC(ch)) GET_MOB_WAIT(ch) = (cycle); }

#define CHECK_WAIT(ch)	(((ch)->desc) ? ((ch)->desc->wait > 1) : 0)
#define GET_VIEW_DISTANCE(ch) (((ch)->desc ? ((ch)->desc->view) : 10)
#define GET_SCREEN_LENGTH(ch) (((ch)->desc ? ((ch)->desc->screen_length) : 24)
#define STATE(d)	((d)->connected)


/* object utils ********************************************************* */

#define GET_OBJ_NAME(obj)	((obj)->name)
#define GET_OBJ_LONG(obj)	((obj)->description)
#define GET_OBJ_SHORT(obj)	((obj)->short_description)
#define GET_OBJ_ACTION(obj)	((obj)->action_description)
#define GET_OBJ_OWNER(obj)      ((obj)->idnum_owner)
#define GET_OBJ_TYPE(obj)	((obj)->obj_flags.type_flag)
#define GET_OBJ_COST(obj)	((obj)->obj_flags.cost)
#define GET_OBJ_X_CORD(obj)	((obj)->obj_flags.x_cord)
#define GET_OBJ_Y_CORD(obj)	((obj)->obj_flags.y_cord)
#define GET_OBJ_Z_CORD(obj)	((obj)->obj_flags.z_cord)
#define GET_OBJ_EXTRA(obj)	((obj)->obj_flags.extra_flags)
#define GET_OBJ_EXTRA2(obj)	((obj)->obj_flags.extra2_flags)
#define GET_OBJ_ANTI(obj)	((obj)->obj_flags.anti_flags)
#define GET_OBJ_WEAR(obj)	((obj)->obj_flags.wear_flags)
#define GET_OBJ_VAL(obj, val)	((obj)->obj_flags.value[(val)])
#define GET_OBJ_WEIGHT(obj)	((obj)->obj_flags.weight)
#define GET_OBJ_SIZE(obj)	((obj)->obj_flags.size)
#define GET_OBJ_SPACE(obj)	((obj)->obj_flags.space)
#define GET_OBJ_RACE(obj)	((obj)->obj_flags.race)
#define GET_OBJ_MATERIAL(obj)	((obj)->obj_flags.material)
#define GET_OBJ_STATUS(obj)	((obj)->obj_flags.status)
#define GET_OBJ_CONDITION(obj)	((obj)->obj_flags.condition)
#define GET_OBJ_MAX_COND(obj)   ((obj)->obj_flags.max_cond)
#define GET_OBJ_CRAFTSMANSHIP(obj)	((obj)->obj_flags.craftsmanship)
#define GET_OBJ_TIMER(obj)	((obj)->obj_flags.timer)
#define GET_OBJ_EVENT(obj)	((obj)->obj_flags.action)
#define GET_OBJ_RNUM(obj)	((obj)->item_number)
#define GET_OBJ_VNUM(obj)	(GET_OBJ_RNUM(obj) >= 0 ? \
				 obj_index[GET_OBJ_RNUM(obj)].virtual : -1)
#define IS_OBJ_STAT(obj,stat)	(IS_SET((obj)->obj_flags.extra_flags,stat))
#define IS_OBJ_STAT2(obj,stat)	(IS_SET((obj)->obj_flags.extra2_flags,stat))


#define GET_OBJ_ORIG_VNUM(obj)	((obj)->obj_flags.orig_vnum > 0 ? \
				(obj)->obj_flags.orig_vnum : \
				GET_OBJ_VNUM(obj) <= 5000 ? \
				GET_OBJ_VNUM(obj) : -1)

#define IS_CORPSE(obj)		(GET_OBJ_TYPE(obj) == ITEM_CONTAINER && \
					GET_OBJ_VAL((obj), 3) == 1)

#define GET_OBJ_SPEC(obj) ((obj)->item_number >= 0 ? \
	(obj_index[(obj)->item_number].func) : NULL)

#define CAN_WEAR(obj, part) (IS_SET((obj)->obj_flags.wear_flags, (part)))

/* compound utilities and other macros ********************************* */


#define HSHR(ch) (GET_SEX(ch) ? (GET_SEX(ch)==SEX_MALE ? "his":"her") :"its")
#define HSSH(ch) (GET_SEX(ch) ? (GET_SEX(ch)==SEX_MALE ? "he" :"she") : "it")
#define HMHR(ch) (GET_SEX(ch) ? (GET_SEX(ch)==SEX_MALE ? "him":"her") : "it")

#define ANA(obj) (strchr("aeiouyAEIOUY", *(obj)->name) ? "An" : "A")
#define SANA(obj) (strchr("aeiouyAEIOUY", *(obj)->name) ? "an" : "a")

#define NEEDS_TWO_HANDS(ch, obj) ((GET_SIZE(ch) < GET_OBJ_SIZE(obj)) || \
                                     (GET_OBJ_WEIGHT(obj) > (CAN_WIELD_W(ch)/2)))

/* Various macros building up to CAN_SEE */

#define LIGHT_OK(sub)	(!IS_AFFECTED(sub, AFF_BLIND) && \
   (IS_LIGHT((sub)->in_room) || IS_AFFECTED((sub), AFF_INFRAVISION)))

#define INVIS_OK(sub, obj) \
 ((!IS_AFFECTED((obj),AFF_INVISIBLE) || IS_DETECTING(sub,DETECTING_INVIS)) && \
 (!IS_AFFECTED((obj), AFF_HIDE) || IS_DETECTING(sub, DETECTING_LIFE)) && \
 (GET_INVIS_LEV(obj) < GET_LEVEL(sub))

#define MORT_CAN_SEE(sub, obj) (LIGHT_OK(sub) && INVIS_OK(sub, obj))

#define IMM_CAN_SEE(sub, obj) \
   (MORT_CAN_SEE(sub, obj) || PRF_FLAGGED(sub, PRF_HOLYLIGHT))

#define SELF(sub, obj)  ((sub) == (obj))

/* Can subject see character "obj"? */
#if 0
#define CAN_SEE(sub, obj) (SELF(sub, obj) || \
   ((GET_REAL_LEVEL(sub) >= GET_INVIS_LEV(obj)) && IMM_CAN_SEE(sub, obj)))
#else
#define CAN_SEE(sub, obj)       (ac_can_see((sub), (obj), 0))
#define CAN_SEE_WHO(sub, obj)   (ac_can_see((sub), (obj), 1))
#endif

/* End of CAN_SEE */


#define INVIS_OK_OBJ(sub, obj) \
  (!IS_OBJ_STAT((obj), ITEM_INVISIBLE) || IS_DETECTING((sub), DETECTING_INVIS))

#define MORT_CAN_SEE_OBJ(sub, obj) (LIGHT_OK(sub) && INVIS_OK_OBJ(sub, obj))

#define CAN_SEE_OBJ(sub, obj) \
   (MORT_CAN_SEE_OBJ(sub, obj) || IS_TRUSTED(sub))

#define CAN_CARRY_OBJ(ch,obj)  \
   (((IS_CARRYING_W(ch) + GET_OBJ_WEIGHT(obj)) <= CAN_CARRY_W(ch)) &&   \
    ((IS_CARRYING_N(ch) + 1) <= CAN_CARRY_N(ch)))

#define CAN_GET_OBJ(ch, obj)   \
   (CAN_WEAR((obj), ITEM_WEAR_TAKE) && CAN_CARRY_OBJ((ch),(obj)) && \
    CAN_SEE_OBJ((ch),(obj)))


#define OBJS(obj, vict) (CAN_SEE_OBJ((vict), (obj)) ? \
	(obj)->short_description  : "something")

#define OBJN(obj, vict) (CAN_SEE_OBJ((vict), (obj)) ? \
	fname((obj)->name) : "something")

#define GET_X_SIZE(room) (world[room].x_size)
#define GET_Y_SIZE(room) (world[room].y_size)
#define GET_Z_SIZE(room) (world[room].z_size)

#define GET_DOOR_X_CORD(room, door) (world[room].dir_option[door]->x_cord)
#define GET_DOOR_Y_CORD(room, door) (world[room].dir_option[door]->y_cord)
#define GET_DOOR_Z_CORD(room, door) (world[room].dir_option[door]->z_cord)

#define EXIT(ch, door)  (world[(ch)->in_room].dir_option[door])
#define _2ND_EXIT(ch, door) (world[EXIT(ch, door)->to_room].dir_option[door])
#define _3RD_EXIT(ch, door) (world[_2ND_EXIT(ch, door)->to_room].dir_option[doo>
#define VIRTUAL_EXIT(rnum, door)  (world[rnum].dir_option[door])

#define CAN_SEE_EXIT(ch, room, door) \
        (ch && VIRTUAL_EXIT(room, door) && (VIRTUAL_EXIT(room, door)->to_room != NOWHERE) && \
        !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_SECRET) && \
        !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_BLOCKED))

#define CAN_GO(ch, door) \
        (ch && EXIT(ch, door) && (EXIT(ch, door)->to_room != NOWHERE) && \
        !IS_SET(EXIT(ch, door)->exit_info, EX_CLOSED) && \
        !IS_SET(EXIT(ch, door)->exit_info, EX_WALLED) && \
        !IS_SET(EXIT(ch, door)->exit_info, EX_SECRET) && \
        !IS_SET(EXIT(ch, door)->exit_info, EX_BLOCKED))

#define VIRTUAL_CAN_GO(room, door) \
        (VIRTUAL_EXIT(room, door) && \
        VIRTUAL_EXIT(room, door)->to_room != NOWHERE && \
        !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_CLOSED) && \
        !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_WALLED) && \
        !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_SECRET) && \
        !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_BLOCKED))
			
#define DOOR_IS_OPENABLE(room, obj, door)	((obj) ? \
			((((GET_OBJ_TYPE(obj) == ITEM_CONTAINER) && IS_SET(GET_OBJ_VAL(obj, 1), CONT_CLOSEABLE)) || \
			(GET_OBJ_TYPE(obj) == ITEM_FURNITURE && IS_SET(GET_OBJ_VAL(obj, 4), FURN_BOOKCASE)) || \
 			(GET_OBJ_TYPE(obj) == ITEM_FURNITURE && IS_SET(GET_OBJ_VAL(obj, 4), FURN_DESK)))) : \
			(IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_ISDOOR) \
		        && !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_WALLED) \
		        && !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_SMASHED) \
		        && !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_SPIKED) \
			&& !IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_NOSEE)))

#define DOOR_IS_OPEN(room, obj, door)	((obj) ? \
			(!IS_SET(GET_OBJ_VAL(obj, 1), CONT_CLOSED)) :\
			(!IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_CLOSED)))

#define DOOR_IS_UNLOCKED(room, obj, door)	((obj) ? \
			(!IS_SET(GET_OBJ_VAL(obj, 1), CONT_LOCKED)) :\
			(!IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_LOCKED)))

#define DOOR_IS_PICKPROOF(room, obj, door) ((obj) ? \
			(IS_SET(GET_OBJ_VAL(obj, 1), CONT_PICKPROOF)) : \
			(IS_SET(VIRTUAL_EXIT(room, door)->exit_info, EX_PICKPROOF)))

#define DOOR_IS_CLOSED(room, obj, door)	(!(DOOR_IS_OPEN(room, obj, door)))

#define DOOR_IS_LOCKED(room, obj, door)	(!(DOOR_IS_UNLOCKED(room, obj, door)))

#define DOOR_KEY(room, obj, door)	((obj) ? (GET_OBJ_VAL(obj, 2)) : \
					(VIRTUAL_EXIT(room, door)->key))

#define DOOR_LOCK(room, obj, door)	((obj) ? (GET_OBJ_VAL(obj, 1)) : \
					(VIRTUAL_EXIT(room, door)->exit_info))

#define CLASS_ABBR(ch) (IS_NPC(ch) ? "--" : class_abbrevs[(int)GET_CLASS(ch)])

#define IS_WARRIOR(ch)		((GET_CLASS(ch) == CLASS_FIGHTER) || \
				(GET_CLASS(ch) == CLASS_PALADIN) || \
				(GET_CLASS(ch) == CLASS_RANGER) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_M) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_M_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_R) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_F) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_F_M) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_I))

#define IS_MAGE(ch)		((GET_CLASS(ch) == CLASS_MAGIC_USER) || \
				(GET_CLASS(ch) == CLASS_ILLUSIONIST) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_M) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_M) || \
				(GET_CLASS(ch) == CLASS_MULTI_M_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_M_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_I_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_I) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_I))

#define IS_ROGUE(ch)		((GET_CLASS(ch) == CLASS_THIEF) || \
				(GET_CLASS(ch) == CLASS_BARD) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_M_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_F_M_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_I_T) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_T))

#define IS_PRIEST(ch)		((GET_CLASS(ch) == CLASS_CLERIC) || \
				(GET_CLASS(ch) == CLASS_DRUID) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_M) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_R) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_F) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_F_M) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_T) || \
				(GET_CLASS(ch) == CLASS_PALADIN) || \
				(GET_CLASS(ch) == CLASS_RANGER) || \
				(GET_CLASS(ch) == CLASS_MULTI_C_I))

#define OUTSIDE(ch) 		(!ROOM_FLAGGED((ch)->in_room, ROOM_INDOORS))
#define UNDERGROUND(ch)		(SECT(IN_ROOM(ch)) == SECT_CAVE)

#define GALLOPING(ch)	  	((RIDING(ch) && AFF4_FLAGGED(RIDING(ch), AFF4_GALLOP)) || \
				AFF4_FLAGGED(ch, AFF4_GALLOP))

/* OS compatibility ***************************************************** */


/* there could be some strange OS which doesn't have NULL... */
#ifndef NULL
#define NULL (void *)0
#endif

#if !defined(FALSE)
#define FALSE 0
#endif

#if !defined(NO)
#define NO 0
#endif

#if !defined(YES)
#define YES 1
#endif

#if !defined(TRUE)
#define TRUE  (!FALSE)
#endif

#define Y TRUE
#define N FALSE

/* defines for fseek */
#ifndef SEEK_SET
#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2
#endif

/*
 * NOCRYPT can be defined by an implementor manually in sysdep.h.
 * CIRCLE_CRYPT is a variable that the 'configure' script
 * automatically sets when it determines whether or not the system is
 * capable of encrypting.
 */
#if defined(NOCRYPT) || !defined(CIRCLE_CRYPT)
#define CRYPT(a,b) (a)
#else
#define CRYPT(a,b) ((char *) crypt((a),(b)))
#endif

/***************** memory options ********************/
#if 0
#define MEMCHK 2

#ifndef MEMCHK

#define CREATE(result, type, number)  \
        if (!((result) = (type *) calloc ((number), sizeof(type)))) \
		{ perror("calloc failure"); result = (type *) (0/0); }

#define RECREATE(result, type, number) \
  if (!((result) = (type *) realloc ((char *)(result), sizeof(type) * (number))))\
		{ perror("realloc failure"); result = (type *)(0/0); }

#define FREE(i)    free(i)

#else				/* memory debug option.  See memory.c */


#define CREATE(result, type, number)  do {\
	if (!((result) = (type *) debug_calloc ((number), sizeof(type), \
						__FILE__, __LINE__)))\
		{ perror("malloc failure"); abort(); } } while(0)

#define RECREATE(result,type,number) do {\
  if (!((result) = (type *) debug_realloc ((result), sizeof(type) * (number), \
					   __FILE__, __LINE__)))\
		{ perror("realloc failure"); abort(); } } while(0)

#define FREE(i)    debug_free(i, __FILE__, __LINE__)
#endif
#endif

void *debug_calloc(size_t nobj, size_t size, char *file, int line);
void *debug_realloc(void *p, size_t size, char *file, int line);
void debug_free(void *p, char *file, int line);

#define CREATE(result, type, number)  do {\
	if (!((result) = (type *) calloc ((number), sizeof(type))))\
		{ perror("malloc failure"); abort(); } } while(0)

#define RECREATE(result,type,number) do {\
  if (!((result) = (type *) realloc ((result), sizeof(type) * (number))))\
		{ perror("realloc failure"); abort(); } } while(0)

#define really_free(variable) free((variable))
#define FREE(variable) {free((variable));(variable) = NULL;}

/* why do we care if its closed? lets try without */
/* errors loading player with backpack. re-enable */
/* error fixed in auto_equip. try without again. */
#define IS_CONTAINER(obj) \
	(((GET_OBJ_TYPE(obj) == ITEM_CONTAINER)/* && !IS_SET(GET_OBJ_VAL(obj, 1), CONT_CLOSED) */) \
	|| ((GET_OBJ_TYPE(obj) == ITEM_FURNITURE) && IS_SET(GET_OBJ_VAL(obj, 4), FURN_BOOKCASE)) \
	|| ((GET_OBJ_TYPE(obj) == ITEM_FURNITURE) && IS_SET(GET_OBJ_VAL(obj, 4), FURN_DESK)) \
	|| (GET_OBJ_TYPE(obj) == ITEM_CORPSE) || (GET_OBJ_TYPE(obj) == ITEM_SCABBARD))
#define IS_SCABBARD(obj) ((GET_OBJ_TYPE(obj) == ITEM_SCABBARD))
#define IS_SCABBARD_WEAPON(obj, cont) \
	((IS_SCABBARD(cont)) && \
		(GET_OBJ_ORIG_VNUM(obj) == GET_OBJ_VAL(cont, 0)))

#define IS_CITIZEN(ch) (GET_HOMETOWN(ch) && GET_HOMETOWN(ch) == zone_table[world[ch->in_room].zone].kingdom)
#define IS_GUARD(ch)  (isname("guard", GET_NAME(ch)) && IS_CITIZEN(ch))

#define IS_PC_HUMANOID(ch) ((GET_RACE(ch) == RACE_HUMAN) || \
	           (GET_RACE(ch) == RACE_HALFELF) || \
			   (GET_RACE(ch) == RACE_ELF) || \
			   (GET_RACE(ch) == RACE_DWARF) || \
			   (GET_RACE(ch) == RACE_HALFLING) || \
			   (GET_RACE(ch) == RACE_GNOME) || \
			   (GET_RACE(ch) == RACE_BARBARIAN) || \
                           (GET_RACE(ch) == RACE_P_DROW) || \
                           (GET_RACE(ch) == RACE_P_DUERGAR) || \
                           (GET_RACE(ch) == RACE_P_OGRE) || \
                           (GET_RACE(ch) == RACE_P_TROLL) || \
                           (GET_RACE(ch) == RACE_P_ILLITHID) || \
                           (GET_RACE(ch) == RACE_P_ORC) || \
                           (GET_RACE(ch) == RACE_P_GOBLIN) || \
			   (GET_RACE(ch) == RACE_HALFORC))

#define IS_HUMANOID(ch) ((GET_RACE(ch) == RACE_HUMAN) || \
	           (GET_RACE(ch) == RACE_HALFELF) || \
			   (GET_RACE(ch) == RACE_ELF) || \
			   (GET_RACE(ch) == RACE_DWARF) || \
                           (GET_RACE(ch) == RACE_P_DROW) || \
                           (GET_RACE(ch) == RACE_P_DUERGAR) || \
                           (GET_RACE(ch) == RACE_P_OGRE) || \
                           (GET_RACE(ch) == RACE_P_TROLL) || \
                           (GET_RACE(ch) == RACE_P_ILLITHID) || \
                           (GET_RACE(ch) == RACE_P_ORC) || \
                           (GET_RACE(ch) == RACE_P_GOBLIN) || \
			   (GET_RACE(ch) == RACE_HALFLING) || \
			   (GET_RACE(ch) == RACE_GNOME) || \
			   (GET_RACE(ch) == RACE_HALFORC) || \
			   (GET_RACE(ch) == RACE_BROWNIE) || \
			   (GET_RACE(ch) == RACE_DRYAD) || \
			   (GET_RACE(ch) == RACE_GNOLL) || \
			   (GET_RACE(ch) == RACE_GOBLIN) || \
			   (GET_RACE(ch) == RACE_HOBGOBLIN) || \
	                   (GET_RACE(ch) == RACE_KOBOLD) || \
			   (GET_RACE(ch) == RACE_LIZARD_MAN) || \
			   (GET_RACE(ch) == RACE_ORC) || \
			   (GET_RACE(ch) == RACE_SPRITE) || \
			   (GET_RACE(ch) == RACE_DROW) || \
			   (GET_RACE(ch) == RACE_TROGLODYTE))
			   
#define IS_IMMATERIAL(ch)  ((IS_AFFECTED4((ch), AFF4_WRAITHFORM)) || \
			   (GET_RACE(ch) == RACE_WRAITH) || \
			   (GET_RACE(ch) == RACE_WILL_O_WISP) || \
			   (GET_RACE(ch) == RACE_SHADOW) || \
                           (GET_RACE(ch) == RACE_POLTERGEIST) || \
                           (GET_RACE(ch) == RACE_HAUNT) || \
                           (GET_RACE(ch) == RACE_GHOST) || \
                           (GET_RACE(ch) == RACE_ELEMENTAL_AIR) || \
                           (GET_RACE(ch) == RACE_GENIE))

#define IS_DRACOLICH(ch)  ((GET_RACE(ch) == RACE_DRACOLICH))

#define IS_DRAGON(ch)  ((GET_RACE(ch) == RACE_DRAGON) || IS_DRACOLICH(ch))

#define IS_SLIME(ch) (isname ("slime", GET_NAME(ch)) || isname ("jelly", GET_NAME(ch)) \
	  	   || isname ("mold", GET_NAME(ch)) || isname ("gelatinous", GET_NAME(ch)))

#define IS_UNDEAD(ch) ((GET_RACE(ch) == RACE_BANSHEE) || \
               (GET_RACE(ch) == RACE_CRYPT_THING) || \
               (GET_RACE(ch) == RACE_DEATH_KNIGHT) || \
               (GET_RACE(ch) == RACE_GHOST) || \
               (GET_RACE(ch) == RACE_GHOUL) || \
               (GET_RACE(ch) == RACE_HAUNT) || \
               (GET_RACE(ch) == RACE_HEUCUVA) || \
               (GET_RACE(ch) == RACE_LICH) || \
               (GET_RACE(ch) == RACE_MUMMY) || \
               (GET_RACE(ch) == RACE_POLTERGEIST) || \
               (GET_RACE(ch) == RACE_REVENANT) ||\
			   (GET_RACE(ch) == RACE_SHADOW) || \
			   (GET_RACE(ch) == RACE_SKELETON) || \
			   (GET_RACE(ch) == RACE_SPECTRE) || \
		       (GET_RACE(ch) == RACE_VAMPIRE) || \
			   (GET_RACE(ch) == RACE_WIGHT) || \
			   (GET_RACE(ch) == RACE_WRAITH) || \
			   (GET_RACE(ch) == RACE_ZOMBIE) || \
                       (IS_DRACOLICH(ch)))

#define IS_ELEMENTAL(ch) ((GET_RACE(ch) == RACE_ELEMENTAL_AIR) || \
			  (GET_RACE(ch) == RACE_ELEMENTAL_EARTH) || \
			  (GET_RACE(ch) == RACE_ELEMENTAL_FIRE) || \
			  (GET_RACE(ch) == RACE_ELEMENTAL_WATER))

#define IS_SWIMMING_RACE(ch) ((GET_RACE(ch) == RACE_ELEMENTAL_WATER) || \
			(GET_RACE(ch) == RACE_FISH))

#define IS_ANIMAL(ch)  ((GET_RACE(ch) == RACE_BAT) || \
                        (GET_RACE(ch) == RACE_BEAR) || \
                        (GET_RACE(ch) == RACE_BEETLE_GIANT) || \
                        (GET_RACE(ch) == RACE_BIRD) || \
                        (GET_RACE(ch) == RACE_CAT_GREAT) || \
                        (GET_RACE(ch) == RACE_CENTIPEDE) || \
                        (GET_RACE(ch) == RACE_CROCODILE) || \
                        (GET_RACE(ch) == RACE_DINOSAUR) || \
                        (GET_RACE(ch) == RACE_DOG) || \
                        (GET_RACE(ch) == RACE_DOLPHIN) || \
                        (GET_RACE(ch) == RACE_ELEPHANT) || \
                        (GET_RACE(ch) == RACE_FISH) || \
                        (GET_RACE(ch) == RACE_FROG) || \
                        (GET_RACE(ch) == RACE_HIPPOCAMPUS) || \
                        (GET_RACE(ch) == RACE_HORSE) || \
                        (GET_RACE(ch) == RACE_INSECT) || \
                        (GET_RACE(ch) == RACE_LEECH) || \
                        (GET_RACE(ch) == RACE_LIZARD) || \
                        (GET_RACE(ch) == RACE_MAMMAL) || \
                        (GET_RACE(ch) == RACE_RAT) || \
                        (GET_RACE(ch) == RACE_SCORPION) || \
                        (GET_RACE(ch) == RACE_SEA_LION) || \
                        (GET_RACE(ch) == RACE_SNAKE) || \
                        (GET_RACE(ch) == RACE_SPIDER) || \
                        (GET_RACE(ch) == RACE_SQUID) || \
                        (GET_RACE(ch) == RACE_TOAD) || \
                        (GET_RACE(ch) == RACE_WHALE) || \
                        (GET_RACE(ch) == RACE_WOLF) || \
                        (GET_RACE(ch) == RACE_YETI))

#define IS_MAMMAL(ch)  ((GET_RACE(ch) == RACE_BAT) || \
			    (GET_RACE(ch) == RACE_BEAR) || \
				(GET_RACE(ch) == RACE_CAT_GREAT) || \
				(GET_RACE(ch) == RACE_DOG) || \
				(GET_RACE(ch) == RACE_DOLPHIN) || \
				(GET_RACE(ch) == RACE_ELEPHANT) || \
				(GET_RACE(ch) == RACE_HORSE) || \
				(GET_RACE(ch) == RACE_MAMMAL) || \
				(GET_RACE(ch) == RACE_RAT) || \
				(GET_RACE(ch) == RACE_SEA_LION) || \
				(GET_RACE(ch) == RACE_WOLF))

#define IS_DEMIHUMAN(ch) ((GET_RACE(ch) == RACE_HALFLING) || \
			   (GET_RACE(ch) == RACE_GNOME) || \
			   (GET_RACE(ch) == RACE_GOBLIN))

#define UNPASSABLE_FURNITURE(ch, x, y) \
	(world[ch->in_room].map->map_grid[x][y] == MAP_FURN_COUNTER || \
	world[ch->in_room].map->map_grid[x][y] == MAP_FURN_DESK || \
	world[ch->in_room].map->map_grid[x][y] == MAP_FURN_TABLE || \
	world[ch->in_room].map->map_grid[x][y] == MAP_FURN_BOOKCASE)

#define UNPASSABLE_ITEM(obj) \
		(GET_OBJ_TYPE(obj) == ITEM_SHIP || \
		(GET_OBJ_TYPE(obj) == ITEM_FURNITURE && GET_OBJ_VAL(obj, 4) == MAP_FURN_COUNTER) || \
		(GET_OBJ_TYPE(obj) == ITEM_FURNITURE && GET_OBJ_VAL(obj, 4) == MAP_FURN_DESK) || \
		(GET_OBJ_TYPE(obj) == ITEM_FURNITURE && GET_OBJ_VAL(obj, 4) == MAP_FURN_TABLE) || \
		(GET_OBJ_TYPE(obj) == ITEM_FURNITURE && GET_OBJ_VAL(obj, 4) == MAP_FURN_BOOKCASE) || \
		(GET_OBJ_TYPE(obj) == ITEM_TRASH && isname(obj->name, "boulder")))

#define SNEAK(ch) (IS_AFFECTED(ch, AFF_SNEAK))
#define LEVITATE(ch, dir) (IS_AFFECTED(ch, AFF_LEVITATE) && ((dir == UP) || (dir == DOWN)))
#define MIN_POS(ch, v)  \
	((GET_POS(ch) >= (ubyte)((v) & 3)) && \
	(GET_STAT(ch) >= (ubyte)((v) & STAT_MASK)))
#define SET_POS(ch, v) ((ch)->char_specials.position = (ubyte)(v))

#define MORPH_MOB(mob) ((mob)->mob_specials.orig_char)
#define MORPH_OBJ(obj) ((obj)->orig_char)
#define CHAR_POLYMORPH_OBJ(mob) ((mob)->char_specials.polymorph)
#define OBJ_POLYMORPH(o) ((o)->orig_char)

     /* generic function to point to either a PC, or the "owning"
        morph (or the original person switched into me)  */
#define GET_PLYR(a) (IS_MORPH(a, NULL) ? MORPH_MOB(a) : \
		((a)->desc && (a)->desc->original) ? \
		(a)->desc->original : (a))

#define EXITN(room, door)		(world[room].dir_option[door])
#define OPEN_DOOR(room, obj, door)	((obj) ?\
		(TOGGLE_BIT(GET_OBJ_VAL(obj, 1), CONT_CLOSED)) :\
		(TOGGLE_BIT(EXITN(room, door)->exit_info, EX_CLOSED)))
#define LOCK_DOOR(room, obj, door)	((obj) ?\
		(TOGGLE_BIT(GET_OBJ_VAL(obj, 1), CONT_LOCKED)) :\
		(TOGGLE_BIT(EXITN(room, door)->exit_info, EX_LOCKED)))

#define MOVE_CMD(cmd) (CMD_IS("north") || CMD_IS("south") || CMD_IS("east") \
	|| CMD_IS("west") || CMD_IS("up") || CMD_IS("down") || CMD_IS("northeast") \
	|| CMD_IS("northwest") || CMD_IS("southeast") || CMD_IS("southwest") \
	|| CMD_IS("ne") || CMD_IS("nw") || CMD_IS("se") || CMD_IS("sw"))

#define FIGHTING_CLASS(ch) (GET_CLASS(ch) == CLASS_FIGHTER || \
	GET_CLASS(ch) == CLASS_MULTI_F_M || GET_CLASS(ch) == CLASS_MULTI_F_T || \
	GET_CLASS(ch) == CLASS_MULTI_F_M_T || GET_CLASS(ch) == CLASS_MULTI_C_F || \
	GET_CLASS(ch) == CLASS_MULTI_C_F_M || GET_CLASS(ch) == CLASS_MULTI_F_I || \
	GET_CLASS(ch) == CLASS_BARD)

#define THIEVING_CLASS(ch) (GET_CLASS(ch) == CLASS_THIEF || GET_CLASS(ch) == CLASS_BARD || \
	GET_CLASS(ch) == CLASS_MULTI_F_T || GET_CLASS(ch) == CLASS_MULTI_M_T || \
	GET_CLASS(ch) == CLASS_MULTI_F_M_T || GET_CLASS(ch) == CLASS_MULTI_I_T || \
	GET_CLASS(ch) == CLASS_MULTI_C_T)

#define OBJ_CARRIED(obj) (obj->carried_by ? obj->carried_by : NULL)
#define OBJ_WORN(obj) (obj->worn_by ? obj_worn_by : NULL)
#define OBJ_ROOM(obj) (OBJ_CARRIED(obj) ? NULL : OBJ_WORN(obj) ? NULL : obj->in_room)

#define UNAFFECTABLE_WEAR_LOCATION(where) (where == WEAR_BACK || \
		where == WEAR_ATTACH_1 || where == WEAR_ATTACH_2 || \
		where == WEAR_ATTACH_3 || where == WEAR_WIELD || \
		where == WEAR_WIELD2 || where == WEAR_HOLD || \
		where == WEAR_HOLD2)

#define str_dup(x) my_str_dup(x, __FILE__, __LINE__)

#define IS_DAY ((time_info.hours > 6) && (time_info.hours < 19))
#define IS_TWILIGHT (((time_info.hours > 4) && (time_info.hours < 7)) || \
                     ((time_info.hours > 16) && (time_info.hours < 19)))
#define IS_NIGHT (!IS_DAY)
#define IS_SUNLIT(r) (IS_DAY && !ROOM_FLAGGED(r, ROOM_DARK) && \
		     !ROOM_FLAGGED(r, ROOM_INDOORS) && \
		     !IS_TWILIGHT)
#define DECAYABLE(r) (IS_SUNLIT(r))

